2026-06-12 10:59:57 +0800  Kevin J. McCarthy  <kevin@8t8.us> (dcb917dc)

        * Update UPDATING files for 2.3.3 release.

M	UPDATING

2026-06-03 21:39:34 +0800  Kevin J. McCarthy  <kevin@8t8.us> (1386633a)

        * Fix configure --with-bundled-regex test.
        
        The documentation in autoconf says:
        
         — Macro: AC_ARG_WITH(PACKAGE, HELP-STRING, [ACTION-IF-GIVEN],
                  [ACTION-IF-NOT-GIVEN])
             If the user gave ‘configure’ the option ‘--with-PACKAGE’ or
             ‘--without-PACKAGE’, run shell commands ACTION-IF-GIVEN.  If
             neither option was given, run shell commands ACTION-IF-NOT-GIVEN.
        
        This means the third parameter is evaluatated in both cases:
        --with-bundled-regex and --without-bundled-regex.
        And thus the code was incorrectly turning mutt_cv_regex on for both
        cases, skipping the test for broken regex further below.
        
        Fix it to properly set mutt_cv_regex.  Further below, configure will
        check the built-in system regex works if the value is 'no'.

M	configure.ac

2026-06-11 11:00:45 +0800  Kevin J. McCarthy  <kevin@8t8.us> (801f3a2d)

        * Fix attachment list crash for deeply nested message types.
        
        Mutt already has checks for deeply nested messages.  However, for the
        message type, parts of the code assume body->header will be set.
        
        The current parser simply exited the recursion at a certain depth, but
        left the header set to NULL.  This caused a crash in the attachment
        list menu, but probably causes a crash elsewhere in the code too.
        
        When deeply nested, instead change the type to text/plain before
        giving up.
        
        Thanks to Acts1631 for the bug report, sample message causing the
        crash, and possible suggested fix.  This fix is different from the
        suggestion, instead fixing the parser, rather than the attachment list
        code.

M	parse.c

2026-05-08 15:02:29 +0800  Kevin J. McCarthy  <kevin@8t8.us> (048f4ae2)

        * Fix concat_path() functions to work for edge-cases too.
        
        This fixes the edge cases tested by Derek Martin.
          "foo/bar/" + "/baz"  gave: "foo/bar//baz" should be: "foo/bar/baz"
          ""         + "/baz"  gave: "//baz"        should be "/bar"
          "/"        + "/foo"  gave  "//foo"        should be "/foo"
        
        All three bugs were triggered by a leading "/" in fname.
        
        The one line strspn() fix is by Alejandro Colomar, but has also been
        applied to the lib.c version.
        
        Many thanks to Derek Martin, for noticing the edge case failures,
        creating a suite of tests, and also working on proposed patches to fix
        the problem.  Also thanks to Rene Kita for his feedback and proposed
        version.
        
        In the end, this was the simplest version that was easy to apply to
        both concat_path() functions.

M	lib.c
M	muttlib.c

2026-05-05 10:47:29 +0800  Kevin J. McCarthy  <kevin@8t8.us> (d07674ac)

        * Fix header cache get_foldername() bug.
        
        The canonifying code did not check whether the folder name was a URL
        first.  If there is a file in the cwd of that name (which is possible,
        for example, in a body cache directory), mutt will convert the URL
        into a full path.
        
        Thanks to Matthew Frost for reporting the issue in a nicely detailed
        bug report, and for helping me confirm the fix.

M	hcache.c

2026-04-26 10:49:49 +0800  Kevin J. McCarthy  <kevin@8t8.us> (31864ba9)

        * automatic post-release commit for mutt-2.3.2

M	ChangeLog
M	VERSION

2026-04-26 10:45:26 +0800  Kevin J. McCarthy  <kevin@8t8.us> (4a9c9248)

        * Update UPDATING file for 2.3.2 release.

M	UPDATING

2026-04-18 22:08:19 +0800  Kevin J. McCarthy  <kevin@8t8.us> (834c5a2e)

        * Fix IMAP auth_cram MD5 digest of secret to use memcpy().
        
        For a secret longer than MD5_BLOCK_LEN, an MD5 digest is used instead.
        However, mutt was incorrectly using strfcpy() instead of memcpy() on
        the raw binary value returned by md5_buffer in hash_passwd.  If
        hash_passwd contained an '\0' it would result in the value being
        truncated.
        
        Additionally, the strfcpy was truncating the hash_passwd by one byte
        regardless, due to passing a "size" of MD5_DIGEST_LEN when the data
        itself was length MD5_DIGEST_LEN.
        
        This likely hasn't been a reported issue because:
        1. CRAM-MD5 is not used much anymore
        2. Most people likely don't have a password length greater than 64
           bytes.
        
        Thanks to evilrabbit@tutamail.com for the security report.

M	imap/auth_cram.c

2026-04-18 22:40:46 +0800  Kevin J. McCarthy  <kevin@8t8.us> (12f54fe3)

        * Check for embedded nul in url_pct_decode().
        
        Consider %00 an invalid character in a URL.
        
        Thanks to evilrabbit@tutamail.com for the security report.
        
        Reviewed-by: Alejandro Colomar <alx@kernel.org>

M	url.c

2026-04-18 22:36:37 +0800  Kevin J. McCarthy  <kevin@8t8.us> (f547a849)

        * Fix imap_auth_gss() security level size check and buf_size type.
        
        Make sure send_token.length is 4 bytes before reading the data.
        
        Fix the buf_size type to be uint32_t instead of long.  ntohl()
        operates on, and returns, a 32 bit unsigned integer.  Most
        architectures now use a 64-bit long.
        
        I believe this only worked because in Little-Endian, the
        least-significant bits come first, so even though we were using 8
        bytes of send_token.value (4 of which were out of bounds) for the cast
        to long, only the first 4 bytes were used to truncate to the uint32_t
        that ntohl() used.  Likewise when we converted htonl() further down.
        
        Additionally, the comments indicate that mutt wasn't using buf_size in
        any case, so perhaps that also explains the lack of bug reports.
        
        Thanks to evilrabbit@tutamail.com for the security report.
        
        Reviewed-by: Alejandro Colomar <alx@kernel.org>

M	imap/auth_gss.c

2026-04-18 21:54:34 +0800  Kevin J. McCarthy  <kevin@8t8.us> (fdc04a17)

        * Fix infinite loop in gpgme data_object_to_stream().
        
        The code was not properly checking for a -1 return value in the read,
        leading to an infinite loop, and printing past the buffer value to the
        stream.
        
        Thanks to evilrabbit@tutamail.com for the security report.
        
        Reviewed-by: Alejandro Colomar <alx@kernel.org>

M	crypt-gpgme.c

2026-04-18 21:41:23 +0800  Kevin J. McCarthy  <kevin@8t8.us> (ebfa2969)

        * Fix NULL dereference in show_sig_summary().
        
        Inside show_one_sig_status(), if the error code is GPG_ERR_NO_PUBKEY,
        key is NULL.  However, show_sig_summary() doesn't check for a NULL key
        before dereferencing for the "key expired" case.
        
        Thanks to evilrabbit@tutamail.com for the security report.
        
        Thanks to Alejandro Colomar for his review and suggestion to keep the
        ternary operator.
        
        Reviewed-by: Alejandro Colomar <alx@kernel.org>

M	crypt-gpgme.c

2026-03-20 13:26:34 +0800  Kevin J. McCarthy  <kevin@8t8.us> (519d1b9b)

        * automatic post-release commit for mutt-2.3.1

M	ChangeLog
M	VERSION

2026-03-20 13:18:13 +0800  Kevin J. McCarthy  <kevin@8t8.us> (0f1f138c)

        * Update UPDATING file for 2.3.1 release.

M	UPDATING

2026-02-25 11:15:20 +0800  Kevin J. McCarthy  <kevin@8t8.us> (3a8dfafc)

        * Fix browser examine_directory() writable buffer parameter bug.
        
        Despite being "const char *", the directory "d" parameter was being
        modified inside examine_directory() if the directory no longer
        existed.  The code climbed the directory path until it found where it
        still existed, using the strchr() return value as "char *" to modify
        the "const char *" parameter.
        
        Unfortunately, it modified the buffer data directly without updating
        the dptr.  This could lead to buggy behavior, because subsequent
        buffer operations would append to the dptr, unaware that the string
        was nul terminated earlier.
        
        Thanks to Rene Kita for finding this issue and to Alejandro Colomar
        for his research into the problem.

M	browser.c

2026-02-22 12:34:22 +0800  Kevin J. McCarthy  <kevin@8t8.us> (a0083dc9)

        * Fix IMAP reconnect crash at password prompt.
        
        When waiting at a password prompt, eventually it will time out and
        call imap_keepalive().  This will end up recursively calling
        imap_check_mailbox(), because the idata has IMAP_REOPEN_ALLOW set
        during a reconnect operation.
        
        To prevent this problem, don't send keepalives on connections with a
        FATAL status.  In any case, we shouldn't be sending keepalives since
        the connection is in an unknown state.
        
        As an aside, a reconnect should be using the cached credentials in the
        Connections list when imap_conn_find() iterates through the connection
        list.  However, ticket 517 clearly shows there is a path where this is
        not happening.  I haven't figured out how yet, but this fix should be
        applied regardless.

M	imap/util.c

2026-02-14 12:20:34 +0800  Kevin J. McCarthy  <kevin@8t8.us> (025a33ad)

        * Fix another compilation error --without-wc-funcs.
        
        This was generating an error on FreeBSD:
          mbyte.c:417:5: error: redefinition of '__wcwidth'
        
        Thanks to Daniel Tameling for suggesting the undef and testing it
        fixes the build error.

M	mbyte.h

2026-01-26 12:57:05 +0800  Kevin J. McCarthy  <kevin@8t8.us> (8b10799c)

        * Fix iswblank() compilation error when configured --without-wc-funcs.
        
        The iswblank() call was added to mutt_format_string() in commit
        7074b571, more recently than all the mbyte.[ch] substitution code
        added about 25 years ago.
        
        Unfortunately, when added, it wasn't included in the HAVE_WC_FUNCS
        tests, and a replacement was not created in mbyte.c for when mutt is
        configured with --without-wc-funcs.  This led to a compilation error
        in that (apparently rarely used) configuration, because wctype.h is
        not included in that case.
        
        Honestly the code is a little bit confusing, but I've preserved the
        existing conventions for this stable branch fix.

M	configure.ac
M	curs_lib.c
M	mbyte.c
M	mbyte.h

2026-01-25 11:01:42 +0800  Kevin J. McCarthy  <kevin@8t8.us> (50e3b1f3)

        * automatic post-release commit for mutt-2.3.0

M	ChangeLog
M	VERSION
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2026-01-25 10:55:27 +0800  Kevin J. McCarthy  <kevin@8t8.us> (6d9cf2fb)

        * Update UPDATING file for 2.3.0 release.

M	UPDATING

2026-01-24 13:54:37 +0100  Rene Kita  <mail@rkta.de> (8fa41ae2)

        * Make clear issues are not for feature requests
        
        As discussed in [0] feature requests should be discussed on the mailing
        list before being added to the issue tracker. Add some notes to make
        this more clear to the user.
        
        As discussed in [1] it makes more sense to send feature requests and bug
        reports to the dev ML. Update the manual to reflect that. Change wording
        to keep the list entries under 80 chars.
        
        While at it, copy a NOTE from the web site about the need to be
        subscribed in order to post to a ML.
        
        [0]: https://marc.info/?l=mutt-dev&m=176822608723403&w=2
        [1]: https://marc.info/?l=mutt-dev&m=176925724408475&w=2

M	doc/manual.xml.head
M	doc/mutt.man

2026-01-18 13:40:11 +0800  Kevin J. McCarthy  <kevin@8t8.us> (301067e4)

        * Add README.PACKAGERS file.
        
        This notes potential distribution issues of Mutt with
        OpenSSL (pre-3.0) and LibreSSL.

M	Makefile.am
A	README.PACKAGERS

2026-01-12 09:36:23 +0100  Grzegorz Szymaszek  <gszymaszek@short.pl> (5854039b)

        * Update the Polish translation for Mutt 2.3.0

M	po/pl.po

2026-01-12 10:06:00 +0800  Ivan Vilata i Balaguer  <ivan@selidor.net> (0224e9fb)

        * Update Catalan translation.

M	po/ca.po

2026-01-11 20:35:40 +0800  Kevin McCarthy  <kevin@8t8.us> (12f17ce7)

        * Add POP3 non-base64 workaround to gsasl code too.
        
        As described in the previous commit, some servers send a non-base64
        encoded challenge in the initial response.
        
        Ignore the base64 decode failure for the first challenge, to improve
        compatibility in the gsasl authentication code too.
        
        This is modeled after the same gsasl fix in smtp.c.

M	pop_auth.c

2026-01-11 20:09:49 +0800  Yao Zi  <me@ziyao.cc> (0746ae48)

        * pop_auth: Don't bail out when failing to decode the first SASL challenge
        
        RFC 5034 requires data in SASL server challenges to be encoded in base64
        when integrating with POP3,
        
        > A server challenge is sent as a line consisting of a "+" character,
        > followed by a single space and a string encoded using Base64, as
        > specified in Section 4 of [RFC4648].  This line MUST NOT contain any
        > text other than the BASE64-encoded challenge.
        
        However, some mail providers put raw text instead of base64-encoded
        data in the challenge. Mutt always bails out when encountering them,
        
        [2026-01-08 05:02:31] Authenticating (SASL)...
        [2026-01-08 05:02:31] 6> AUTH PLAIN
        [2026-01-08 05:02:31] 6< + Ready for additional text
        [2026-01-08 05:02:31] pop_auth_sasl: error base64-decoding server response.
        [2026-01-08 05:02:31] 6> *
        [2026-01-08 05:02:32] 6< -ERR Au
        [2026-01-08 05:02:32] SASL authentication failed.
        
        while some other POP3 clients, e.g. cURL, accept them,
        
        > AUTH PLAIN
        < + Ready for additional text
        > dGVzdHRlc3R0ZXN0Cg==
        < +OK
        > LIST
        < +OK 223 messages (1256448 octets)
        
        which might work since some SASL mechanisms, e.g. PLAIN, don't care
        about the challenge responsed by server.
        
        Let's stop bailing out early when failing to decode the first SASL
        challenge as base64. Instead, print a debug message and then try to
        continue the authentication process for better compatibility with these
        quirky service providers. This takes a similar workaround to
        b363b602e179 ("Add SMTP gsasl auth workaround for broken Microsoft
        servers.")
        
        Link: https://datatracker.ietf.org/doc/html/rfc5034
        Signed-off-by: Yao Zi <me@ziyao.cc>

M	pop_auth.c

2026-01-10 10:59:31 +0100  Petr Písař  <petr.pisar@atlas.cz> (11bf4bbb)

        * Update Czech translation for mutt 2.2.16

M	po/cs.po

2026-01-10 07:26:11 +0800  lilydjwg  <lilydjwg@gmail.com> (8ddd7be5)

        * Update zh_CN.po translations.

M	po/zh_CN.po

2026-01-10 07:17:51 +0800  Emir SARI  <emir_sari@icloud.com> (9d11ccac)

        * Update Turkish translations

M	po/tr.po

2026-01-09 18:27:49 +0800  Kevin McCarthy  <kevin@8t8.us> (0908474f)

        * Fix sr.ht freebsd build system deps.
        
        db5 is not needed.
        
        The latest version running there appears to need gettext-tools
        installed in order to run autoreconf.

M	.builds/freebsd.yml

2026-01-09 21:15:24 +0800  Vsevolod Volkov  <mutt@vvv.kyiv.ua> (5ee1275b)

        * Updated Russian translation.

M	po/ru.po

2026-01-09 21:13:07 +0800  Vsevolod Volkov  <mutt@vvv.kyiv.ua> (f0c48b91)

        * Updated Ukrainian translation.

M	po/uk.po

2026-01-09 17:59:20 +0800  Helge Kreutzmann  <debian@helgefjell.de> (4b79ae7a)

        * Update de.po.

M	po/de.po

2026-01-09 15:28:17 +0800  Daniel Nylander  <po@danielnylander.se> (f3733d23)

        * Updated Swedish translation.

M	po/sv.po

2026-01-09 12:45:29 +0800  Kevin McCarthy  <kevin@8t8.us> (f0092d23)

        * Update copyrights to 2026.

M	COPYRIGHT
M	doc/manual.xml.head
M	doc/mutt.man
M	main.c
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2026-01-07 16:38:40 +0100  Vincent Lefevre  <vincent@vinc17.net> (33c58fb2)

        * Updated French translation.

M	po/fr.po

2025-12-14 14:26:41 +0800  Daniel Nylander  <po@danielnylander.se> (074eb728)

        * Updated Swedish translation.

M	po/sv.po

2025-12-11 15:24:08 +0000  Yao Zi via Mutt-dev  <mutt-dev@mutt.org> (c8425a77)

        * Display the address when failing to add an SMTP recipient
        
        Some providers are picky about recipient addresses, they may refuse to
        send mails to an address to which mails have previously been rejected
        for "550 5.1.1 Bad destination mailbox address".
        
        Sending an RCPT TO command with such an address will fail with these
        providers, and result in a non-standard enhanced status code. In this
        case, mutt only emits an error like "SMTP session failed: 550 ..."
        without mentioning the address associated with the failed command, which
        doesn't help much if there are many recipients.
        
        This patch adds extra error log about the recipient address when an RCPT
        TO command fails. Users then could easily distinguish the problematic
        recipient, and remove it or contact the provider for support.
        
        Signed-off-by: Yao Zi <me@ziyao.cc>

M	smtp.c

2025-11-22 11:07:18 +0800  Kevin McCarthy  <kevin@8t8.us> (597b2970)

        * Merge branch 'stable'

2025-11-22 10:59:52 +0800  Kevin McCarthy  <kevin@8t8.us> (7b98015d)

        * automatic post-release commit for mutt-2.2.16

M	ChangeLog
M	VERSION

2025-11-09 12:52:41 +0800  Kevin McCarthy  <kevin@8t8.us> (58e9dca4)

        * Merge branch 'stable'

2025-10-03 13:17:07 +0200  Vincent Lefevre  <vincent@vinc17.net> (ba36b184)

        * Updated French translation.

M	po/fr.po

2025-10-02 13:44:26 +0800  Kevin McCarthy  <kevin@8t8.us> (4bdfed9f)

        * Merge branch 'stable'

2025-09-23 14:01:32 +0800  Kevin McCarthy  <kevin@8t8.us> (a5e1f207)

        * Merge branch 'stable'

2025-08-26 19:07:40 +0800  Kevin McCarthy  <kevin@8t8.us> (0742c5d5)

        * Merge branch 'stable'

2025-08-26 10:44:13 +0800  Kevin McCarthy  <kevin@8t8.us> (3728efe6)

        * Merge branch 'stable'

2025-05-03 19:25:34 +0800  Kevin McCarthy  <kevin@8t8.us> (5fd040e3)

        * Merge branch 'stable'

2025-05-03 19:08:26 +0800  Kevin McCarthy  <kevin@8t8.us> (fb494674)

        * Merge branch 'stable'

2025-04-26 11:44:47 +0800  Kevin McCarthy  <kevin@8t8.us> (b2a0ef71)

        * Merge branch 'stable'

2025-03-23 13:43:26 +0800  Kevin McCarthy  <kevin@8t8.us> (2efcabc4)

        * Add $imap_reconnect_tries and $imap_reconnect_sleep.
        
        Try to make imap_reconnect() work a little harder by introducing
        options to control the number of reconnect attempts, and how long to
        sleep between each attempt.

M	globals.h
M	imap/imap.c
M	imap/message.c
M	init.h
M	mutt.h

2025-03-15 11:29:15 +0800  Kevin McCarthy  <kevin@8t8.us> (6fef346a)

        * Merge branch 'stable'

2025-02-20 12:23:41 +0800  Kevin McCarthy  <kevin@8t8.us> (5c8e775f)

        * Merge branch 'stable'

2025-02-08 11:23:30 +0800  Kevin McCarthy  <kevin@8t8.us> (bb2064ae)

        * Merge branch 'stable'

2025-02-06 11:43:35 +0800  Kevin McCarthy  <kevin@8t8.us> (22e0caf0)

        * Merge branch 'stable'

2025-01-21 10:13:39 -0500  Daniel Kahn Gillmor  <dkg@fifthhorseman.net> (caa8e5e7)

        * fix spelling

M	lib.c

2024-12-02 11:38:38 +0800  Kevin McCarthy  <kevin@8t8.us> (423f5002)

        * Merge branch 'stable'

2024-11-04 11:15:11 +0800  Kevin McCarthy  <kevin@8t8.us> (f87ab401)

        * Merge branch 'stable'

2024-06-20 11:29:12 -0700  William Yardley  <wyardley@users.noreply.github.com> (9dc98409)

        * Add note about remote mailboxes to `$spoolfile` docs

M	init.h

2024-04-20 11:46:40 +0800  Kevin McCarthy  <kevin@8t8.us> (1f3da810)

        * Merge branch 'stable'

2024-04-13 13:47:34 +0800  Kevin McCarthy  <kevin@8t8.us> (762590bb)

        * Don't untag after edit-label.
        
        Mutt is pretty consistent about NOT untagging automatically after an
        operation.  The only place where it does so is when deleting, but even
        this is configurable via $delete_untag.

M	headers.c

2024-04-13 18:31:59 +0800  Kevin McCarthy  <kevin@8t8.us> (680042df)

        * Merge branch 'stable'

2024-03-09 18:35:21 +0800  Kevin McCarthy  <kevin@8t8.us> (3c98bfa8)

        * Merge branch 'stable'

2024-03-09 18:16:00 +0800  Kevin McCarthy  <kevin@8t8.us> (e2d23514)

        * Merge branch 'stable'

2023-12-06 21:54:19 +0000  Norman Wood  <normw013@fastmail.fm> (354c5b11)

        * Use readline to overcome macOS input() restrictions
        
        Under macOS, for a python script launched in a terminal, input() accepts only 1024 characters.  In the authcode flow, the authorization code that is read by the call to input() around line 200 is longer than this and will be truncated, causing token retrieval to fail.  Importing readline resolves this, allowing input() to accept a longer character string.
M	contrib/mutt_oauth2.py

2023-12-07 19:39:06 +0100  Florian Weimer  <fweimer@redhat.com> (563c5f60)

        * configure.ac: Fix ICONV_NONTRANS probe
        
        The standard iconv function uses char ** even for its input argument.
        With a const char ** argument, ICONV_NONTRANS is incorrectly set to 1
        if the compiler produces an error for such incompatible pointer types.
        
        Although as far as I can see, the only thing that accomplishes is
        disabling an assert, so it probably does not matter much.

M	configure.ac

2023-09-09 14:55:00 +0800  Kevin McCarthy  <kevin@8t8.us> (757ca3b3)

        * Merge branch 'stable'

2023-08-23 15:42:19 +0800  Kevin McCarthy  <kevin@8t8.us> (b85b0dbf)

        * Merge branch 'stable'

2023-08-18 11:25:06 +0800  Kevin McCarthy  <kevin@8t8.us> (45bfedaf)

        * Merge branch 'stable'

2023-08-15 13:15:49 +0800  Kevin McCarthy  <kevin@8t8.us> (1480121f)

        * Merge branch 'stable'

2023-07-18 19:03:05 +0000  Aram Hamo  <contact@aramhamo.me> (bf988762)

        * Update smime_keys.pl accepting old/insecure smime certificates

M	smime_keys.pl

2023-06-05 18:55:17 +0800  Kevin McCarthy  <kevin@8t8.us> (b470a9ad)

        * Merge branch 'stable'

2023-04-15 12:46:04 -0700  Kevin McCarthy  <kevin@8t8.us> (5347d1c5)

        * Merge branch 'stable'

2023-03-25 13:20:30 -0700  Kevin McCarthy  <kevin@8t8.us> (d2ed5d18)

        * Merge branch 'stable'

2023-03-13 18:27:45 -0700  Kevin McCarthy  <kevin@8t8.us> (caea3018)

        * Merge branch 'stable'

2023-03-12 19:54:44 -0700  Kevin McCarthy  <kevin@8t8.us> (3263c953)

        * Merge branch 'stable'

2023-03-12 19:41:08 -0700  Kevin McCarthy  <kevin@8t8.us> (277a12d1)

        * Merge branch 'stable'

2023-03-06 15:04:59 -0800  Kevin McCarthy  <kevin@8t8.us> (cf88e6d8)

        * Merge branch 'stable'

2022-12-20 09:16:42 -0800  Kevin McCarthy  <kevin@8t8.us> (90236f5a)

        * Merge branch 'stable'

2022-12-12 15:06:34 -0800  Kevin McCarthy  <kevin@8t8.us> (9917c0ea)

        * Merge branch 'stable'

2022-12-07 13:09:30 -0800  Kevin McCarthy  <kevin@8t8.us> (db429b21)

        * Merge branch 'stable'

2022-07-10 14:57:11 +0200  Matthias Andree  <matthias.andree@gmx.de> (af2080d3)

        * mutt_ssl: refactor Implicit TLS and STARTTLS code
        
        Signed-off-by: Matthias Andree <matthias.andree@gmx.de>

M	mutt_ssl.c

2022-03-11 09:12:07 -0800  Kevin McCarthy  <kevin@8t8.us> (2f077d72)

        * Change the initial browser file to to cwd.
        
        If the working_dir was empty, it would be set to $folder, which isn't
        helpful if it's a IMAP directory.  Instead set it to cwd.

M	browser.c

2022-03-04 14:27:53 -0800  Kevin McCarthy  <kevin@8t8.us> (946bf5b2)

        * Divide browser "LastDir" into separate file and mailbox locations.
        
        Previously there was only one "last" location stored, shared between
        file and mailbox operations when the MUTT_SEL_FOLDER flags was passed.
        
        This meant adding attachments to a composed message would start in the
        "mailbox" place (which could be an IMAP folder).  Then, a subsequent
        change-folder would start in the attachment directory browsed to.
        
        Create two different flags, MUTT_SEL_MAILBOX and MUTT_SEL_FILE and use
        those to use the corresponding "last" variable.
        
        Change the browser function to use a temporary buffer, working_dir,
        instead of directly manipulating LastDir.
        
        Change callers to use the appropriate flag based on their usage.

M	browser.c
M	curs_lib.c
M	curs_main.c
M	enter.c
M	main.c
M	mutt.h

2022-12-03 17:55:36 -0800  Matthew Sotoudeh  <matthew@masot.net> (185346ad)

        * Add socket send/receive timeout options
        
        On an unreliable connection (e.g., laptop put to sleep and changing wifi
        networks) I've had mutt fairly regularly become stuck in SSL_read and
        have to be killed.
        
        Per some of the comments on
        https://stackoverflow.com/questions/46517875/ssl-read-blocks-indefinitely
        adding a timeout to the socket should carry over to the SSL_read call.
        
        Using this socket_receive_timeout option appears to resolve the issue
        for me.

M	globals.h
M	init.h
M	mutt_socket.c

2022-11-21 12:48:46 -0800  Kevin McCarthy  <kevin@8t8.us> (c79959e1)

        * Merge branch 'stable'

2022-11-19 12:43:20 -0800  Kevin McCarthy  <kevin@8t8.us> (67517850)

        * Merge branch 'stable'

2022-11-12 13:02:50 -0800  Kevin McCarthy  <kevin@8t8.us> (f65467b0)

        * Merge branch 'stable'

2022-11-07 14:48:57 -0800  Kevin McCarthy  <kevin@8t8.us> (040ba998)

        * Merge branch 'stable'

2022-11-06 08:51:26 -0800  Kevin McCarthy  <kevin@8t8.us> (c11015d0)

        * Merge branch 'stable'

2022-11-05 13:25:15 -0700  Kevin McCarthy  <kevin@8t8.us> (0d2fb7c9)

        * Merge branch 'stable'

2022-11-04 13:31:45 -0700  Kevin McCarthy  <kevin@8t8.us> (39972738)

        * Merge branch 'stable'

2022-11-03 14:02:36 -0700  Kevin McCarthy  <kevin@8t8.us> (9d5489a5)

        * Merge branch 'stable'

2022-11-03 13:16:48 -0700  Kevin McCarthy  <kevin@8t8.us> (4ee5fcc4)

        * Merge branch 'stable'

2022-10-21 21:51:52 +0200  Vincent Lefevre  <vincent@vinc17.net> (a318ca5a)

        * Updated French translation.

M	po/fr.po

2022-10-14 12:58:38 -0700  Kevin McCarthy  <kevin@8t8.us> (3c48d727)

        * Merge branch 'stable'

2022-10-09 19:31:41 -0700  Kevin McCarthy  <kevin@8t8.us> (8681885b)

        * Merge branch 'stable'

2022-10-08 13:51:04 -0700  Kevin McCarthy  <kevin@8t8.us> (590ec8e9)

        * Merge branch 'stable'

2022-10-08 12:45:54 -0700  Kevin McCarthy  <kevin@8t8.us> (f005b034)

        * Merge branch 'stable'

2022-09-02 13:12:10 +0200  Vincent Lefevre  <vincent@vinc17.net> (a90f69b9)

        * Updated French translation.

M	po/fr.po

2022-08-30 18:20:42 -0700  Kevin McCarthy  <kevin@8t8.us> (578f3ae1)

        * Merge branch 'stable'

2022-08-25 13:32:12 -0700  Kevin McCarthy  <kevin@8t8.us> (c06f789b)

        * Merge branch 'stable'

2022-08-22 09:28:03 -0700  Kevin McCarthy  <kevin@8t8.us> (d84696f2)

        * Merge branch 'stable'

2022-08-07 10:28:10 -0700  Kevin McCarthy  <kevin@8t8.us> (1fccbbf8)

        * Merge branch 'stable'

2022-08-05 12:36:49 -0700  Kevin McCarthy  <kevin@8t8.us> (537cc1e4)

        * Merge branch 'stable'

2022-08-05 10:25:40 -0700  Kevin McCarthy  <kevin@8t8.us> (01a6e037)

        * Merge branch 'stable'

2022-07-31 11:11:16 -0700  Kevin McCarthy  <kevin@8t8.us> (76e93dd3)

        * Merge branch 'stable'

2022-07-28 13:05:26 -0700  Kevin McCarthy  <kevin@8t8.us> (05af53f1)

        * Merge branch 'stable'

2022-07-28 12:59:26 -0700  Kevin McCarthy  <kevin@8t8.us> (fa154e55)

        * Merge branch 'stable'

2022-07-06 14:46:15 -0700  Kevin McCarthy  <kevin@8t8.us> (7d9df177)

        * Merge branch 'stable'

2022-06-11 13:11:57 -0700  Kevin McCarthy  <kevin@8t8.us> (25743053)

        * Merge branch 'stable'

2022-06-05 12:27:16 -0700  Kevin McCarthy  <kevin@8t8.us> (74ce6f5a)

        * Merge branch 'stable'

2022-05-28 11:09:59 -0700  Kevin McCarthy  <kevin@8t8.us> (f582b526)

        * Merge branch 'stable'

2022-05-27 14:18:02 -0700  Kevin McCarthy  <kevin@8t8.us> (0a36fe5f)

        * Merge branch 'stable'

2022-05-25 10:02:13 -0700  Kevin McCarthy  <kevin@8t8.us> (e1058b2a)

        * Merge branch 'stable'

2022-05-21 09:35:27 -0700  Kevin McCarthy  <kevin@8t8.us> (1066be97)

        * Merge branch 'stable'

2022-05-20 08:51:45 -0700  Kevin McCarthy  <kevin@8t8.us> (188ece9a)

        * Merge branch 'stable'

2022-05-19 12:40:52 -0700  Kevin McCarthy  <kevin@8t8.us> (caf1d53e)

        * Merge branch 'stable'

2022-05-16 10:34:13 -0700  Kevin McCarthy  <kevin@8t8.us> (5e31bc48)

        * Merge branch 'stable'

2022-05-14 12:28:46 -0700  Kevin McCarthy  <kevin@8t8.us> (5cc97c19)

        * Merge branch 'stable'

2022-05-08 11:07:46 -0700  Kevin McCarthy  <kevin@8t8.us> (d448c911)

        * Merge branch 'stable'

2022-04-30 12:52:54 -0700  Kevin McCarthy  <kevin@8t8.us> (448b2574)

        * Merge branch 'stable'

2022-04-21 14:37:45 -0700  Kevin McCarthy  <kevin@8t8.us> (377f8c16)

        * Merge branch 'stable'

2022-04-12 12:34:29 -0700  Kevin McCarthy  <kevin@8t8.us> (6e7437c4)

        * Merge branch 'stable'

2022-03-25 13:23:16 -0700  Kevin McCarthy  <kevin@8t8.us> (f082dd14)

        * Merge branch 'stable'

2022-03-05 11:22:01 -0800  Kevin McCarthy  <kevin@8t8.us> (1ba319cf)

        * Merge branch 'stable'

2022-03-05 09:34:21 -0800  Kevin McCarthy  <kevin@8t8.us> (d1f297b5)

        * Merge branch 'stable'

2022-03-05 09:23:41 -0800  Kevin McCarthy  <kevin@8t8.us> (4797afee)

        * Merge branch 'stable'

2022-02-21 15:36:58 -0800  Kevin McCarthy  <kevin@8t8.us> (14187faf)

        * Merge branch 'stable'

2022-02-19 10:59:23 -0800  Kevin McCarthy  <kevin@8t8.us> (a102f762)

        * Merge branch 'stable'

2022-02-19 09:08:04 -0800  Kevin McCarthy  <kevin@8t8.us> (657210ed)

        * Merge branch 'stable'

2022-02-14 13:23:16 -0800  Kevin McCarthy  <kevin@8t8.us> (bfa075a3)

        * Merge branch 'stable'

2021-04-08 22:01:19 +0200  Paweł Zuzelski  <pawelz@execve.pl> (955d281f)

        * Add missing period in a comment.
        
        That comment was a bit confusing without the punctuation.

M	hook.c

2025-11-22 10:55:45 +0800  Kevin McCarthy  <kevin@8t8.us> (8b81a856)

        * Update UPDATING file for 2.2.16 release.

M	UPDATING

2025-11-08 21:28:50 +1000  Jonathan Matthew  <jmatthew@openbsd.org> (49aad685)

        * mutt_ssl: only allocate exdata indices once
        
        We don't need a new index for each connection, so allocating a new
        one each time is at best a memory leak.

M	mutt_ssl.c

2025-10-02 13:34:15 +0800  Kevin McCarthy  <kevin@8t8.us> (2b349c5e)

        * automatic post-release commit for mutt-2.2.15

M	ChangeLog
M	VERSION

2025-10-02 13:18:22 +0800  Kevin McCarthy  <kevin@8t8.us> (b2db4087)

        * Update UPDATING file for 2.2.15 release.

M	UPDATING

2025-09-20 10:41:24 +0800  Kevin McCarthy  <kevin@8t8.us> (b363b602)

        * Add SMTP gsasl auth workaround for broken Microsoft servers.
        
        It appears some Microsoft servers append a non-BASE64 encoded response
        to what should be an empty challenge to the initial AUTH sent by the
        client.
        
        It's not RFC compliant, so gsasl rightly rejects the response.
        However, this doesn't help poor mutt users to authenticate.
        
        To work around this, check the response for the initial reply only,
        and if it's not BASE64 decodable, just drop the response.  It is
        mostly likely meaningless, and would have resulted in the AUTH failing
        regardless.
        
        Thanks to Frank Reker for the bug report and proposed patch, which
        this is based upon.

M	smtp.c

2025-08-26 13:30:32 +0800  Kevin McCarthy  <kevin@8t8.us> (b4771a9d)

        * Add documentation about <buffy-cycle> and its keybinding.
        
        Add a subsection to the "Editing Input Fields" section of the manual,
        explaining about the <buffy-cycle> function, and when it is used.
        
        Also, add an explanation for a previously undocumented behavior: in
        other filename and mailbox prompts, typing the <buffy-cycle> key
        binding falls back and invokes the <complete> function.
        
        Mention the <quote-char> function, as a useful way to enter a literal
        space, instead of invoking <buffy-cycle> or <complete> when typing
        space.

M	doc/manual.xml.head

2025-08-26 10:32:22 +0800  Kevin McCarthy  <kevin@8t8.us> (467e919f)

        * Fix isdigit() argument to unsigned char in pager is_ansi() call.
        
        In a refactor, in commit 0ac6b609cd9e4588f00221b5c66e0fd5f584da88 a
        few years ago, I inadvertantly changed the type of the is_ansi()
        parameter, and thus changed the isdigit() argument to char.
        
        This is not allowed, and needs to be cast to (unsigned char) for
        correct behavior on some platforms.
        
        Thanks to Thomas Klausner (@_wiz_) for pointing out the bug and for
        the patch.

M	pager.c

2025-05-03 19:24:57 +0800  Kevin McCarthy  <kevin@8t8.us> (47ed1d21)

        * Fix .builds files to reference new srht repository.

M	.builds/alpine.yml
M	.builds/debian.yml
M	.builds/freebsd.yml

2025-05-03 19:06:44 +0800  Kevin McCarthy  <kevin@8t8.us> (42d9a016)

        * Improve the my_hdr documentation.
        
        Try to make it clearer that it can only be used for custom header
        fields and a certain set of standard header fields.

M	doc/manual.xml.head

2025-04-26 11:42:21 +0800  Kevin McCarthy  <kevin@8t8.us> (61a66d03)

        * Remove deprecated AC_PROG_CC_C99 call.
        
        The test and setting of $ac_cv_prog_cc_c99 is done by AC_PROG_CC now.

M	configure.ac

2025-03-13 15:28:55 +0800  Kevin McCarthy  <kevin@8t8.us> (dacd6a50)

        * Fix interleaved search/limit for IMAP mailboxes.
        
        mutt_search_command() and mutt_pattern_func() both invoke
        imap_search() for IMAP mailboxes.  Additionally, mutt_search_command()
        uses the header->searched flag to cache search results for faster
        repeated matching.
        
        Interleaving a search, followed by a limit, followed by another search
        (with the exact same pattern) did not invalidate the previous search.
        The limit imap_search() cleared all the match flags, and set them to
        the results of the limit imap_search().  The second search for the
        same pattern tried to use the matched flag for headers with cached
        results, resulting in incorrect search results.
        
        Many thanks to Mikhail (@MikZyth) for the very detailed bug report,
        allowing me to easily track down the bug.

M	imap/imap.c

2025-02-20 10:58:56 +0800  Kevin McCarthy  <kevin@8t8.us> (516568dc)

        * automatic post-release commit for mutt-2.2.14

M	ChangeLog
M	VERSION

2025-02-20 10:20:51 +0800  Kevin McCarthy  <kevin@8t8.us> (59908c2b)

        * Update UPDATING file for 2.2.14 release.

M	UPDATING

2025-02-08 11:20:38 +0800  Kevin McCarthy  <kevin@8t8.us> (aa1bc169)

        * Update copyrights to 2025.

M	COPYRIGHT
M	doc/manual.xml.head
M	doc/mutt.man
M	main.c
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2025-02-05 18:09:37 +0800  Kevin McCarthy  <kevin@8t8.us> (0ac64bf3)

        * Fix NULL pointer dereference when calling imap_logout_all().
        
        When idata->status is set to IMAP_FATAL, it signals the connection is
        in an unusable state that can't be resolved.  While doing cleanup,
        imap_close_mailbox() will leave the idata->state unchanged, and will
        set idata->ctx to NULL.
        
        So this could result in a situation where
          idata->status == IMAP_FATAL
          idata->state == IMAP_SELECTED
          idata->ctx == NULL.
        
        Normally when idata->state == IMAP_SELECTED (or higher), Mutt assumes
        a mailbox is selected and the ctx should be set to the open mailbox
        CONTEXT.  However, when the status is IMAP_FATAL, mutt aborts trying
        to do anything with that connection.  So there is no issue.
        
        When exiting mutt, imap_logout_all() is called, which loops through
        any unclosed connections and calls imap_logout() for each.
        Unfortunately, imap_logout() was overwriting idata->status to IMAP_BYE
        without checking if it was previously set to IMAP_FATAL, and then
        sending a "LOGOUT" commmand.
        
        This could result in
          idata->status == IMAP_BYE
          idata->state == IMAP_SELECTED
          idata->ctx == NULL
        in which case the IMAP code assumes a ctx will be present, because status
        is no longer set to IMAP_FATAL.
        
        This commit checks for an existing IMAP_FATAL status, and skips
        trying to reset the status and send "LOGOUT" in that case.
        
        Many thanks to Roberto Ricci for reporting the bug along with a stack
        trace, and working with me as I slowly found the problem.

M	imap/imap.c

2024-11-29 11:40:05 +0800  Kevin McCarthy  <kevin@8t8.us> (cba1fc27)

        * Remove "." from MimeSpecials (RFC2045 tspecials).
        
        RFC2045 declares tspecials to not include a period.  So encoding it
        inside 2231 parameter values, or adding double quotes to MIME
        parameter values (such as in Content-Type and Content-Disposition)
        because of the presence of a period, while not illegal, is
        unnecessary.
        
        Ticket 491 reported a case where some Android clients were not
        decoding the "." in an attachment filename extension for some unknown
        reason.  While this is clearly a bug in the Android client, it's also
        true that the period need not have been encoded in the first place.
        
        However, "." couldn't simply be removed from MIMESpecials, because it
        was also used for RFC2047 encoding.  RFC2047 encoded-words are used in
        non-MIME headers, and cannot be double quoted.
        
        Create a third "specials" list, RFC2047Specials, adding back in the
        ".", to keep RFC2047 encoding the same as it was.  Add a comment as to
        why it exists, to prevent someone from making the unfortunate mistake
        of thinking it can just be changed back to use MIMESpecials.
        
        Thanks to Peter Seiderer for reporting the issue and suggesting a fix,
        which this patch is based upon.

M	rfc2047.c
M	sendlib.c

2024-10-29 13:15:12 +0800  Kevin McCarthy  <kevin@8t8.us> (a5bd9821)

        * Fix configure.ac AM_ICONV result checking.
        
        --disable-iconv seeds the cache value variable, $am_cv_func_iconv, to
        "no" to skip the test and disable iconv.
        
        However, the result of an existing and *working* AM_ICONV test is
        stored in $am_func_iconv.  The call to AC_DEFINE(HAVE_ICONV) depends
        on that variable.
        
        Mutt was improperly checking $am_cv_func_iconv below.
        
        In the event of an existing but broken iconv, this would result in
        HAVE_ICONV being undefined, but mutt_idna.o being added to
        MUTT_LIB_OBJECTS.  This would cause both the stub functions in
        mutt_idna.h and the full functions in mutt_idna.c to be defined,
        giving a compilation error.
        
        Thanks to @juanitotc for the bug report and helping to test the fix.

M	configure.ac

2024-04-19 22:30:54 +0200  Alejandro Colomar  <alx@kernel.org> (0af8a6fc)

        * crypt-gpgme.c: Fix NULL dereference
        
        Fixes: 1afaa74a19ee ("gpgme integration.  See documentation for $crypt_use_gpgme, and http://www.gnupg.org/aegypten2/.")

M	crypt-gpgme.c

2024-04-13 13:22:11 +0800  Kevin McCarthy  <kevin@8t8.us> (0d75d71a)

        * Add $smime_pkcs7_default_smime_type config option.
        
        This works around Outlook sending application/pkcs7-mime ".p7m" parts
        without a smime-type parameter.
        
        Mutt previously hardcoded an assumption that these were SignedData to
        work around an old Outlook book.  However Outlook now appears to also
        send EnvelopedData in this form.

M	contrib/smime.rc
M	crypt.c
M	globals.h
M	init.h

2024-03-09 18:29:03 +0800  Kevin McCarthy  <kevin@8t8.us> (00d56288)

        * automatic post-release commit for mutt-2.2.13

M	ChangeLog
M	VERSION

2024-03-09 18:24:58 +0800  Kevin McCarthy  <kevin@8t8.us> (ceecc40b)

        * Update UPDATING file for 2.2.13 release.

M	UPDATING

2024-03-09 18:01:11 +0800  Kevin McCarthy  <kevin@8t8.us> (9b967f07)

        * Fix smtp client to respect $use_envelope_from option.
        
        The code was only looking to see if $envelope_from_address had a
        value, not if $use_envelope_from was set.
        
        Add extra safety checks to make sure the mailbox value isn't NULL.

M	smtp.c

2024-03-09 17:54:34 +0800  Kevin McCarthy  <kevin@8t8.us> (039cc521)

        * Fix smtp client $envelope_from_address possible dangling pointer.
        
        If the account-hook invoked by mutt_conn_find() modifies
        $envelope_from_address, envfrom could point no longer point to the
        address.
        
        Move the mutt_conn_find() before the code that determines the envelope
        from address.

M	smtp.c

2023-09-09 14:45:24 +0800  Kevin McCarthy  <kevin@8t8.us> (0a81a2a7)

        * automatic post-release commit for mutt-2.2.12

M	ChangeLog
M	VERSION

2023-09-09 14:42:14 +0800  Kevin McCarthy  <kevin@8t8.us> (6a155b49)

        * Update UPDATING file for 2.2.12 release.

M	UPDATING

2023-09-03 14:11:48 +0800  Kevin McCarthy  <kevin@8t8.us> (a4752eb0)

        * Fix write_one_header() illegal header check.
        
        This is another crash caused by the rfc2047 decoding bug fixed in the
        second prior commit.
        
        In this case, an empty header line followed by a header line starting
        with ":", would result in t==end.
        
        The mutt_substrdup() further below would go very badly at that point,
        with t >= end+1.  This could result in either a memcpy onto NULL or a
        huge malloc call.
        
        Thanks to Chenyuan Mi (@morningbread) for giving a working example
        draft message of the rfc2047 decoding flaw.  This allowed me, with
        further testing, to discover this additional crash bug.

M	sendlib.c

2023-09-04 12:50:07 +0800  Kevin McCarthy  <kevin@8t8.us> (4cc3128a)

        * Check for NULL userhdrs.
        
        When composing an email, miscellaneous extra headers are stored in a
        userhdrs list.  Mutt first checks to ensure each header contains at
        least a colon character, passes the entire userhdr field (name, colon,
        and body) to the rfc2047 decoder, and safe_strdup()'s the result on
        the userhdrs list.  An empty result would from the decode would result
        in a NULL headers being added to list.
        
        The previous commit removed the possibility of the decoded header
        field being empty, but it's prudent to add a check to the strchr
        calls, in case there is another unexpected bug resulting in one.
        
        Thanks to Chenyuan Mi (@morningbread) for discovering the two strchr
        crashes, giving a working example draft message, and providing the
        stack traces for the two NULL derefences.

M	sendlib.c

2023-09-03 12:22:01 +0800  Kevin McCarthy  <kevin@8t8.us> (452ee330)

        * Fix rfc2047 base64 decoding to abort on illegal characters.
        
        For some reason, the rfc2047 base64 decoder ignored illegal
        characters, instead of aborting.  This seems innocuous, but in fact
        leads to at least three crash-bugs elsewhere in Mutt.
        
        These stem from Mutt, in some cases, passing an entire header
        field (name, colon, and body) to the rfc2047 decoder.  (It is
        technically incorrect to do so, by the way, but is beyond scope for
        these fixes in stable).  Mutt then assumes the result can't be empty
        because of a previous check that the header contains at least a colon.
        
        This commit takes care of the source of the crashes, by aborting the
        rfc2047 decode.  The following two commits add protective fixes to the
        specific crash points.
        
        Thanks to Chenyuan Mi (@morningbread) for discovering the strchr
        crashes, giving a working example draft message, and providing the
        stack traces for the two NULL derefences.

M	rfc2047.c

2023-08-23 15:40:19 +0800  Kevin McCarthy  <kevin@8t8.us> (7eb9c18f)

        * Add a documentation note that aliases are case insensitive.
        
        It's very old behavior, but doesn't seem to be documented anywhere.
        
        Thanks to Charles for pointing that out.

M	doc/manual.xml.head

2023-08-18 11:17:23 +0800  Kevin McCarthy  <kevin@8t8.us> (6b538297)

        * automatic post-release commit for mutt-2.2.11

M	ChangeLog
M	VERSION

2023-08-18 11:07:42 +0800  Kevin McCarthy  <kevin@8t8.us> (d619496e)

        * Update UPDATING file for 2.2.11 release.

M	UPDATING

2023-08-15 12:34:05 +0800  Kevin McCarthy  <kevin@8t8.us> (d52c6115)

        * Fix GPGME build failure on MacOS.
        
        Commit 012981e8 (in release 2.2.9) updated the GPGME autoconf files,
        to fix a build issue with newer GPGME releases.
        
        Unfortunatley that caused a build issue for hosts where the gpg-error
        header files aren't in the include path.  The newer autoconf file
        expect GPG_ERROR_CFLAGS to be added to the list of flags for the
        compiler.
        
        Thanks to Will Yardley for reporting the issue and quickly testing the
        proposed fix.

M	Makefile.am

2023-06-05 18:53:55 +0800  TAKAHASHI Tamotsu  <ttakah@lapis.plala.or.jp> (a5423c40)

        * Updated Japanese translation.

M	po/ja.po

2023-04-14 15:57:07 -0700  Kevin McCarthy  <kevin@8t8.us> (50954c4a)

        * Fix <collapse-all> behavior for sort=reverse-threads.
        
        When uncollapsing, _mutt_traverse_thread() returns the virtual number
        of the root message in the thread.  <collapse-thread> directly sets
        menu->current to this value to cause the cursor to be on the *first*
        message of the thread (which isn't the same as the root message when
        sort=reverse-threads).  <collapse-all> finds the corresponding message
        by searching for it after re-indexing.
        
        However, when collapsing, _mutt_traverse_thread() had code to try and
        find the *first* message in the thread and return that virtual number.
        <collapse-thread> then did the same trick, because the old first
        message is now the new root message for sort=reverse-threads.
        
        However, that cleverness caused a bug for <collapse-all> - it can't
        use that virtual number directly, and it can't "find" the message at
        the index after reindexing.
        
        To fix this, remove the cleverness from _mutt_traverse_thread() when
        collapsing.  Return the virtual number of the root.  Add searching
        behavior for <collapse-thread> to fix its behavior.

M	curs_main.c
M	thread.c

2023-03-25 13:07:19 -0700  Kevin McCarthy  <kevin@8t8.us> (e0e92c31)

        * automatic post-release commit for mutt-2.2.10

M	ChangeLog
M	VERSION

2023-03-25 13:03:39 -0700  Kevin McCarthy  <kevin@8t8.us> (9138232d)

        * Update UPDATING files for 2.2.10 release.

M	UPDATING

2023-03-13 18:24:31 -0700  Kevin McCarthy  <kevin@8t8.us> (33f8b7ce)

        * Update copyright notices.
        
        This is generated from the copyright-updater script, with manual
        updates for the main.c and documentation, and po files.

M	COPYRIGHT
M	background.c
M	buffy.c
M	doc/manual.xml.head
M	doc/mutt.man
M	main.c
M	mutt_sasl_gnu.c
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po
M	sidebar.c

2022-11-12 10:02:01 -0800  Kevin McCarthy  <kevin@8t8.us> (9f01d4ab)

        * Abort imap_fast_trash() if previously checkpointed.
        
        We don't want to copy the deleted flag over to the trash folder too.
        
        I looked into various ways to keep the UID COPY, but they lead to
        niggling issues with error handling along with handling if the server
        sends flag updates back to the client.
        
        So for that (hopefully rare) case, abort the fast trash and just use a
        regular copy.

M	imap/imap.c

2023-03-06 18:55:06 -0800  Kevin McCarthy  <kevin@8t8.us> (216dd145)

        * Improve smtp oauth authentication.
        
        Split XOAUTH2 to use two steps.
        
        This follows the microsoft.com documentation example for smtp.  Since
        office365 is the main site using XOAUTH2 now, it's better to match
        their documentation.
        
        It also matches msmtp's behavior, which probably means somewhere or
        another needs it that way.
        
        At the same time, improve response code checking.  Mutt was using
        smtp_get_resp() before, which returns 0 for both a ready and success
        response code.  Make sure it's a success response code when done
        authenticating.

M	smtp.c

2023-03-04 18:33:35 +0100  Sebastian Andrzej Siewior  <sebastian@breakpoint.cc> (5df86199)

        * Use base64 URL safe alphabet for message id generation.
        
        The character '/' from base64 alphabet breaks web redirectors if the
        message-id from an email is used as part of the URL for redirectors and/
        or automatic pointers to an email.
        
        Use the URL safe alphabet from RFC4648 section 5 for message id
        generation.
        
        Signed-off-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>

M	base64.c
M	messageid.c
M	mime.h
M	protos.h
M	sendlib.c

2023-03-04 18:33:34 +0100  Sebastian Andrzej Siewior  <sebastian@breakpoint.cc> (cecddeac)

        * base64val: Add support to decode base64 safe URL.
        
        In the base64 safe URL dictionary the characters '+' and '/' are
        replaced by '-' and '_'.
        Add the characters to Index_64 to allow decoding if needed.
        
        Signed-off-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>

M	handler.c

2022-12-19 18:53:43 -0800  Cline, Wade  <wade.cline@intel.com> (7c4fa478)

        * mutt_oauth2: Print access token request message
        
        There are cases when using the 'authcode' grant where the authorization
        request will succeed but the access token request will fail (for
        example: if the user's web browser and terminal use different proxy
        settings).  The current implementation of the script does not inform
        the user that the authorization token is being exchanged for an access
        code, with the result that it can appear that a request has both
        succeeded (according to the browser) and failed (according to the
        terminal output) simultaneously.  Add a message to inform the user that
        a second request is being made so there is less potential for confusion.

M	contrib/mutt_oauth2.py

2022-12-12 15:05:18 -0800  Kevin McCarthy  <kevin@8t8.us> (16d8ad64)

        * Move MuttLisp boolean config note.
        
        I think it probably makes more sense to be inside the (if) function
        documentation than (equal).

M	doc/manual.xml.head

2022-12-07 15:51:36 -0800  Kevin McCarthy  <kevin@8t8.us> (ef2abed2)

        * Fix counters for external maildir 'T' flag changes.
        
        The maildir_check_mailbox() code was not updating the context deleted
        and trashed counts in those cases.  This could lead to messages marked
        as deleted, but no action being taken on a mailbox sync/close.
        
        wip: fix ctx counts for maildir 'T' flags updates.

M	mh.c

2022-12-07 12:58:40 -0800  Kevin McCarthy  <kevin@8t8.us> (d0faf2d4)

        * Remove reference to $mark_old inside $mail_check_recent.
        
        There doesn't appear to be any relationship between $mark_old and "new
        mail" status any more.
        
        Commit c26c2531 (from 2002) is the most recent commit that talked
        about reducing the meaning of $mark_old, and may have been the commit
        to make that separation.

M	init.h

2022-12-07 12:53:51 -0800  Kevin McCarthy  <kevin@8t8.us> (ba5e0dc2)

        * Add doc note to MuttLisp about boolean config vars.
        
        They evaluate to "yes" and "no", and so need an explicit comparison to
        those values when using the equal function.

M	doc/manual.xml.head

2022-11-19 13:20:25 -0800  Kevin McCarthy  <kevin@8t8.us> (2f35d2fd)

        * Reset header color after mutt_set_flag().
        
        I partially changed this to lazily update after a thread update in
        commit c9fa0414, but unfortunately didn't investigate the reason for
        the color update while setting a flag.  Since it was that way, I
        assumed it was for a purpose.
        
        However, it turns out there is no need to actively set the header
        color in that function.  Many places in Mutt already simply reset the
        color values to 0 to invalidate and cause a recheck later.
        
        Setting the color there so can even be detrimental, if the user has
        slow 'color index' lines.  For example doing a <tag-pattern>~A will
        cause the color to be computed for the *entire* mailbox.  Now, the
        user ought to not have a slow color index line, but if they do, this
        causes unnecessary pain.
        
        Note that the header->color doesn't have an actual "unset" value,
        which could also help performance.  Maybe in the future in master
        branch.

M	flags.c
M	mutt.h
M	protos.h
M	score.c

2020-04-26 10:43:24 -0700  Kevin McCarthy  <kevin@8t8.us> (a60b22fe)

        * Filter U+200C in pager.
        
        "U+200C ZERO WIDTH NON-JOINER" is generating '?' on some systems.

M	pager.c

2022-11-12 12:50:23 -0800  Kevin McCarthy  <kevin@8t8.us> (00093fd7)

        * automatic post-release commit for mutt-2.2.9

M	ChangeLog
M	VERSION

2022-11-12 12:44:13 -0800  Kevin McCarthy  <kevin@8t8.us> (b40c28ce)

        * Update UPDATING file for 2.2.9.

M	UPDATING

2022-11-12 12:39:11 -0800  Kevin McCarthy  <kevin@8t8.us> (a5296bcd)

        * Document the <1234> key syntax for bind.
        
        This is useful for octal values of greater (or less) than three
        digits.

M	doc/manual.xml.head

2022-11-06 19:19:40 -0800  Kevin McCarthy  <kevin@8t8.us> (3c0f8597)

        * Fix non-printable keyname printing to use <octal> syntax.
        
        The IsPrint() was grabbing values outside the range of a char.
        Instead, restrict the range and fall back to the <octal> syntax, which
        the muttrc actually accepts.

M	keymap.c

2022-11-07 14:32:59 -0800  Kevin McCarthy  <kevin@8t8.us> (52753702)

        * Move AM_PATH_GPG_ERROR before AM_PATH_GPGME.
        
        The former sets $GPGRT_CONFIG which the latter needs to find and use
        gpgrt-config instead of gpgme-config.

M	configure.ac

2022-11-07 09:01:58 -0800  Kevin McCarthy  <kevin@8t8.us> (012981e8)

        * Update gpgme autoconf files to the latest versions.
        
        GPGME is transitioning away from gpgme-config, to gpgrt-config, and
        the new autoconf files are required to make the transition.
        
        Thanks to Vincent Lefèvre for reporting the problem and helping test
        the required fixes.

M	m4/gpg-error.m4
M	m4/gpgme.m4

2022-11-06 08:48:32 -0800  Kevin McCarthy  <kevin@8t8.us> (80e79060)

        * Adjust manual concerning IMAP Fcc in batch mode.
        
        Remove the sentence saying it isn't supported from the Batch
        Composition Flow section of the manual.

M	doc/manual.xml.head

2022-11-05 13:14:09 -0700  Kevin McCarthy  <kevin@8t8.us> (57e3de6d)

        * automatic post-release commit for mutt-2.2.8

M	ChangeLog
M	VERSION

2022-11-05 12:37:33 -0700  Kevin McCarthy  <kevin@8t8.us> (44b9bd4f)

        * Update UPDATING file for 2.2.8 release.

M	UPDATING

2022-11-04 13:18:51 -0700  Kevin McCarthy  <kevin@8t8.us> (db16ce47)

        * Add explicit void to 0-parameter function definitions.
        
        These are the errors output with:
          -Werror=implicit-int -Werror=implicit-function-declaration
          -Werror=int-conversion -Werror=strict-prototypes
          -Werror=old-style-definition

M	autocrypt/autocrypt_acct_menu.c
M	background.c
M	charset.c
M	curs_lib.c
M	menu.c
M	monitor.c
M	pattern.c

2022-11-03 14:01:12 -0700  Kevin McCarthy  <kevin@8t8.us> (0838a8f4)

        * Clarify $uncollapse_new documentation.
        
        Indicate more clearly it is talking about "delivered" messages that
        arrive in a thread, not about the unread-status of those messages.

M	init.h

2022-11-01 20:22:06 -0700  Kevin McCarthy  <kevin@8t8.us> (b254f2fb)

        * Add a check for key->uids in create_recipient_set.
        
        For gpgme < 1.11.0, it used this function to create the encryption key
        list.  The '!' was interpreted differently back then, and it
        apparently didn't check if the returned key had any uids before
        referencing it.  Add a check to prevent a segv as in the public key
        block fix.

M	crypt-gpgme.c

2022-10-31 15:06:51 -0700  Kevin McCarthy  <kevin@8t8.us> (f0eb3586)

        * Fix public key block listing for old versions of gpgme.
        
        Commit 382355a5 accidentally removed the data import for legacy mode,
        which would cause it to produce empty output.

M	crypt-gpgme.c

2022-10-31 15:02:57 -0700  Kevin McCarthy  <kevin@8t8.us> (48b6ea32)

        * Fix gpgme crash when listing keys in a public key block.
        
        The gpgme code handling classic application/pgp assumed each key would
        have a uid.  Change it to check for a missing uid list.
        
        Also change it to list every uid (instead of only the first), and to
        put each one on a "uid" line in the output.
        
        The output is only for display, so the format change won't affect
        other parts of the code.
        
        Thanks to Mikko Lehto for the high quality bug report, detailing the
        exact place of the crash with a reproducing example and a workaround
        patch.

M	crypt-gpgme.c

2022-10-13 13:25:51 -0700  Kevin McCarthy  <kevin@8t8.us> (25b69530)

        * Allow Fcc'ing to IMAP in batch mode.
        
        There are some prompts that can cause it to abruptly fail, but it
        turns out SMTP has some of those too.
        
        For now, abort if $confirmcreate is set.
        
        Certificate prompts were fixed in commit c46db2be for 2.2.7.

M	imap/imap.c
M	send.c

2022-10-13 13:18:55 -0700  Kevin McCarthy  <kevin@8t8.us> (a1c86bd2)

        * Add fcc error handling in batch mode.
        
        If $fcc_before_send is set, then abort with an error message.
        
        If it's not set (the default), then continue on, as the message is
        already sent.

M	send.c

2022-10-09 11:13:15 -0700  Kevin McCarthy  <kevin@8t8.us> (9cfa36ea)

        * Fix scrolling when handling SIGWINCH in the index.
        
        The index had some (very very old) code which reset the scroll top
        during SIGWINCH handling.  This caused a recomputation of the top,
        which caused the index to jumble around randomly during resizing.
        
        The last few commits added SigWinch flag setting whenever
        mutt_endwin() was called, which meant this jumbling would occur much
        more often.  (For example when piping a message.)
        
        After looking more closely, this top reset seems to be unnecessary.  A
        full redraw needs to properly handle the case where "current" is
        outside the visible range, because a resize could occur in a called
        menu.  Additionally, the menu.c code does just fine without this, and
        is used for all the other standard menus in Mutt.
        
        Thanks to Vincent Lefèvre for helping test the SigWinch changes, and
        reporting this regression.

M	curs_main.c

2022-10-08 13:47:15 -0700  Kevin McCarthy  <kevin@8t8.us> (082ed14e)

        * Explicitly mention --with-sqlite3 in the INSTALL file.

M	INSTALL

2022-09-23 13:05:59 +0800  Kevin McCarthy  <kevin@8t8.us> (5649e381)

        * Set the curses resize policy to use tioctl()
        
        mutt_resize_screen() calls mutt_reflow_windows(), which records window
        sizes in those data structures.  After a endwin(), curses will also
        check the terminal size, but it if uses a different policy than Mutt,
        the screen will be drawn incorrectly.
        
        I looked into adding a config option to change this, but ran into a
        chicken-egg problem.  initscr() must be called before the config is
        processed, to allow for color setting.  However, use_env() must be
        called before initscr().  So for now, just set to policy to ignore the
        env vars, except as a fallback.

M	configure.ac
M	main.c

2022-09-21 13:03:22 +0800  Kevin McCarthy  <kevin@8t8.us> (fede64d0)

        * Remove unneeded calls in mutt_edit_file().
        
        The mutt_resize_screen() is no longer needed now that mutt_endwin()
        sets SigWinch.
        
        The keypad() and clearok() calls are generally only needed if a
        program takes over the screen unexpectedly (without Mutt having run
        endwin()).

M	curs_lib.c

2022-09-21 13:02:40 +0800  Kevin McCarthy  <kevin@8t8.us> (9fb2755d)

        * Change a few cases of endwin() to call mutt_endwin().
        
        The remaining cases in the Mutt code are special cases, but these two
        should be fixed.  This ensures SigWinch is set.

M	commands.c
M	compress.c

2022-09-21 13:00:44 +0800  Kevin McCarthy  <kevin@8t8.us> (619db54f)

        * Add SigWinch = 1 to mutt_endwin().
        
        Since mutt_reflow_window() needs to be called on a resize, and it's
        possible for programs to block SIGWINCH being sent to Mutt, this is a
        fail-safe to ensure it's run.
        
        The previous commit moved SigWinch handling before refresh() in the
        menus, which should prevent double-refresh issues.

M	curs_lib.c

2022-09-19 18:41:48 +0800  Kevin McCarthy  <kevin@8t8.us> (925a2927)

        * Move SigWinch handling before refresh in menus.
        
        This will prevent an unneeded double-refresh after an endwin() when we
        set SigWinch in the next commit.
        
        In the pager, change RETWINCH handling to account for a sigwinch while
        in the handler.  Previously a redraw would occur and use/free the
        Resize data, but since the SigWinch check now occurs before the
        redraw, keep existing data.

M	curs_main.c
M	menu.c
M	pager.c

2022-08-30 15:31:24 -0700  Kevin McCarthy  <kevin@8t8.us> (e43a42bf)

        * Ensure pop_data is freed for mailbox and fetch-mail usage.
        
        <fetch-mail> was only free'ing the container and not the auth_list or
        timestamp used in authentication.
        
        Mailbox usage was never free'ing the pop_data object.
        
        Create a pop_free_pop_data() helper and use that in <fetch-mail>
        usage where the pop_data was being free'd before.
        
        Since the pop code always allocates and assigns a new pop_data object
        after each mutt_conn_find(), add a call to pop_close_mailbox() too.
        
        Just to make sure, reset connection->data before free'ing the pop_data
        in each case.

M	pop.c

2022-08-25 13:23:43 -0700  Kevin McCarthy  <kevin@8t8.us> (c46db2be)

        * Add error handling for cert prompts in batch mode.
        
        It looks like there are no batch mode checks before trying to throw up
        a curses menu for certificate prompts.
        
        This currently affects SMTP, and I guess either hasn't been an issue
        or people just learned to work around it.
        
        Mutt has no great way to deal with this, so at least for now display
        an error and abort verification gracefully as opposed to whatever was
        happening before (which could not have been pretty).
        
        Alas, this breaks my rule of adding translation strings in stable, but
        I couldn't find another appropriate string.

M	mutt_ssl.c
M	mutt_ssl_gnutls.c

2022-08-22 09:24:19 -0700  Ivan Vilata i Balaguer  <ivan@selidor.net> (56f1d398)

        * Updated Catalan translation.

M	po/ca.po

2022-08-07 10:20:17 -0700  Kevin McCarthy  <kevin@8t8.us> (4927240d)

        * automatic post-release commit for mutt-2.2.7

M	ChangeLog
M	VERSION

2022-08-07 10:15:32 -0700  Kevin McCarthy  <kevin@8t8.us> (7b41537e)

        * Update UPDATING file for 2.2.7 release.

M	UPDATING

2022-08-02 20:51:17 -0700  Kevin McCarthy  <kevin@8t8.us> (40228035)

        * Fix mutt_read_rfc822_line() to use is_email_wsp().
        
        ISSPACE() uses isspace() which is locale-dependent.  On some
        platforms, unexpected 8-bit chars, such as 0xa0 or 0x85 return true.
        
        When using $edit_headers, this can result in Subject: lines being
        truncated if a multi-byte character ending in one of these values is
        at the end of a line.
        
        There are probably other bugs that could be triggered by this, such as
        in IMAP parsing.  However, I need more time to investigate before
        making large-scale changes that could introduce new bugs.

M	parse.c

2022-08-04 10:25:26 +0200  Matthias Andree  <matthias.andree@gmx.de> (4d2b33ba)

        * Drop X509 *cert from sslsockdata, unused.
        
        Signed-off-by: Matthias Andree <matthias.andree@gmx.de>
        (cherry picked from commit 0d03501ac9ddd1a4a62a7274651d64da0c4c3865)

M	mutt_ssl.c

2022-07-29 19:52:45 -0700  Kevin McCarthy  <kevin@8t8.us> (a1a08067)

        * Change mutt_display_message() $pager to use %s if present.
        
        Other places in the code all use mutt_do_pager(), which uses
        mutt_expand_file_fmt().
        
        The use of %s was not documented (and likely not used since it's
        broken when displaying messages), so add documentation to the $pager
        option.

M	commands.c
M	init.h

2022-07-29 10:40:33 -0700  Kevin McCarthy  <kevin@8t8.us> (4f672027)

        * Overide SSL_CTX min/max protocol versions.
        
        Newer versions of OpenSSL disable old (insecure) protocols by default.
        Reset the allowed versions, so that Mutt's configuration variables
        enabling old protocols actually work if needed.
        
        Thanks to Matthias Andree for the patch, which this commit is based
        upon.

M	mutt_ssl.c

2022-03-04 15:26:56 -0800  Kevin McCarthy  <kevin@8t8.us> (b022931d)

        * Tighten $query_command parsing to allow empty name field.
        
        The documentation writes the output should be "each line containing a
        tab separated address then name then some other optional information".
        The wiki page at
        <https://gitlab.com/muttmua/mutt/-/wikis/MuttGuide/Aliases> also
        implies a single tab between each field.
        
        Since the function used strtok, consecutive tab delimeters were
        treated as a single delimiter.  This caused a missing name field to
        use the comment field as the name.
        
        Change the function to use strchr instead.  This is not without risk,
        as the functionality is old.  Who knows what all programs have been
        written that might assume initial, or multiple delimiters are
        acceptable...
        
        Thanks to Magnus Groß for reporting the problem along with a patch,
        which this commit is derived from.

M	query.c

2022-07-10 14:58:40 +0200  Matthias Andree  <matthias.andree@gmx.de> (135fb67e)

        * version.sh: fix robustness on git failure
        
        for instance, with untrusted directory under sudo.
        
        Signed-off-by: Matthias Andree <matthias.andree@gmx.de>

M	version.sh

2022-07-17 22:20:12 +0200  Matthias Andree  <matthias.andree@gmx.de> (607efef7)

        * de.po: Fix German certificate dialog translation.
        
        Remove the full-stop to ensure reader will continue reading rather
        than mistake this as a conclusion.
        
        Also, from: to: here translate to von: bis: (not an: which would be
        spatial not temporal).
        
        Finally, fix a mistranslation where SHA256 was translated as SHA1
        
        Reviewed by: Helge Kreutzmann <debian@helgefjell.de>
        Signed-off-by: Matthias Andree <matthias.andree@gmx.de>

M	po/de.po

2022-07-06 14:39:42 -0700  Kevin McCarthy  <kevin@8t8.us> (0614c38c)

        * Comment out undesirable default settings in smime.rc.
        
        Some distributions, such as Debian, use the contrib/smime.rc as a
        default system configuration file (under /etc/Muttrc.d).  However
        settings such as $smime_is_default and $crypt_autosign should not be
        enabled by default for everyone.
        
        Debian previously maintained a patch against the file, commenting out
        those settings, but the patch somehow got dropped and is causing
        confusion for Debian users.
        
        Since the settings aren't necessarily desirable for anyone who wants
        to use S/MIME, comment them out in the contrib file.

M	contrib/smime.rc

2022-06-09 09:22:03 -0700  Kevin McCarthy  <kevin@8t8.us> (97f8eee2)

        * Decrypt S/MIME when mime-forwarding with $forward_decrypt set.
        
        The code was performing a decode for S/MIME, but this had the effect
        of running attachments through the autoview routines.
        
        Change so it only performs a decrypt.  This is also how copying is
        handled in set_copy_flags(), so I believe the decode was just a
        mistake.

M	sendlib.c

2022-06-05 11:20:00 -0700  Kevin McCarthy  <kevin@8t8.us> (d1ee1314)

        * automatic post-release commit for mutt-2.2.6

M	ChangeLog
M	VERSION

2022-06-05 11:13:47 -0700  Kevin McCarthy  <kevin@8t8.us> (42c9d1ea)

        * Update UPDATING file for 2.2.6 release.

M	UPDATING

2022-05-27 14:58:23 -0700  Kevin McCarthy  <kevin@8t8.us> (44636260)

        * Fix $pgp_sort_keys sorting.
        
        Both gpgme and pgpkey used nonsensical comparison return values, for
        example: "return r > 0".
        
        Adjust numeric comparisons to use mutt_numeric_cmp() and have the
        comparator return the result of the actual comparison.
        
        Adjust the "trust" sorting of gpgme to be the same as classic-pgp:
        putting restrictions at the bottom, but reverse sorting validity,
        length and timestamp values so they come first in the list.

M	crypt-gpgme.c
M	pgpkey.c

2022-05-22 19:03:33 -0700  Kevin McCarthy  <kevin@8t8.us> (818ea32c)

        * Adjust browser and sidebar numeric sorting to use mutt_numeric_cmp()
        
        Large values shouldn't use subtraction into an integer return type, so
        just convert all of them to use the macro, to be safe.

M	browser.c
M	sidebar.c

2022-05-27 13:24:11 -0700  Kevin McCarthy  <kevin@8t8.us> (f8336984)

        * Fix mbrtowc() error handling in mutt_which_case().
        
        The function did not reset the increment value on a -2 return value.
        
        Increase the maximum conversion size to the string length, and check
        for -2.  Since we're looking at the whole string, we can then just
        terminate the loop on either value, assuming a case-sensitive search.
        
        mbrtowc() will return -2 if passed n==0, so add an explicit check for
        the end of string and a positive n count.

M	pattern.c

2022-05-27 13:22:22 -0700  Kevin McCarthy  <kevin@8t8.us> (def28317)

        * Fix mbrtowc() error handling in check_alias_name().
        
        The function did not reset the increment value on any error.  Increase
        the maximum conversion size to the string length, and check for -2.
        Since we're looking at the whole string, we can then just terminate
        the loop on a -2 return value.

M	alias.c

2022-05-26 11:29:15 -0700  Kevin McCarthy  <kevin@8t8.us> (51c67ba9)

        * Convert my_width() to use mbrtowc().
        
        This allows handling a single corrupted character vs an incomplete
        multibyte character differently, as other parts of Mutt do.

M	sendlib.c

2022-05-25 20:59:39 -0700  Kevin McCarthy  <kevin@8t8.us> (ca960228)

        * Fix header folding my_width() calculation.
        
        After calculating the width of a character, the routine would only
        increment the string pointer by one byte.  Any errors returned by
        mbtowc() would also increment the width by one.  This means multibyte
        characters would overcount width by the number of bytes minus one.
        
        Change it to check the return value and use that value to increment
        the string pointer.
        
        Change mbtowc() to look at the whole rest of the string instead of
        just MB_CUR_MAX, as the manpage says even MB_CUR_MAX may not be enough
        in some circumstances.
        
        Since we calculate strlen, use that as well as '\0' for the loop
        termination check.  Also check for mbtowc() returning 0 just for extra
        safety.
        
        Reset the internal mbstate_t before converting, and on any error.
        
        If mbtowc() returns an error, use replacment_char() as a substitue for
        width calcluation, as mutt_strwidth() and other parts of Mutt do.

M	sendlib.c

2022-05-25 09:53:07 -0700  Kevin McCarthy  <kevin@8t8.us> (67bb3d35)

        * Filter Arabic Letter Mark due to display corruption.
        
        Under GNU Screen, the directional marker causes display corruption in
        the index.
        
        This (along with past filters added) should perhaps be considered GNU
        Screen bugs.  They've been reported upstream a while ago, but so far
        not received any attention.  So for Mutt users' benefit it's better to
        filter them out for now.
        
        Thanks to Vincent Lefèvre for debugging and reporting the problem,
        along with providing historical information from similar past issues.

M	mbyte.c

2022-05-21 09:18:04 -0700  Kevin McCarthy  <kevin@8t8.us> (ceb6c4fc)

        * Fix browser completion path expansion to preserve a trailing slash.
        
        The browser lists the contents of a directory passed as 'f' when it
        has a trailing slash; without, it lists everything matching that name
        in the parent directory.
        
        Since the browser does its own relative path expansion, we can just
        use mutt_buffer_path_norel() to keep a trailing slash in 'f'.

M	browser.c

2022-05-21 09:07:23 -0700  Kevin McCarthy  <kevin@8t8.us> (599806a0)

        * Decouple expand_path() relpath vs trailing slash handling.
        
        This change was originally done for the next commit, to fix browser
        completion handling.  However, I discovered the browser does its own
        relative path expansion, and could just be fixed by using the _norel()
        version.
        
        Still, I think this change is a good idea in any case.  There may be a
        few more fixes needed that require relpath expansion while keeping
        trailing slashes.
        
        Since the number of flag parameters to expand_path would become
        excessive by adding a "remove_trailing_slash" paremeter, convert it to
        use a single 'flags' parameter instead.

M	hook.c
M	mutt.h
M	muttlib.c
M	protos.h

2022-05-20 08:51:05 -0700  Helge Kreutzmann  <debian@helgefjell.de> (5006b546)

        * Update de.po.

M	po/de.po

2022-05-19 12:36:06 -0700  Kevin McCarthy  <kevin@8t8.us> (80d90e0c)

        * Document $sendmail invocation behavior.
        
        This variable is handled differently from other "command" variables in
        Mutt.  It's tokenized by space and then executed via execvp().  This
        means spaces in command/arguments are not supported, and neither is
        shell quoting.
        
        I don't know if it was done this way out of some security concern, but
        it seems like using mutt_system() and mutt_buffer_quote_filename() for
        recipient arguments should at least be investigated.

M	init.h

2022-05-16 10:20:30 -0700  Kevin McCarthy  <kevin@8t8.us> (a8c7fba1)

        * automatic post-release commit for mutt-2.2.5

M	ChangeLog
M	VERSION

2022-05-16 10:16:07 -0700  Kevin McCarthy  <kevin@8t8.us> (c94b511a)

        * Update UPDATING file for 2.2.5.

M	UPDATING

2022-05-13 15:37:58 -0700  Kevin McCarthy  <kevin@8t8.us> (6688bfbf)

        * Set gsasl hostname callback value.
        
        This is needed for GSSAPI, and apparently DIGEST-MD5 too.
        
        The gsasl documentation is a little confusing, saying it "should be
        the local host name of the machine", however the imap/auth_gss.c code
        seems to be using the server name, and the msmtp source also uses the
        server name for this callback.
        
        Thanks to brian m. carlson and Gábor Gombás for reporting this issue
        in Debian ticket 1010915, and an additional thanks to brian for
        quickly testing the fix.

M	mutt_sasl_gnu.c

2022-05-06 12:51:56 -0700  Kevin McCarthy  <kevin@8t8.us> (9d5db7cb)

        * Force IR with gsasl SMTP PLAIN authentication.
        
        Debian ticket 1010658 showed a server violating RFC 4954 by sending
        non-base64 data in the 334 response when Mutt sends "AUTH PLAIN"
        (without IR).
        
        The msmtp source also seems to force IR with PLAIN because it found
        other broken servers.
        
        So the best option seems to be just handling PLAIN specially for now.

M	smtp.c

2022-04-30 12:41:43 -0700  Kevin McCarthy  <kevin@8t8.us> (c3baa83e)

        * automatic post-release commit for mutt-2.2.4

M	ChangeLog
M	VERSION

2022-04-30 12:38:09 -0700  Kevin McCarthy  <kevin@8t8.us> (4d082513)

        * Update UPDATING file for 2.2.4 release.

M	UPDATING

2022-04-30 11:11:04 -0700  Kevin McCarthy  <kevin@8t8.us> (7dec694f)

        * Document $header_cache behavior change wrt directories.
        
        Although not documented, Mutt would previously intepret a
        $header_cache value ending in '/' as a directory even if it didn't
        exist.  The new DT_PATH normalization prevents this possibility, so a
        directory will need to be created in advance.
        
        I'm not fond of "fixing" regressions with documentation, but I believe
        this is a small issue, easily worked around for first-time use, and
        the benefits of the normalization are worth this small change.

M	doc/manual.xml.head
M	init.h

2022-04-28 12:48:09 -0700  Kevin McCarthy  <kevin@8t8.us> (a20ed9b4)

        * When expanding local paths, normalize to remove a trailing '/'.
        
        Commit 986e9e74 normalized Maildir/mh paths upon opening, to aid in
        mailbox comparison issues that can crop up (as the IMAP path
        normalization does).
        
        Unfortunately, this caused other problems in cases where users were
        explicitly adding a trailing '/' to their config settings, such as
        with buffy mailboxes, or with $spoolfile.
        
        To normalize properly, we need to do as the IMAP code does - both on
        the context opening, and expand_path (as imap_expand_path() and
        imap_fix_path() do).
        
        This also helps other cases; for example, the file browser returns
        entries without a trailing '/', while tab completion in the editor
        menu appends a trailing '/'.
        
        Right now the only regression I'm aware of is with $header_cache on
        first use, which I will document in the next commit.  If it turns out
        there are more important regressions I may have to back this and the
        original commit out.

M	muttlib.c

2022-04-21 22:58:48 +0300  Emir SARI  <emir_sari@icloud.com> (b69aed8e)

        * Minor translation fixes

M	po/tr.po

2022-04-12 11:23:07 -0700  Kevin McCarthy  <kevin@8t8.us> (d9199322)

        * automatic post-release commit for mutt-2.2.3

M	ChangeLog
M	VERSION

2022-04-12 11:14:38 -0700  Kevin McCarthy  <kevin@8t8.us> (03f8c660)

        * Update UPDATING file for 2.2.3.

M	UPDATING

2022-04-10 11:05:48 -0700  Kevin McCarthy  <kevin@8t8.us> (efe4186a)

        * Fix read past end of buf in is_mmnoask().
        
        buf is size STRING while the environment variable is copied into a
        LONG_STRING, so lng can be past the end of buf.  Swap the comparison
        order to make sure they match (and thus ensuring buf[lng] isn't
        outside the buffer).

M	handler.c

2022-04-09 13:32:33 -0700  Kevin McCarthy  <kevin@8t8.us> (f8264135)

        * Fix strlen() assigns to be of type size_t where obvious.
        
        Ticket 405 had an almost-exploit enabled by sloppy assignment of
        strlen().  There were more details involved, of course, but this
        served as encouragement to clean up obvious "strlen assignment to int"
        in the rest of the code.
        
        Note this is not *all* cases, only those that were simple and obvious.
        In some cases, the code assigns strlen() to an int but also uses that
        variable to hold negative values for another reason.  In other cases,
        an API is involved (e.g. SASL) that make changing potentially
        dangerous.  And lastly, some functions were just a bit too complicated
        to risk introducing a bug.

M	charset.c
M	compose.c
M	copy.c
M	crypt-gpgme.c
M	edit.c
M	handler.c
M	hcache.c
M	imap/auth_cram.c
M	imap/imap.c
M	init.c
M	muttlib.c
M	parse.c
M	pgp.c
M	sendlib.c
M	smime.c

2022-04-09 09:54:38 -0700  Kevin McCarthy  <kevin@8t8.us> (195bcad0)

        * Flush iconv() in mutt_convert_string().
        
        The man page says this ought to be done, and other places in Mutt do
        so.

M	charset.c

2022-04-08 21:07:46 -0700  Kevin McCarthy  <kevin@8t8.us> (f58a25cc)

        * Add convert_string() size check.
        
        This is similar to the mutt_convert_string() fix in the last commit.
        In this case there was no integer overflow issue, but there was still
        a (remote) possibility of obl wrapping, so add a check.
        
        Also, ensure there is at least one byte to terminate ob by allocating "obl
        + 1" size buffer, but passing obl to iconv().
        
        Note that mutt_convert_string() uses a multiplier of MB_LEN_MAX, while
        this function used 4.  I thought MB_LEN_MAX might be too large, but
        Tavis Ormandy was able to give a counter-example (0x82 in TSCII (Tamil
        SCII) requires 4 3-byte UTF-8 codepoints).  Convert this function to
        use MB_LEN_MAX, like mutt_convert_string().

M	rfc2047.c

2022-04-08 20:19:27 -0700  Kevin McCarthy  <kevin@8t8.us> (f26d304b)

        * Fix integer overflow in mutt_convert_string().
        
        In the case of a *very* large message header (which is possible via a
        compressed encrypted message) it's possible to overflow the incorrect
        assignment of strlen() to an int local variable.
        
        Thanks to Tavis Ormandy for the bug report and patch, which this
        commit is based upon.
        
        Although Tavis wasn't able to find an exploit, it was almost possible
        to make ob small and obl big, which would have allowed attacker
        control of a heap corruption.
        
        Change the strlen() to assign directly to ibl (of type size_t).  This
        prevents signed to unsigned conversion of len to ibl, which make the
        attack almost possible.
        
        Note that ibl should reflect the number of bytes to be converted by
        iconv(), so the change of ibl to strlen() instead of (strlen() + 1) is
        intentional, and correct.
        
        ob is allocated with an additional byte for a trailing nul, which is
        appended after the conversion.

M	charset.c

2022-04-05 13:14:47 -0700  Kevin McCarthy  <kevin@8t8.us> (4ae494ca)

        * Fix uudecode cleanup on unexpected eof.
        
        Clean up iconv state and state->prefix handling instead of just
        returning.  This is done for the other encoding handlers.

M	handler.c

2022-04-05 11:05:52 -0700  Kevin McCarthy  <kevin@8t8.us> (e5ed080c)

        * Fix uudecode buffer overflow.
        
        mutt_decode_uuencoded() used each line's initial "length character"
        without any validation.  It would happily read past the end of the
        input line, and with a suitable value even past the length of the
        input buffer.
        
        As I noted in ticket 404, there are several other changes that could
        be added to make the parser more robust.  However, to avoid
        accidentally introducing another bug or regression, I'm restricting
        this patch to simply addressing the overflow.
        
        Thanks to Tavis Ormandy for reporting the issue, along with a sample
        message demonstrating the problem.

M	handler.c

2022-03-25 13:07:34 -0700  Kevin McCarthy  <kevin@8t8.us> (aa28abe8)

        * automatic post-release commit for mutt-2.2.2

M	ChangeLog
M	VERSION

2022-03-25 12:58:51 -0700  Kevin McCarthy  <kevin@8t8.us> (dcfbfb16)

        * Update UPDATING file for 2.2.2 release.

M	UPDATING

2022-03-05 11:17:40 -0800  Kevin McCarthy  <kevin@8t8.us> (8babf6c0)

        * Protect prompt completion memcpy() calls with a NULL check.
        
        The behavior of memcpy() is undefined when dest is NULL, even if n is
        0.  It's possible to trigger this, somewhat deliberately, for these
        two cases, so add a guard check.

M	enter.c

2022-03-05 09:31:21 -0800  Kevin McCarthy  <kevin@8t8.us> (7c8992aa)

        * Fix mutt.man formatting.
        
        Thanks for the fix from Mario Blättermann and the manpages-l10n
        project.

M	doc/mutt.man

2022-03-05 09:12:53 -0800  Kevin McCarthy  <kevin@8t8.us> (e65fdf56)

        * Fix query menu tagging behavior.
        
        rfc822_write_address() will automatically prepend ", " to the buf
        parameter if it is non-empty.  Since query_menu() just appended ", "
        to buf, the '\0' marker is at "curpos + 2", and that should be passed
        as the offset instead.
        
        Prior to this fix, tagging would result in two comma-space separators
        between each tagged entry.
        
        Since rfc822_write_address() does the work too, we could just change
        query_menu() to pass rfc822_write_address(buf, buflen, tmpa, 0) each
        time.  But for a stable-branch fix I'll make the smallest change.
        
        As a note, I presume this hasn't been reported because (almost) no one
        uses tagging in this menu.  That may be because it requires hitting
        <select-entry> after tagging, which is non-intuitive.  I think it
        would be worth changing to allow tagging and then hitting <exit> too.

M	query.c

2022-02-21 12:19:30 -0800  Kevin McCarthy  <kevin@8t8.us> (bce2c294)

        * Fix some mailbox prompts to use mailbox history ring.
        
        Commit b0570d76, in the 2.0 release, improved some of the mailbox
        prompt flow and logic, creating a separate function for mailbox
        prompting.  At the same time it changed "save/copy to mailbox" to use
        that function and thus the mailbox history ring.
        
        Unfortunately, this created a partition between some other prompts
        that used the filename history ring but were actually prompting for
        mailboxes.
        
        Change those prompts: edit-fcc, and imap create/rename mailbox to use
        the mailbox history ring.  This will allow values to be shared between
        them and prompts such as "open mailbox" and "save/copy to mailbox".
        
        Ordinarily I wouldn't commit this to stable, but that change broke at
        least one person's workflow badly.

M	compose.c
M	imap/browse.c

2022-02-19 10:48:43 -0800  Kevin McCarthy  <kevin@8t8.us> (c8109e14)

        * automatic post-release commit for mutt-2.2.1

M	ChangeLog
M	VERSION

2022-02-19 10:42:53 -0800  Kevin McCarthy  <kevin@8t8.us> (58b6b76a)

        * Update UPDATING file for 2.2.1 release.

M	UPDATING

2022-02-17 14:38:04 -0800  Kevin McCarthy  <kevin@8t8.us> (30d18234)

        * Make sure username is included in header and body cache paths.
        
        Commit 960afab4 changed URL generation to preserve the data originally
        in the mailbox URL, to fix some internal comparison problems.
        
        Unfortunately, it also affected header and body cache generation.
        Since those could easily be shared across multi-muttrc situations,
        it's important the username be part of the pathname.
        
        Thanks to exg on the #mutt IRC channel for reporting the regression!

M	account.c
M	account.h
M	bcache.c
M	imap/command.c
M	imap/imap.c
M	imap/util.c
M	mutt_socket.c
M	pop.c

2022-02-15 00:15:28 +0300  Emir SARI  <emir_sari@icloud.com> (6457ac67)

        * Fix ambiguity in translation

M	po/tr.po

2022-02-12 10:57:33 -0800  Kevin McCarthy  <kevin@8t8.us> (7160e05a)

        * automatic post-release commit for mutt-2.2.0

M	ChangeLog
M	VERSION
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2022-02-12 10:49:21 -0800  Kevin McCarthy  <kevin@8t8.us> (a5175478)

        * Set release date for 2.2.0 in UPDATING file.

M	UPDATING

2022-02-11 13:37:27 +0100  Grzegorz Szymaszek  <gszymaszek@short.pl> (cc7578a1)

        * Update the Polish translation for Mutt 2.2.0

M	po/pl.po

2022-02-09 22:58:23 +0300  Emir SARI  <emir_sari@icloud.com> (1c47970f)

        * Improve Turkish translations

M	po/tr.po

2022-02-06 14:53:01 -0800  Kevin McCarthy  <kevin@8t8.us> (70958893)

        * Fix mutt_paddstr() to properly filter unprintable chars.
        
        The original version of this function had no "replacement character"
        functionality, so it simply directly called addnstr() to display the
        characters if everything was okay.
        
        Commit a080fd35 added replacement logic, similar to
        mutt_format_string(), but forgot to change addnstr to use the
        replacement character.
        
        This means garbage characters could goof up the mutt display, for
        things such as the subject in the compose menu.
        
        We could add calls to wcrtomb() like in mutt_format_string(), but
        mutt_addwch() already does this, and properly calls wcrtomb() a second
        time to add a shift sequence if needed.

M	curs_lib.c

2022-02-05 14:01:39 -0800  Kevin McCarthy  <kevin@8t8.us> (fe3dd705)

        * Change mailto_allow to be exact match only.
        
        The code was previously reusing mutt_matches_ignore(), but that allows
        prefixes.  For mailto accepted headers we should be more picky.

M	url.c

2022-02-05 13:54:19 -0800  Kevin McCarthy  <kevin@8t8.us> (5c3c6e52)

        * Filter headers passed via the command line.
        
        The values passed via '-s' and mailto urls were not sufficiently
        sanitized, allowing an embedded newline that could be used to inject a
        header.

M	main.c
M	parse.c
M	protos.h
M	url.c

2022-02-05 09:22:44 -0800  Kevin McCarthy  <kevin@8t8.us> (d3b4ff88)

        * Fix mbox.man asctime(3) reference.
        
        The section number should not be part of the BR text.
        
        Thanks to @hmartink and the manpage-l10n project for the bug report!

M	doc/mbox.man

2022-02-04 18:33:34 -0500  Aaron Schrab  <aaron@schrab.com> (7d2a53ee)

        * Clarify description of $local_date_header
        
        When I reexamined the documentation of the $local_date_header option, I
        wasn't very confident about what it actually does. Much of what I did
        get from it came from a vague recollection of the discussion around when
        it was added, and I referred back to the commit which added this to
        solidify that understanding.
        
        Viewing this as a user (without looking at the internal implementation),
        I don't think the date is being converted, to me that implies that it
        was received from somewhere else in some other format; rather I'd view
        it as being initially generated in the local timezone.
        
        The reference to the "sender's timezone" makes me think that this would
        be operating on dates in messages received from other people; I've
        changed that to "your" to help clarify that it's about messages created
        locally.
        
        Finally, add information about what is done if this option is unset,
        along with some reasoning on why someone might want to unset this.

M	init.h

2022-02-02 12:51:08 -0800  Kevin McCarthy  <kevin@8t8.us> (c2ed716b)

        * Don't queue IMAP close commands.
        
        Commit e7df4d5a changed the close commands to queue up, on the theory
        that it will always be followed by a SELECT or a LOGOUT.
        
        However, performing a <recall-message> while in the inbox will open a
        *new* connection.  mutt_conn_find() prepends the new conection to the
        Connections list.  The next mailbox opened will use that *new*
        connection.
        
        The effect will be the queued CLOSE won't occur before that mailbox is
        opened, and so "\Deleted" messages won't be expunged on the server
        right away.
        
        If the user had $move set and reopened their $spoolfile, they would
        find the read messages marked for delete but not yet expunged from the
        server.

M	imap/imap.c

2022-02-02 06:47:45 -0800  Kevin McCarthy  <kevin@8t8.us> (92686e5d)

        * Update Finnish translation.

M	po/fi.po

2022-01-31 06:31:43 +0100  Flammie Pirinen  <flammie@iki.fi> (b485d04f)

        * update Finnish translations

M	po/fi.po

2022-01-30 10:15:20 -0800  Ivan Vilata i Balaguer  <ivan@selidor.net> (553f016e)

        * Updated Catalan translation.

M	po/ca.po

2022-01-30 09:21:58 -0800  Vsevolod Volkov  <vvv@mutt.org.ua> (c7053420)

        * Updated Russian translation.

M	po/ru.po

2022-01-30 09:19:01 -0800  Vsevolod Volkov  <vvv@mutt.org.ua> (db9ac4ad)

        * Updated Ukrainian translation.

M	po/uk.po

2022-01-29 14:24:52 -0800  Kevin McCarthy  <kevin@8t8.us> (8a6472f0)

        * Fix argc==0 handling.
        
        At least on Debian Linux, after invoking getopt() with argc==0, optind
        seems to remain at the default value of 1.
        
        mutt_dotlock was checking for optind==argc to report a missing
        parameter, and would end up invoking the function with the first
        environment variable instead.
        
        mutt, pgpewrap, and mutt_pgpring were assuming argv[0] was non-null,
        so just add a check and hardcode the value in that case to avoid a
        possible segv.
        
        mutt_pgpring allows no arguments.  Its parameters to
        pgpring_find_candidates() would pass the environment list and a
        negative nhints in that case.  The code seem to handle the case, but
        set optind=argc to be clear about it.

M	dotlock.c
M	main.c
M	pgpewrap.c
M	pgppubring.c

2022-01-29 11:46:56 -0800  Helge Kreutzmann  <debian@helgefjell.de> (46ff6ccb)

        * Update de.po.

M	po/de.po

2022-01-29 09:34:04 -0800  Helge Kreutzmann  <debian@helgefjell.de> (17452c87)

        * Update de.po.

M	po/de.po

2022-01-28 12:38:00 -0800  Emir SARI  <emir_sari@icloud.com> (7ae08fd5)

        * Update Turkish translations.

M	po/tr.po

2022-01-28 20:15:02 +0100  Petr Písař  <petr.pisar@atlas.cz> (df4eb293)

        * Update Czech translation for mutt-2.2.0

M	po/cs.po

2022-01-28 09:34:39 -0800  Kevin McCarthy  <kevin@8t8.us> (0864ef75)

        * Update translation files copyright string.
        
        Thanks to Vincent Lefèvre for reminding me to do this too.

M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2022-01-28 15:11:18 +0100  Vincent Lefevre  <vincent@vinc17.net> (7f5ff5f2)

        * Updated French translation.

M	po/fr.po

2022-01-27 15:35:30 -0800  Kevin McCarthy  <kevin@8t8.us> (821803cd)

        * Fix $status_format documentation of $sort_thread_groups expando.

M	init.h

2022-01-27 14:29:35 -0800  Kevin McCarthy  <kevin@8t8.us> (890eb88c)

        * Initial draft of UPDATING file changes for 2.2.0.

M	UPDATING

2022-01-27 13:04:37 -0800  Kevin McCarthy  <kevin@8t8.us> (23ef6eb1)

        * Update source file copyright lines based on commit history.
        
        This is based on the copyright-updater script.  That script only
        updates existing copyright lines in the headers.  Other copyright is
        stored in the commit history.

M	background.c
M	buffer.c
M	buffer.h
M	buffy.c
M	hcachever.pl
M	send.h
M	sidebar.c

2022-01-27 12:18:57 -0800  Kevin McCarthy  <kevin@8t8.us> (ed65fe18)

        * Update manual and program copyright notices.

M	COPYRIGHT
M	doc/manual.xml.head
M	doc/mutt.man
M	main.c

2022-01-27 14:18:06 +0100  Vincent Lefevre  <vincent@vinc17.net> (4f9eac94)

        * Updated French translation.

M	po/fr.po

2021-12-31 18:30:17 -0800  Kevin McCarthy  <kevin@8t8.us> (2e8b6fea)

        * Add very basic cd path completion.
        
        This uses existing code to partially complete, and then launch the
        browser for selection.
        
        Unfortunately, completing a path argument brings up other issues, such
        as quoting, which this currently doesn't handle.  It also might be
        better to rotate through completions rather than launching the file
        brower.
        
        Add a "select directory" mode to the browser, modeled on the IMAP
        "enter vs select a mailbox with children" behavior: using <view-file>
        to select the directory and <select-entry> to enter the directory.

M	browser.c
M	enter.c
M	init.c
M	mutt.h

2021-12-31 15:24:01 -0800  Kevin McCarthy  <kevin@8t8.us> (2362c114)

        * Simplify the mutt_select_file() call for MUTT_CMD completion.
        
        Flags never has both MUTT_CMD and MUTT_MAILBOX, so there is no need
        for the test.

M	enter.c

2021-12-31 15:10:25 -0800  Kevin McCarthy  <kevin@8t8.us> (bc01beeb)

        * Add memcpy on MUTT_CMD completion to invoke the file selector.
        
        It looks like commit 844a133f (21 years ago) accidentally removed the
        memcpy while refactoring, but without it the mutt_select_file() won't
        be called on the second tab keypress.

M	enter.c

2022-01-22 14:10:24 -0800  Kevin McCarthy  <kevin@8t8.us> (05b0dd2c)

        * Enable $rfc2047_parameters by default.
        
        20+ years later, Mutt still gets bug reports about attachment names in
        2047 encoded form.
        
        Although there is a tiny chance an attachment could legimately want to
        be named like that, it's far far more likely the sending MUA has
        incorrectly encoded the value.
        
        When a user has this problem, the "solution" is also difficult to
        find, unless they are initimately familiar with RFC2047 vs 2231.  So I
        think users would benefit much more from this being set by default.

M	init.h

2022-01-17 15:36:55 -0800  Kevin McCarthy  <kevin@8t8.us> (4015c9a0)

        * Set environ for sendmail execvp() call.
        
        The code previously tried to use execvpe(), but that's a glibc
        extension.  However, it's not hard to manually set environ before an
        execvp() call to accomplish the same thing.

M	sendlib.c

2022-01-17 09:54:11 +0100  Vincent Lefevre  <vincent@vinc17.net> (fcd3d956)

        * Updated French translation.

M	po/fr.po

2022-01-14 15:17:38 -0800  Kevin McCarthy  <kevin@8t8.us> (2387728b)

        * Convert SMTP cyrus sasl to use buffers.
        
        Use the smtp_get_auth_response() added for gsasl, to allow
        multi-response lines and arbitrary length server response lines.  The
        rfc notes that SASL lines are not constrained by the SMTP line length
        limits.
        
        Since everything was a bit tangled together before, change the output
        and base64 conversion to use buffers too.

M	smtp.c

2022-01-15 12:31:16 -0800  Robert Bartel  <r.bartel@gmx.net> (44269756)

        * Move hard_redraw() after sendmail invocation.
        
        If a curses gpg pinentry is displayed by the $sendmail program, the
        keypad() needs to called afterwards for it to re-enable function/arrow
        keys.

M	sendlib.c

2022-01-15 11:19:05 -0800  Kevin McCarthy  <kevin@8t8.us> (100d6f3b)

        * Revert "Add $reply_prefix."
        
        This reverts commit 9c1ce59874ce1c8e97d0c5bd71847596dafb1d50.
        
        The change is controversial, and probably ill-advised.  Thanks to
        everyone for the feedback.

M	globals.h
M	init.h
M	send.c

2022-01-13 14:35:20 -0800  Kevin McCarthy  <kevin@8t8.us> (5b8e4605)

        * Add config.h dependency for keymap_defs.h generation.
        
        Ensure the header is regenerated if configure is re-run.  The $(OPS)
        list might change as a result of re-configure, but the timestamps of
        those files won't.  However, config.h will change so we can check that
        as a dependency.

M	Makefile.am

2022-01-10 17:53:09 -0800  Kevin McCarthy  <kevin@8t8.us> (4eff6049)

        * Force resort_init if $reply_regexp changes.
        
        Simply changing real_subj isn't enough to make sure the change is
        reflected in the current index.  There may actually be a more subtle
        way to achieve this, but for now I'll just dump the subj_hash and
        force rethreading.

M	init.c
M	init.h

2022-01-10 14:37:06 -0800  Kevin McCarthy  <kevin@8t8.us> (9c1ce598)

        * Add $reply_prefix.
        
        Allow the user to modify the subject prefix used in a reply.
        Hopefully this would be used sparingly, but nothing prevented a user
        from manually modifying the prefix themselves before.

M	globals.h
M	init.h
M	send.c

2022-01-10 14:00:40 -0800  Kevin McCarthy  <kevin@8t8.us> (466d3b8b)

        * Localize $reply_regexp.
        
        This will allow translators to add additional reply prefixes common to
        their locale.
        
        Add more documentation to the option, to explain the parts of the
        regular expression.  Give an example of adding more prefixes.
        
        Note that the result of this is stored in the header cache.  Probably
        people rarely were affected by this before, but with the new
        localization, people may experiment and need to be aware to turn the
        header cache off while testing.

M	doc/makedoc.pl
M	init.c
M	init.h

2022-01-09 15:28:23 -0800  Kevin McCarthy  <kevin@8t8.us> (cd3a5c85)

        * Fix $reply_regexp default value.
        
        The default value happened to work, but didn't make logical sense.  It
        was using a bracket expression that *included* a backslash, and
        left-bracket, 0-9, and again a backslash.  The first ']' closed the
        bracket expression, and then '+' matched that 1 or more times,
        followed by ']'.  Fortunately the whole parenthisized expression had a
        '*' so it would repeat matching, but as far as I can tell, it was
        working accidentally.
        
        Because even the fixed version is hard to understand, add some
        explanation of the parts to the documentation.

M	init.h

2022-01-09 14:57:07 -0800  Kevin McCarthy  <kevin@8t8.us> (3ca96fab)

        * Fix manual generation string_unescape() of backslash values.
        
        Since the values are shown as if double-quoted, backslash also needs
        to be properly escaped.

M	doc/makedoc.pl

2021-12-30 12:58:28 -0800  Kevin McCarthy  <kevin@8t8.us> (2926cf8c)

        * Merge branch 'stable'

2021-12-30 12:50:49 -0800  Kevin McCarthy  <kevin@8t8.us> (31b18ae9)

        * automatic post-release commit for mutt-2.1.5

M	ChangeLog
M	VERSION

2021-12-30 11:09:31 +0300  Emir Sarı  <bitigchi@me.com> (da60500d)

        * Improve Turkish translations

M	po/tr.po

2021-12-28 13:42:43 -0800  Kevin McCarthy  <kevin@8t8.us> (7855611a)

        * Add pager REDRAW_FLOW redraw flag when popping a menu.
        
        A setting change or window resize could take place in the called menu,
        which will require reflowing the pager when returning to it.
        
        When converting to the menu stack, I left in manual REDRAW_FULL redraw
        assignments, to be cautious and because it wasn't causing an problems.
        However, with the REDRAW_FLOW added, the pager menu needs to have
        those assignments removed after a menu call.

M	menu.c
M	pager.c

2021-12-28 13:25:54 -0800  Kevin McCarthy  <kevin@8t8.us> (5c7e2bce)

        * Merge branch 'stable'

2021-12-27 12:59:49 -0800  Kevin McCarthy  <kevin@8t8.us> (938f91de)

        * Add config variable mentions to Forwarding and Bouncing Mail.
        
        Mention $forward_attribution_intro, $forward_attribution_trailer, and
        $forward_format.

M	doc/manual.xml.head

2021-12-27 12:25:24 -0800  Kevin McCarthy  <kevin@8t8.us> (752a1b44)

        * Merge branch 'stable'

2021-12-25 14:00:02 -0800  Kevin McCarthy  <kevin@8t8.us> (89681e9e)

        * Merge branch 'stable'

2021-12-23 17:30:27 -0800  Kevin McCarthy  <kevin@8t8.us> (4fd19957)

        * Add new gsasl files to POTFILES.in.

M	po/POTFILES.in

2021-12-15 17:50:00 -0800  Kevin McCarthy  <kevin@8t8.us> (68caf914)

        * Add GNU SASL support for authentication.
        
        It turns out Cyrus SASL's license may not be compatible with GPL
        programs, see Debian Bug 999672.
        
        So, add support for the GNU SASL library, using configure option
        --with-gsasl.
        
        I haven't touched the Cyrus SASL code in Mutt all that much in the
        past, but I've done my best to keep the gsasl code clean and simple.
        There are likely mistakes to be fixed and additions to be made,
        though.
        
        I queried the gsasl mailing list about the need for a socket
        wrapper (as is done for the cyrus code), and it seems this should no
        longer be needed.  As long as GSASL_QOP is left at the
        default (qop-auth), the client should ask for authentication, and not
        negotiate integrity or confidentiality.  (Thanks to Phil Pennock and
        Simon Josefsson for their reponses - although the blame is fully
        on *me* if this turns out to be incorrect).  Therefore there is no
        CONNECTION wrapping in this implementation.
        
        Add multiline response support for SMTP authentication (which is
        probably not actually needed).  Also add arbitrary line length for the
        SASL server responses (the RFCs note that for SASL, the protocol line
        lengths don't apply).

M	Makefile.am
M	ascii.h
M	configure.ac
M	doc/makedoc-defs.h
M	imap/Makefile.am
M	imap/auth.c
M	imap/auth.h
A	imap/auth_sasl_gnu.c
M	main.c
A	mutt_sasl_gnu.c
A	mutt_sasl_gnu.h
M	pop_auth.c
M	smtp.c

2021-12-21 18:29:26 -0800  Kevin McCarthy  <kevin@8t8.us> (e3faeb03)

        * Add mutt_socket_buffer_readln().
        
        This will be useful for SMTP and POP SASL reading, where line of
        arbitrary length are required to be supported.

M	mutt_socket.c
M	mutt_socket.h

2021-12-20 15:37:16 -0800  Kevin McCarthy  <kevin@8t8.us> (22736484)

        * Merge branch 'stable'

2021-12-19 21:45:12 -0500  Mike Frysinger  <vapier@gentoo.org> (a4da1664)

        * simplify envelope subject handling code a little
        
        Avoid excess defines.  Compiled code is the same.

M	init.c

2021-12-14 13:36:15 -0800  Kevin McCarthy  <kevin@8t8.us> (80ba3a49)

        * Merge branch 'stable'

2021-12-13 18:55:14 -0800  Kevin McCarthy  <kevin@8t8.us> (f1cc1309)

        * Merge branch 'stable'

2021-12-11 13:22:40 -0800  Kevin McCarthy  <kevin@8t8.us> (fcecddaa)

        * Merge branch 'stable'

2021-12-07 14:46:12 -0800  Kevin McCarthy  <kevin@8t8.us> (ac348e19)

        * Merge branch 'stable'

2021-12-05 12:02:34 +0000  Torsten Franz  <torsten.franz@ubuntu.com> (9dbde32c)

        * Update de.po

M	po/de.po

2021-12-02 15:44:37 -0800  Kevin McCarthy  <kevin@8t8.us> (32c03d3d)

        * Fix sidebar counters with $maildir_trash.
        
        On close, the sidebar decrements deleted messages, but should not when
        $maildir_trash is set.

M	mx.c

2021-12-02 15:36:59 -0800  Kevin McCarthy  <kevin@8t8.us> (29ed0c2e)

        * Improve the statusbar modified flag for $maildir_trash.
        
        Add a context counter for the trash status flag.  Compare that to the
        number of deleted messages to determine modified state.
        
        Note that "undeleting" a trashed message will set context->changed.
        Without that we couldn't do a simple counter comparison.  But with
        context->changed checked first, we can assume equal trash and deleted
        flags then means there are no "delete" modifications pending.

M	init.h
M	mutt.h
M	mx.c
M	status.c

2021-12-01 18:12:11 -0800  Kevin McCarthy  <kevin@8t8.us> (ede3cf58)

        * Ignore $delete when sync'ing with $maildir_trash set.
        
        When closing a mailbox, the $delete quadoption is not consulted to
        determine whether to write out the T flags.  However, for some reason,
        sync was doing so.
        
        Since we aren't "purging" the messages, the prompt doesn't make sense.
        Make close and sync consistent by skipping the $delete check for sync.

M	init.h
M	mx.c

2021-11-24 13:51:32 -0600  Aaron Poffenberger  <akp@hypernote.com> (e8a01c1a)

        * Fix unused variable warning.

M	mutt_ssl.c

2021-11-20 14:21:29 -0800  Kevin McCarthy  <kevin@8t8.us> (04a7f1d9)

        * Allow an empty To: address prompt.
        
        If the user has $askcc or $askbcc configured, they may want to put
        addresses in those without filling in the To field.
        
        Instead check to make sure at least one of the fields is filled in
        after all the prompt before aborting.

M	send.c

2021-11-11 15:05:33 -0800  Kevin McCarthy  <kevin@8t8.us> (543e1151)

        * Convert COLOR_DEFAULT constant to -1.
        
        Previously, "mono" assigned -1 to fg/bg to indicate "unset" values.
        
        NCurses uses -1 to indicate "default" color (when supported), but
        COLOR_DEFAULT was assigned the value -2 and swapped at the last
        moment.  While it worked, I personally found this confusing.
        
        To make the logic clearer, create a COLOR_UNSET constant with value
        -2, and switch COLOR_DEFAULT to -1.  Then remove the last-minute
        translation when allocating the color.
        
        Change the "not set" initialization and testing to use COLOR_UNSET for
        clarity.
        
        Because map_getvaluebyname() returns -1 for a missing value,
        create a new lookup function that returns the matching mapping_t or
        NULL if not found.

M	color.c
M	init.c
M	mapping.h

2021-11-08 20:45:03 +0100  Charalampos Kardaris  <ckardaris@outlook.com> (f210e9a0)

        * [Fix] poll to use PollFdsCount and no PollFdsLen
        
        PollFdsLen tracks the maximum elements of the pollfd struct before
        needing reallocation, whereas PollFdsCount tracks the number of actual
        elements in it. Polling has to be done only on the actual number of
        elements.

M	monitor.c

2021-10-26 14:42:17 -0700  Kevin McCarthy  <kevin@8t8.us> (623eeb26)

        * Add a few mutt variable configure dependency comments.
        
        Add dependency comments to a few variables where it might not be
        obvious are dependent on the feature being enabled.
        
        While reviewing the dependencies, I noticed a couple #if could be
        indented for more uniformity in the file.

M	init.h

2021-10-22 18:08:48 -0700  Kevin McCarthy  <kevin@8t8.us> (75be20d6)

        * Fix color object case insensitive comparisons.
        
        In most of the color code, mutt_getvaluebyname() is used to compare
        against valid tables, which is (ascii) case insensitive.
        
        However, 'uncolor' and 'color quoted' for some reason used case
        sensitive comparison.
        
        The uncolor code can use object comparison instead, as the matching
        Fields value was just retrieve.  For 'color quoted', switch to using
        ascii_strncasecmp() instead.

M	color.c

2021-10-20 14:30:48 -0700  Kevin McCarthy  <kevin@8t8.us> (9c1c9182)

        * Correct multipart/alternative manual section slightly.
        
        Step three only selects from enriched, plain, and then html; not _any_
        text type.
        
        Step four considers any text type as one that Mutt can handle
        internally.

M	doc/manual.xml.head

2021-10-19 18:48:47 -0700  Kevin McCarthy  <kevin@8t8.us> (60ab5f11)

        * Add internal mutt_ctime() implementation.
        
        ctime() is marked obsolescent in the POSIX guide, so we ought to stop
        using it to ensure future portability.

M	from.c
M	mx.c
M	protos.h

2021-10-12 13:31:13 -0700  Kevin McCarthy  <kevin@8t8.us> (534f3ae0)

        * Improve pattern compiler whitespace skipping.
        
        Commit 564b515c fixed a problem with nested patterns, where trailing
        whitespace could cause a compilation error.  That fix added missing
        SKIPWS() calls in a couple branches.
        
        However, the real problem is that the loop doesn't ensure whitespace
        is skipped *before* checking for *ps.dptr.
        
        Rather than relying on all the case branches (and "eater" functions)
        to skip the whitespace after processing, rearrange the logic so the
        SKIPWS() is after the switch statement.

M	pattern.c

2021-10-09 19:55:00 +0200  Vincent Lefevre  <vincent@vinc17.net> (6270278f)

        * Updated French translation.

M	po/fr.po

2021-10-07 17:40:50 -0700  Kevin McCarthy  <kevin@8t8.us> (986e9e74)

        * Remove trailing slashes when opening maildir/mh mailboxes.
        
        IMAP cleans this up already (and file-based mailboxes don't allow it).
        
        It's easy to have this happen by tab-completing a maildir mailbox at
        the change folder prompt.  Removing the slash makes the display more
        uniform, and prevents some problems such as $trash folder comparison.

M	mh.c

2021-10-07 13:02:29 -0700  Kevin McCarthy  <kevin@8t8.us> (14618717)

        * Note that IMAP mailboxes polling doesn't support flag counts.
        
        The IMAP protocol only supports unread and total counts, but the
        manual had no mention of this.

M	doc/manual.xml.head
M	init.h

2021-09-28 15:02:34 -0700  Kevin McCarthy  <kevin@8t8.us> (466432b5)

        * Add $attach_save_charset_convert quadoption.
        
        This prompts to allow charset conversion of received text-type
        attachments.
        
        Mutt automatically converts when sending to a value from
        $send_charset.  If an attachment were automatically converted from
        utf-8 to iso-8859-1 on the sending side, then on the receiving
        side (also 99.9% likely to be utf-8 nowadays) it may not be helpful to
        save the the originally utf-8 attachment as iso-8859-1.  This can be
        especially destructive for attached patches or translation updates.
        
        Add the quadoption, defaulting to ask-yes so people know about it.
        With a quadoption, it can be easily completely turned off or made the
        default if the user desires.
        
        Add code to skip the prompt if converting from ascii to extended
        ascii (e.g. utf-8 or iso-8859-*).  There may be others too but this
        should cover almost all cases nowadays.

M	attach.c
M	init.h
M	mutt.h
M	muttlib.c
M	protos.h
M	recvattach.c

2021-09-25 14:28:18 -0700  Kevin McCarthy  <kevin@8t8.us> (769e5086)

        * Remove unneeded type save/restores around mutt_decode_attachment().
        
        The type save/restore seems to have been copied around the other crypt
        code calls to mutt_decode_attachment().  Remove it, because
        mutt_decode_attachment() makes no such changes.
        
        Note run_decode_and_handler() *does* need to save/restore because it
        manually assigns to b->type itself.

M	crypt-gpgme.c
M	pgp.c
M	smime.c

2021-09-24 16:23:35 -0700  Kevin McCarthy  <kevin@8t8.us> (c0536334)

        * Improve smime_verify_one() error handling and general flow.
        
        mutt_decode_attachment() does not change offset, length, or type.  The
        previous commit added a const modifier to its BODY parameter to assert
        that point.
        
        The save/restore appears to be copy/pasted from other code.  The
        length/type are assigned to if the BODY is passed to a helper function
        after the decode, but that's not the case here.  Remove the
        backup/restore code of the sigbdy fields.
        
        The smime_invoke_verify() call uses the signedfile directly, not the
        STATE parameter.  Remove the code to swap s->fpin before calling
        smime_invoke_verify().
        
        Improve the error handling to properly close file handles and unlink
        all temp files.

M	smime.c

2021-09-24 19:12:35 -0700  Kevin McCarthy  <kevin@8t8.us> (2077f72e)

        * Assert mutt_decode_attachment() doesn't modify body fields.
        
        Some old smime (and other parts of the code) have out of date comments
        asserting mutt_decode_attachment() modifies the body length, offset,
        and type fields.
        
        Add a const modifier to the parameter and called functions to assert
        this is not the case.

M	crypt.c
M	handler.c
M	mutt_crypt.h
M	muttlib.c
M	protos.h

2021-09-23 14:58:54 -0700  Kevin McCarthy  <kevin@8t8.us> (d0d40a33)

        * Don't use subtraction for qsort numeric value comparisons.
        
        Subtraction can overflow, resulting in incorrect sorts.  This is
        especially a concern for the date and size sorting, whose fields are
        greater than an 'int' size.
        
        The index values should be okay, but it's better to be consistent and
        avoid any possible issues.
        
        Define a macro, mutt_numeric_cmp(), that uses direct comparison rather
        than subtraction.

M	imap/imap.c
M	lib.h
M	sort.c
M	thread.c

2021-09-23 13:29:25 -0700  Kevin McCarthy  <kevin@8t8.us> (4153ae96)

        * Fix alias menu multi-select documentation.
        
        The manual mistakenly said to use <select-entry>, which is not (and
        never has been) supported by the code.  Change it to <tag-entry>, and
        note that <Space> is bound to <tag-entry> in the alias menu.

M	doc/manual.xml.head

2021-09-23 13:14:46 -0700  Kevin McCarthy  <kevin@8t8.us> (64d09812)

        * Implement <select-entry> as <display-message> in index menu.
        
        The default keybindings of <display-message> overshadow those of
        <select-entry>.  However, for someone who rebinds (globally or just in
        the index menu), it's still possible to invoke <select-entry> inside
        the index.
        
        It's debatable if <display-message> is the only choice in this case.
        For instance, <attach-message> in the compose menu could conceivably
        make use of the function.  However that opens another set of issues,
        and as someone on mutt-users said is solving a problem no one has
        complained about.
        
        For now, I think <display-message> is the best choice outside of
        displaying an error message, so make it do that.

M	curs_main.c

2021-09-18 13:52:45 -0700  Kevin McCarthy  <kevin@8t8.us> (c1c94be1)

        * Use km_error_key() in index only for OP_NULL.
        
        Like other menus, just ignore unimplemented functions.

M	curs_main.c

2021-09-07 12:55:23 -0700  Kevin McCarthy  <kevin@8t8.us> (960afab4)

        * Generate URLs with user/password as parsed.
        
        This helps ensure they match for browser sticky-cursor, sidebar, and a
        few other places where a path is compared against
        something (e.g. $trash).
        
        Add two flags that track if the user/password came from the parsed
        URL.  If they were instead added to the account via $imap_user or
        $imap_pass, don't include those when generating a URL string as
        output.
        
        Change LSUB to also include the password, if present in the original
        connection URL.

M	account.c
M	account.h
M	imap/command.c
M	imap/util.c

2021-09-06 13:17:18 -0700  Kevin McCarthy  <kevin@8t8.us> (8bb11afe)

        * Ensure embedded IMAP passwords are stored in context->path.
        
        Without this, IMAP autoreconnect, background-edit Fcc, browser
        sticky-cursor, and sidebar "current" selection may not work properly.
        
        Change imap_qualify_path() to preserve the password if it is present
        in IMAP_MBOX for the generated URL.
        
        In almost all cases, DT_PATH types are run through
        mutt_pretty_mailbox(), which filters out the passwords, before
        displaying them in the UI.
        
        However there are a few cases where the context->path is displayed
        directly.  Create a new function, mutt_buffer_remove_path_password()
        to remove it and display that instead.

M	browser.c
M	imap/imap.h
M	imap/util.c
M	muttlib.c
M	mx.c
M	protos.h

2021-09-13 04:06:02 +0200  Vincent Lefevre  <vincent@vinc17.net> (d7d7b4b3)

        * Updated French translation.

M	po/fr.po

2021-09-10 13:25:58 -0700  Kevin McCarthy  <kevin@8t8.us> (49943c2a)

        * Merge branch 'stable'

2021-09-09 09:24:51 -0700  Kevin McCarthy  <kevin@8t8.us> (395a5a1d)

        * Merge branch 'stable'

2021-08-31 11:26:07 -0700  Kevin McCarthy  <kevin@8t8.us> (a6d83ff6)

        * Fix yesorno help prompt printing of choice.
        
        Commit d0b9bec8 added a '?' choice to print the variable controlling
        the prompt.  However, it didn't properly relocate the cursor after
        hitting '?'.  Make sure the "yes" or "no" is echoed in the collapsed
        MessageWindow.

M	curs_lib.c

2021-08-31 11:23:27 -0700  Kevin McCarthy  <kevin@8t8.us> (7358075a)

        * Add $compose_confirm_detach_first, default set.
        
        With the default keymap, hitting 'D' in the compose menu will remove
        parts and unlink owned files.  Mutt prevents removing all the parts,
        but if you have added attachments, this makes it very easy mis-type
        and accidentally nuke the message you've been composing.
        
        This option only checks for the first part - which is highly likely
        the main composed message.  It might be possible to try and make the
        check more intelligent, but I think a simple check will go a long way
        towards preventing disaster.

M	compose.c
M	init.h
M	mutt.h

2021-08-30 11:08:48 -0700  Kevin McCarthy  <kevin@8t8.us> (a5335121)

        * Add a comment about msn_seqset generation and header cache holes.

M	imap/message.c

2021-08-25 16:00:31 -0400  Craig Gallek  <cgallek@gmail.com> (f0ff78a5)

        * Use cms utility for SMIME encryption/decryption.
        
        The openssl smime utility only supports RSA keys for encryption (more
        specifically, the PKCS7 container that it uses can't be used with other
        key types).  The cms utility supports newer versions of the SMIME RFCs,
        including the use DH ephemeral-static algorithms for encrypting the
        symmetric key used during message encryption.
        
        This patch updates the suggested encryption/decryption commands, but
        does not change any of the commands used for signature
        generation/verification (as the smime sign/verify commands do support
        other key types).
        
        Debian seems to have already made this change[1] for the decryption path
        a while ago, but did not update the encryption command (current Debian
        patch for this file[2]).  There is a slight danger of updating the
        decryption command at the same time as the encryption command (as
        clients still trying to decrypt with smime could have problems reading
        messages encrypted with cms), but the existence of that Debian bug seems
        to imply that there is already a source of messages using the newer CMS
        format.
        
        I verified that I am now able to encrypt a message with public key type
        id-ecPublicKey.  Previously, this resulted in an error like:
        "encryption not supported for this key type:pk7_lib.c"
        
        [1] https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=639533
        [2] https://sources.debian.org/patches/mutt/2.0.5-4.1/misc/smime.rc.patch/
        
        Signed-off-by: Craig Gallek <cgallek@gmail.com>

M	contrib/smime.rc

2021-08-24 13:18:22 -0700  Kevin McCarthy  <kevin@8t8.us> (27e61da5)

        * Merge branch 'stable'

2021-08-24 12:50:53 -0700  Kevin McCarthy  <kevin@8t8.us> (fa5f8810)

        * Merge branch 'stable'

2021-08-24 15:17:05 +0200  Vincent Lefevre  <vincent@vinc17.net> (67c16b7c)

        * Improve conststrings.c generation, mainly for GNU Autoconf 2.71.
        
        With GNU Autoconf 2.71, the "ac_cs_config=" line in config.status may
        contain sequences like '\'' when a configure argument has spaces in it,
        for instance CFLAGS with several options. Thus it is not sufficient to
        get this line with grep; one needs to eval it and output the result.
        
        GNU Autoconf 2.69 was including the whole $ac_cs_config value inside
        double quotes, and the previous code also had issues with configure
        arguments containing special characters (but spaces were fine).

M	Makefile.am

2021-08-24 02:29:55 +0200  Vincent Lefevre  <vincent@vinc17.net> (898eb3ca)

        * Updated French translation.

M	po/fr.po

2021-08-20 13:37:39 -0700  Kevin McCarthy  <kevin@8t8.us> (a7eabb26)

        * Merge branch 'stable'

2021-08-20 20:43:41 +0100  Edmund Grimley Evans  <edmund.grimley.evans@gmail.com> (2adf634c)

        * Update Esperanto translation.

M	po/eo.po

2021-08-16 18:41:23 -0700  Kevin McCarthy  <kevin@8t8.us> (4cce210a)

        * Add robustness checks to file attach functions.
        
        The compose fix in stable prevented an issue trying to attach a NULL
        filename, but the functions are called in other places.  For
        robustness sake, add checks to the functions too.

M	sendlib.c

2021-08-16 18:34:00 -0700  Kevin McCarthy  <kevin@8t8.us> (b7128e2a)

        * Merge branch 'stable'

2021-08-11 15:02:30 -0400  Craig Gallek  <cgallek@gmail.com> (3003857c)

        * Prompt for password when using encrypted client certificate
        
        This already worked when compiled against openssl, but not with gnutls.
        
        Signed-off-by: Craig Gallek <cgallek@gmail.com>

M	mutt_ssl_gnutls.c

2021-08-14 15:38:20 -0700  Kevin McCarthy  <kevin@8t8.us> (c9fa0414)

        * Lazily update header colors after a thread-flag update.
        
        Although there are other issues with threads and ~() color patterns,
        this helps with collapsed thread coloring.  The thread-flag update can
        change the matching pattern, but that should be determined after all
        the thread messages are changed.
        
        For example, a collapsed thread with deleted messages and a color
        pattern '~v ~(~D)' should display differently after <undelete-thread>.
        Changing it to update colors lazily allows correct coloring (for that
        case).

M	flags.c
M	mutt.h
M	protos.h
M	score.c

2021-08-03 11:08:22 -0700  Kevin McCarthy  <kevin@8t8.us> (5aa75ed2)

        * Add $sort_thread_groups for top-level thread sorting.
        
        closes #368.
        
        Rename THREAD->sort_key to sort_aux_key, to make the fields more
        distinct.  Add THREAD->sort_group_key for caching the top-level sort
        HEADER.  An additional value is needed to allow propagating up values,
        for place-holder threads, and for "last" sort handling.
        
        Add recalc_aux_key and recalc_group_key bits to THREAD, in addition to
        sort_children.  These are used to allow separate flagging of either
        the group key or aux key needing to be recalculated.  Adding these two
        fields helped me keep better track of how the subthread sorting was
        working, because I'm just not as smart the people who originally wrote
        the threading code.  :-)
        
        Fix up some of the logic with rescoring, and "first_message" to take
        the new config vars into account.
        
        Add %T expando to $status_format, and change the default to
        conditionally show the value based on whether $sort is "threads" and
        $sort_thread_groups is not "aux".
        
        Lastly, a thank you to Eric Blake.  He implemented separate
        thread/subthread sorting in the NeoMutt code, after suggesting it on
        the #mutt IRC channel a couple months ago.  When ticket 368 was opened
        he pointed me at his work and offered to port.  However, I couldn't
        pass up the opportunity to learn more about the thread code myself, so
        I declined his offer.
        
        Although no copy/pasting was done, the basic of structure of the
        mutt_sort_subthreads() changes is the same, and I did look at his
        modifications to the function for guidance.  Thank you Eric!

M	compose.c
M	curs_main.c
M	init.c
M	init.h
M	mutt.h
M	score.c
M	sort.h
M	status.c
M	thread.c

2021-07-31 18:34:28 -0700  Kevin McCarthy  <kevin@8t8.us> (b879daa7)

        * Make index sort compare functions independent from config variables.
        
        Previously, the various compare functions used the macros AUXSORT and
        SORTCODE internally.  Those macros performed auxilliary sort using the
        AuxSort global, and also directly referenced SortAux and Sort to
        determine whether to reverse the result.
        
        This made the compare functions inflexible to handle other uses, such
        as $sort_thread_groups, which will be introduced in the next commit.
        
        Instead, introduce helper functions in sort.c and thread.c that call
        the compare functions, and have their own logic for auxilliary sort
        and reverse.
        
        Remove the no longer needed Sort=SortAux assignment around thread
        sorting, and change mutt_sort_subthreads() to reference SortAux
        instead.

M	sort.c
M	thread.c

2021-07-28 15:44:57 -0700  Kevin McCarthy  <kevin@8t8.us> (02298c19)

        * Improve generic menu type handling.
        
        Some of the menus are directly of MENU_GENERIC type.  In a few places,
        Mutt handles those inefficiently or slightly incorrectly.
        
        Remove double "generic" lookups when Mutt is in a generic menu.
        
        Fix the help menu to not show unbound or "generic bindings" for a
        generic menu.
        
        For exec completion, always add generic functions to the possible
        completion list.

M	help.c
M	init.c
M	keymap.c

2021-07-25 14:45:56 -0700  Kevin McCarthy  <kevin@8t8.us> (4021ab59)

        * Break the menu OPS/funcs and keybindings into separate tables.
        
        Move the "extra" keybindings added manually inside km_init() into the
        keybinding tables instead.
        
        This allows the documentation in the manual to be generated correctly.
        
        It also corrects a small problem with duplicate OPS in the struct
        binding_t table.  The exec completion and unbound list in the help
        menu iterated the active binding_t table and assumed each OP appears
        only once.  When '\n' and '\r' were both added to the binding_t table,
        this broke the assumption and caused those to misbehave.

M	doc/gen-map-doc
M	functions.h
M	help.c
M	init.c
M	keymap.c
M	keymap.h

2021-07-22 15:44:42 -0700  Kevin McCarthy  <kevin@8t8.us> (f4ff768c)

        * Enable nonl() mode for ncurses.  closes #362.
        
        This patch is based on the patch from Mike Frysinger, archived from
        the old trac system at:
        https://gitlab.com/muttmua/trac-tickets/-/blob/master/attachments/3494/mutt-enter-return-hg-6658.patch
        
        This version creates a new key symbol, <KeypadEnter> for the KEY_ENTER
        value returned by getch().  According to Vincent Lefèvre's research,
        that corresponds to the "key pad" Enter key.  If KEY_ENTER is not
        defined, it binds the symbol to "\n".  It does this after the
        KeyNames[] definitions of <Enter> and <Return> so they remain the
        default shown by <what-key>.
        
        Since Mutt already accepts KEY_ENTER at the y/n prompt, add it for all
        the built-in operations too.
        
        Bindings with "\r" and "\n" in the binding_t structures don't need
        "<enter>" and "<return>" to be re-specified in km_init(), so remove
        those.  Instead add the "<KeypadEnter>" bindings there.
        
        Remove unnecessary Alias menu bindings for OP_GENERIC_SELECT_ENTRY in
        km_init().
        
        As a note: I don't believe non-extended key symbol bindings need to be
        bound inside km_init().  I'm not clear why this was done, or what
        purpose it serves.  I'll do a bit more research, but if I can't
        uncover any issues, will move them inside the binding_t structures in
        another commit.

M	doc/gen-map-doc
M	doc/manual.xml.head
M	functions.h
M	keymap.c
M	main.c
M	mutt_curses.h

2021-07-22 12:12:15 -0700  Kevin McCarthy  <kevin@8t8.us> (e0232be7)

        * Revert "Silence strfcpy() warning in dotlock_deference_symlink()."
        
        This reverts commit 8970a4793c302c0bb8619a5dde56c8ca8de20532.
        
        I didn't like making this nonsensical change, just to silence the
        compiler.  The last commit should turn off the warning for systems
        with memccpy().

M	dotlock.c

2021-07-22 12:10:16 -0700  Kevin McCarthy  <kevin@8t8.us> (2caacce6)

        * Use memccpy() in the strfcpy macro if it's available.
        
        Thanks to Ian Collier for making this suggestion!
        
        It's more efficient and disables unhelpful compiler warnings about
        strncpy(), since strfcpy is terminating the string itself.
        
        If memccpy() is unavailable, use strncpy() but keep the old behavior
        of strncpy() length C instead of C-1, as I believe it tickles less
        compiler warnings.
        
        Add parenthesis around macro parameter uses, to be safe.  Thanks to
        Vincent Lefèvre for pointing that out.

M	configure.ac
M	dotlock.c
M	lib.h

2021-07-22 11:57:32 +0200  Vincent Lefevre  <vincent@vinc17.net> (abd78fb4)

        * Fix typo in comment and function name: deference -> dereference.

M	dotlock.c

2021-07-21 13:26:25 -0700  Kevin McCarthy  <kevin@8t8.us> (8970a479)

        * Silence strfcpy() warning in dotlock_deference_symlink().
        
        The compiler is being a bit strange, only picking out and warning
        about the 'strfcpy (d, pathptr, l);' line at the bottom of the
        function, even though the source and dest are the same size.
        
        It seems a shame to leave just this last one, since all the other
        warnings (at least on Debian) have been vanquished.
        
        So, to calm the compiler down, "russian doll" the buffer size down the
        call stack "dotlock_dispatch() -> dotlock_prepare() ->
        dotlock_deference_symlink()".

M	dotlock.c

2021-07-19 10:21:16 -0700  Kevin McCarthy  <kevin@8t8.us> (3f9e99b2)

        * Add dprint for a backtick expansion with non-0 exit code.
        
        We don't want to abort, because that would change long-standing
        behavior, and in some circumstances a non-0 exit code might be
        expected.
        
        However, to make a potential unexpected problem easier to debug, add a
        dprint.
        
        This is also the behavior of mutt_FormatString() for a format pipe.

M	init.c

2021-07-17 15:34:41 -0700  Kevin McCarthy  <kevin@8t8.us> (1588a078)

        * Use SEEK_SET and SEEK_END for fseek/fseeko whence parameter.
        
        Thanks to Vincent Lefèvre for pointing out the incorrect usage.  POSIX
        does not specify the actual values (although they are evidently
        commonly in use).

M	attach.c
M	buffy.c
M	copy.c
M	crypt-gpgme.c
M	crypt.c
M	edit.c
M	handler.c
M	listmenu.c
M	mbox.c
M	pager.c
M	parse.c
M	pattern.c
M	pgp.c
M	postpone.c
M	sendlib.c
M	smime.c

2021-07-16 14:00:01 -0700  Kevin McCarthy  <kevin@8t8.us> (df727efb)

        * Rewrite mutt_apply_replace() to use buffers.
        
        This removes the size truncation limit.  It also removes a compiler
        warning about strncpy truncation.

M	muttlib.c

2021-07-13 14:43:47 -0700  Kevin McCarthy  <kevin@8t8.us> (f80f3ea1)

        * Increase scratch buf size in mutt_canonical_charset().
        
        This siliences warnings about the destination being smaller than the
        source when copying.

M	charset.c

2021-07-13 14:27:30 -0700  Kevin McCarthy  <kevin@8t8.us> (a6047765)

        * Change hdrline make_from(_addr) to use snprintf for from.
        
        The other fields all use snprintf().  For some reason the strfcpy in
        this case is tickling a compiler warning, so change the from to use
        snprintf too.

M	hdrline.c

2021-07-13 13:15:38 -0700  Kevin McCarthy  <kevin@8t8.us> (658e8e94)

        * Silence compiler warning in _mutt_buffer_select_file().
        
        Using a constant offset apparently allows the compiler to be smart
        enough to detect a potential problem, but it isn't smart enough to see
        we've already determined lastdirlen is non-zero.

M	browser.c

2021-07-12 19:40:08 -0700  Kevin McCarthy  <kevin@8t8.us> (6ecdb091)

        * Use memcpy in fseek_last_message() instead of strncpy.
        
        We are copying raw bytes and don't care about embedded nuls, so
        eliminate a compiler warning by using memcpy.  BUFSIZ is guaranteed to
        be at least 256.
        
        Adjust the weird BUFSIZ + 9 size, which was added by an old commit
        86f376dc that appears to have been a dead end.  Also remove the no
        longer relevant comment next to the strncpy.
        
        Although it may be "safer" to use strlen() for the mutt_strncmp()
        parameter, the code is performing this comparison over and over.  We
        already hardcode 7 in the buffer size and memcpy.  So, make this loop
        faster by hardcoding it here too.

M	buffy.c

2021-07-12 18:22:42 -0700  Kevin McCarthy  <kevin@8t8.us> (9b0a2631)

        * Fix mutt_sasl buffer size to hold ip_port strings.
        
        The output buffer wasn't quite big enough to hold the maximum size
        input buffer.

M	mutt_sasl.c

2021-07-12 18:06:01 -0700  Kevin McCarthy  <kevin@8t8.us> (10ef9aae)

        * Silence imap_make_date() warning by switching to a BUFFER.

M	imap/imap_private.h
M	imap/message.c
M	imap/util.c

2021-07-12 17:39:00 -0700  Kevin McCarthy  <kevin@8t8.us> (1977fbb4)

        * Silence compiler "may be uninitialized" warnings.
        
        For both of these cases, there is no actual bug.  But set them to 0 to
        make the compiler happy.

M	copy.c
M	imap/message.c

2021-07-17 15:13:44 -0700  Kevin McCarthy  <kevin@8t8.us> (2803adb2)

        * Merge branch 'stable'

2021-07-12 11:03:58 -0700  Kevin McCarthy  <kevin@8t8.us> (a1e71e64)

        * Merge branch 'stable'

2021-07-12 10:41:50 -0700  Kevin McCarthy  <kevin@8t8.us> (d5e626ce)

        * Merge branch 'stable'

2021-07-09 17:52:32 +0200  Vincent Lefevre  <vincent@vinc17.net> (2a9220b2)

        * Updated French translation.

M	po/fr.po

2021-07-09 06:09:48 -0700  Kevin McCarthy  <kevin@8t8.us> (6e7b6436)

        * Merge branch 'stable'

2021-07-06 13:12:50 -0700  Kevin McCarthy  <kevin@8t8.us> (d0b9bec8)

        * Add a help choice '?' to the yes or no prompt for quadoptions.
        
        The prompt currently just prints "See $%s for more information." where
        %s is the variable name.  This will at least give a pointer to what
        variable can be adjusted to change the prompt behavior.
        
        A handful of boolean variables also control prompt display.  Add a
        help choice for those too using the function mutt_query_boolean().

M	crypt-gpgme.c
M	curs_lib.c
M	curs_main.c
M	imap/imap.c
M	imap/message.c
M	init.c
M	muttlib.c
M	pgp.c
M	protos.h

2021-07-01 14:20:17 -0700  Kevin McCarthy  <kevin@8t8.us> (ab6bbb5b)

        * Filter out group delimiters for encrypt keylist generation.
        
        The group display-name and end delimiter shouldn't be included when
        generating the keylist.
        
        Also, filter them out for autocrypt operations.

M	autocrypt/autocrypt.c
M	crypt.c
M	protos.h
M	sendlib.c

2021-07-01 07:36:40 +0200  Aitor Soroa  <a.soroa@gmail.com> (9923ee67)

        * contrib/markdown2html: properly deal with lead-ins
        
        When matching lead-ins, make sure they are not quoted.

M	contrib/markdown2html

2021-07-01 07:34:34 +0200  Aitor Soroa  <a.soroa@gmail.com> (6943c01d)

        * contrib/markdown2html: properly deal with missing context
        
        Check that the proper variables exist e.g. "if prev is not None" instead of "if not prev". The latter causes malcfunctions when the variable is an e,pty string.

M	contrib/markdown2html

2021-07-01 07:49:50 +0200  Aitor Soroa  <a.soroa@gmail.com> (f891746f)

        * contrib/markdown: fix bug when dealing with quotelead classes
        
        The script tries to match previously written '<p>{.quotelead}' string
        without success, as '<p>' gets converted to '&lt;p&gt;' when creating the
        HTML version.

M	contrib/markdown2html

2021-06-30 20:25:45 +0200  Vincent Lefevre  <vincent@vinc17.net> (9888ab2f)

        * Exit with a failure for any usage or version write error.

M	main.c

2021-06-30 17:04:20 +0200  Vincent Lefevre  <vincent@vinc17.net> (1d2061b2)

        * Really fix usage and version write error checking.
        
        This had to be done for 'mutt -vv' too (in addition to -h and -v).
        No longer set errno = 0, unneeded due to the ferror() test.
        See issue #358.

M	main.c

2021-06-30 13:50:23 +0200  Vincent Lefevre  <vincent@vinc17.net> (768ba86a)

        * Fix usage and version write error checking.
        
        "fflush (stdout)" is needed to detect most errors (only a closed stdout
        could be detected otherwise). A ferror test is also needed to avoid
        false positives since the C standard allows errno to be set even in
        the absence of errors.

M	main.c

2021-06-29 13:23:09 -0700  Kevin McCarthy  <kevin@8t8.us> (e6bcc2de)

        * Add usage and version write error checking.
        
        'mutt -v' and 'mutt -h' did not check to ensure output actually
        printed to stdout.
        
        Technically, this is a lazy check, because many things can set errno,
        and it only checks errno at the end, rather than the return value of
        each write call.  I'm compromising correctness for code readability in
        this case, given these are just help and version output commands.

M	main.c

2021-06-29 12:29:42 -0700  Kevin McCarthy  <kevin@8t8.us> (72fecfd6)

        * Check stdout is a terminal in curses mode.
        
        Mutt uses the standard initscr(), which writes to stdout.  Ensure it's
        available (e.g. hasn't been closed or redirected).

M	main.c

2021-06-28 15:11:24 -0700  Kevin McCarthy  <kevin@8t8.us> (b5359339)

        * Add a hard redraw after oauth authentication.
        
        The sample contrib program can use gpg to decrypt a token.  This may
        pop up a curses agent prompt, requiring a hard redraw.
        
        It may be that we should be calling a hard redraw after any fork/exec.
        I don't know if this will cause more problems, so for now I'll just
        patch this one place.  But that is something to consider.

M	account.c

2021-06-28 15:07:15 -0700  Kevin McCarthy  <kevin@8t8.us> (e985ad2a)

        * Fix classic pgp decrypt_part() hard redraw on error.
        
        Ensure the hard redraw is set even if the decryption fails.  The agent
        prompt still may have appeared.
        
        Since we don't need to set environment variables afterwards, directly
        check the OPTUSEGPGAGENT option for the post-check.

M	pgp.c

2021-06-20 14:33:36 -0700  Kevin McCarthy  <kevin@8t8.us> (5cc548e1)

        * Merge branch 'stable'

2021-06-18 14:53:12 -0700  Kevin McCarthy  <kevin@8t8.us> (80ed1d85)

        * Reset SIGPIPE signal handler in child process before exec().
        
        Ignored signals, such as SIGPIPE in Mutt, are inherited by child
        processes.  This can cause incorrect behavior in filter-like programs
        that expect SIGPIPE to be the default value of "Term".
        
        A couple other places in Mutt already reset SIGTERM, SIGTSTP, and
        SIGCONT, with a comment mentioning it really wasn't necessary.  Since
        I don't much like messing with signals, I'll leave those resets in.
        
        Extract those plus SIGPIPE into a new function,
        mutt_reset_child_signals() and add that before each exec call.
        
        Thanks to Vincent Lefèvre for reporting the issue and for the initial
        patch, which this commit is based upon.

M	background.c
M	filter.c
M	mutt_tunnel.c
M	protos.h
M	sendlib.c
M	signal.c
M	system.c

2021-06-13 15:56:58 +0200  Rene Kita  <mail@rkta.de> (9155c657)

        * Add $pager_skip_quoted_context option.
        
        Using <skip-quoted> the first unquoted line becomes the new top line
        displayed in the pager. This leaves the user with no context to know
        what the answer refers to.
        
        Add an option to keep some lines of context when using <skip-quoted>.
        
        With $pager_skip_quoted_context set to 5, <skip-quoted> will show at
        most 5 lines of the previous quote. If the previous quote is shorter
        than 5 lines the whole quote will be displayed.
        
        This option defaults to 0 to remain backwards compatible.

M	globals.h
M	init.h
M	pager.c

2021-06-17 02:08:09 +0200  Vincent Lefevre  <vincent@vinc17.net> (4595cdb6)

        * Updated French translation.

M	po/fr.po

2021-06-13 14:58:47 -0700  Kevin McCarthy  <kevin@8t8.us> (86700b01)

        * Suggested translation changes.
        
        These were forwarded to mutt-po by Helge Kreutzmann, from his
        translation team.
        
        I've added comments to a couple places where the meaning was unclear.

M	OPS
M	autocrypt/autocrypt.c
M	compose.c
M	edit.c
M	muttlib.c
M	pattern.c
M	pop.c

2021-06-13 14:16:44 -0700  Kevin McCarthy  <kevin@8t8.us> (94d0285c)

        * Merge branch 'stable'

2021-06-13 14:12:30 -0700  Kevin McCarthy  <kevin@8t8.us> (3cf7a149)

        * Directly add full mailbox to GPG search hints.
        
        The code previously called (crypt/pgp)_add_string_to_hints(), which
        performs a strtok() using " ,.:\"()<>\n" and discards parts of size 3
        or less.
        
        This makes sense for personal fields, and random "stuff" entered in
        the getkeybystr() prompt.  But it doesn't make a lot of sense for the
        mailbox.
        
        There's no advantage I can see in chopping off and discarding the
        domain name for getting more relevant results.
        
        Ordinarily, I wouldn't bother fixing this, but in ticket 354 someone
        is experimenting with alternative backends, and they would like the
        full email address listed in the hints.

M	crypt-gpgme.c
M	pgpkey.c

2021-12-30 12:47:09 -0800  Kevin McCarthy  <kevin@8t8.us> (6fbb59cf)

        * Update UPDATING file for 2.1.5.

M	UPDATING

2021-12-27 13:45:21 -0800  Kevin McCarthy  <kevin@8t8.us> (a89a677c)

        * Reflow pager when setting $wrap.
        
        I somehow missed $wrap when adding commit 0636c24b.
        
        Lineinfo needs to be recomputed since color matching can change with
        the line wrapping change.

M	init.h

2021-12-26 15:43:27 -0800  Kevin McCarthy  <kevin@8t8.us> (c74cbba7)

        * Include <term.h> before invoking tigetstr() and tigetflag().
        
        On NetBSD, a segv was occurring in mutt_ts_capability() because
        tigetstr() was implicitly declared and thus defaulted to return type
        int.  The 8-byte (char *) actually returned was being converted to a
        4-byte int before being assigned to the (char *) variable.  This
        resulted in a corrupted pointer, causing a segv when dereferenced.
        
        I thought C99+ should warn about implicit declarations.  Although
        configure.ac AC_PROG_CC_C99 asserts the compiler can handle C99,
        perhaps it doesn't put the compiler in the mode to strictly enforce
        it.  (Thanks to rkta on IRC for the input).
        
        The solution, as the man page notes, is to include <term.h> before
        invoking those functions.
        
        Unfortunately term.h pollutes the namespace with all sorts of defines.
        Currently that include columns and lines, which are used inside Mutt.
        
        To help prevent issues, create Mutt wrappers for the functions and
        split them into a separate file, curs_ti_lib.c, that #include
        <term.h>, rather than just adding #include <term.h> to mutt_curses.h
        
        Apparently on some older platforms, #include <curses.h> would also
        include term.h, so make sure columns in undef'ed in mutt_curses.h.  (I
        think we would have heard about that problem already, but just in
        case.)
        
        A huge thank you to rahl on IRC for debugging this issue, and working
        with me over IRC to test various suggestions until the issue was
        found.  I didn't have access to a NetBSD instance, so rahl saved me
        much time and effort, and was crucial to fixing this bug.

M	Makefile.am
M	configure.ac
M	curs_main.c
A	curs_ti_lib.c
M	keymap.c
M	mutt_curses.h
M	po/POTFILES.in

2021-12-24 21:12:58 -0800  Kevin McCarthy  <kevin@8t8.us> (f58795c9)

        * Fix mutt_ts_capability() fallback list loop.
        
        The for loop termination check should be '*termp', not 'termp'.  termp
        starts as &known[0], so to check for the NULL terminator, we need to
        look at *termp.
        
        Since *termp is now checked in each loop, it no longer needs to be in
        the if check inside the loop, so remove it there.
        
        This hasn't been blowing up because the mutt_strncasecmp() check
        inside the loop was also incorrect.  It should be scanning for a
        matching entry, but was looking for non-zero (nonmatching) retval.
        Since term can't match both the first and second entries, it would
        always return 1 and would never get to the loop NULL terminator.

M	curs_main.c

2021-12-20 14:13:29 -0800  Kevin McCarthy  <kevin@8t8.us> (c60ffa27)

        * Fix SMTP response text potential buffer overread.
        
        mutt_socket_readln() returns the number of bytes, including the '\0'.
        smtp_code() only verifies 4 bytes (or a minimum strlen() of 3).
        
        The smtp_get_resp() and smtp_auth_sasl() were both looking at "buf+4"
        without verifying the string went past "buf+3".
        
        Note RFC 4954 and 5321 say there should be a trailing space on a
        response code with no text.  But if the server neglected that, buf+4
        would try to read or decode past the read data.

M	smtp.c

2021-12-13 19:31:04 -0800  Kevin McCarthy  <kevin@8t8.us> (5b318bc8)

        * Space unstuff flowed text for $send_multipart_alternative_filter.
        
        Mutt tries to hide the format=flowed stuff/unstuff processing from the
        user in other cases (when editing, viewing, piping, and printing, for
        instance).  It should also do this when piping the content to the
        alternative filter.

M	compose.c
M	protos.h
M	send.c
M	sendlib.c

2021-12-13 15:43:00 -0800  Kevin McCarthy  <kevin@8t8.us> (91474fdf)

        * Don't force SMTP authentication without a username or client cert.
        
        See Debian bug 1001013.  This is a regression from commit 191b0513,
        which fixed SMTP client certification authentication (see GitLab
        ticket 336).  However, that commit assumed the server wouldn't
        advertise AUTH if it wasn't needed, which the Debian ticket shows is
        not always the case.
        
        Client certificate support still relies on AUTH properly being set.
        
        Add a check for either the username or a cert before calling
        smtp_auth().  The username check was removed by the above mentioned
        commit, but more importantly the username is no longer set by the
        OpenSSL/GnuTLS client cert code.  (Which was the main problem
        addressed by the commit).  So there shouldn't be an issue with adding
        the username check back.

M	smtp.c

2021-12-11 13:15:27 -0800  Kevin McCarthy  <kevin@8t8.us> (93ef06ae)

        * automatic post-release commit for mutt-2.1.4

M	ChangeLog
M	VERSION

2021-12-11 13:11:39 -0800  Kevin McCarthy  <kevin@8t8.us> (138abb63)

        * Update UPDATING for 2.1.4.

M	UPDATING

2021-12-07 14:28:18 -0800  Kevin McCarthy  <kevin@8t8.us> (cc117960)

        * Loosen imap_open_mailbox() SELECT response data parsing.
        
        DavMail is putting more than one space between '*' and the EXISTS
        count, e.g. '*  5 EXISTS'
        
        Strictly speaking, this is disallowed by RFC3501 (see Section 9, Note
        2).  However, there is also no good reason for imap_open_mailbox() to
        be stricter than the untagged handler, which correctly extracts the
        count.
        
        Add a check to make sure we are looking at an untagged response, and
        then use imap_next_word() rather than just incrementing by two.
        
        Thank you to Michael Gernoth (@stargo) for debugging this issue,
        creating a merge request with a possible fix, and helping to test this
        commit.

M	imap/imap.c

2021-09-10 13:18:49 -0700  Kevin McCarthy  <kevin@8t8.us> (987dde4c)

        * automatic post-release commit for mutt-2.1.3

M	ChangeLog
M	VERSION

2021-09-10 13:12:50 -0700  Kevin McCarthy  <kevin@8t8.us> (a7d54a9f)

        * Update UPDATING for 2.1.3.

M	UPDATING

2021-09-08 09:29:09 -0700  Kevin McCarthy  <kevin@8t8.us> (a547111a)

        * Reduce sorting when expunging QRESYNC VANISHED records.
        
        There is no need to perform expensive sorting (e.g. by thread), which
        will just need to be done again after the mailbox is opened.

M	imap/message.c

2021-09-08 07:37:37 -0700  Kevin McCarthy  <kevin@8t8.us> (57c1017d)

        * Clean up more context fields on a QRESYNC reset.
        
        Reset ctx->size.
        
        Clear all hash structures.  Currently imap_expunge_mailbox() triggers
        a resort, which can populate some of these hashes.  The next commit
        will change that, but it's better to make sure there are no remnants
        in any hashes to avoid memory corruption.

M	imap/message.c

2021-09-08 04:15:11 -0700  Kevin McCarthy  <kevin@8t8.us> (1c819fd6)

        * QRESYNC: don't increment msn for missing headers.
        
        Commit 74ce032f moved the msn increment outside the check for a
        missing header.  The idea was that a header-cache hole needed to be
        accounted for.  However, a header can also be missing just by a VANISH
        happening the last time the mailbox was open.
        
        Since the header won't be in the uid_hash, cmd_parse_vanished() can't
        decrement subsequent msns, so it need to be done in this loop.
        
        If there is a header cache hole, or another problem, verify_qresync()
        will detect a problem and try again without QRESYNC.
        
        However if there were an actual stored "blank", do increment, since
        there was no UID to process a vanish on.

M	imap/message.c

2021-09-07 21:42:07 -0700  Kevin McCarthy  <kevin@8t8.us> (fa2fef46)

        * Fix compare_uid() to work with large UID values.
        
        The function was pulled from the other sort methods used in mutt.  But
        those don't work properly for a 32-bit unsigned value.  If the
        difference between two UID values is greater than a signed int can
        represent, it will sort improperly.
        
        Some of the other sort functions need to be fixed too, but that can be
        done in master.

M	imap/imap.c

2021-08-24 12:58:36 -0700  Kevin McCarthy  <kevin@8t8.us> (9a92dba0)

        * automatic post-release commit for mutt-2.1.2

M	ChangeLog
M	VERSION

2021-08-24 12:54:51 -0700  Kevin McCarthy  <kevin@8t8.us> (a86338a8)

        * Update UPDATING file for 2.1.2.

M	UPDATING

2021-08-21 18:42:33 -0700  Kevin McCarthy  <kevin@8t8.us> (74ce032f)

        * Preserve QRESYNC seqset holes when restoring from header cache.
        
        It's possible for there to be holes in the MSN sequence, and also in
        the header cache.  When iterating through the seqset, preserve those
        by incrementing msn even if the result isn't found in the header
        cache (because it is 0 or because the record is missing in the header
        cache).

M	imap/message.c

2021-08-21 14:55:43 -0700  Kevin McCarthy  <kevin@8t8.us> (b0f54225)

        * Don't include inactive messages in msgset generation.
        
        Currently only deleted messages that will be expunged are marked
        inactive, so it shouldn't be an issue.  However, before the previous
        commit (changing sorting by UID), I think there was a possibility for
        a bug if trailing expunge-marked messages with MAXINT index were also
        marked inactive.
        
        The sort change fixes that, but to make the code clearer just remove
        the possibility of inactive messages being included.

M	imap/imap.c

2021-08-21 13:00:12 -0700  Kevin McCarthy  <kevin@8t8.us> (647efbd1)

        * Sort headers by UID when generating a msgset sequence.
        
        When there is a hole in the header cache, the UID numbers are no
        longer guaranteed to increase with the index.  This can result in
        incorrect msgset values being sent to the server.
        
        Thanks to Pieter-Tjerk de Boer for reporting this problem, with a
        detailed description of the problem, and a suggested patch.
        
        Note to backporters:
        
        * this patch depends on the imap_disallow_reopen() added in commit
          6051760c2cf492ada1e06d910c0c2c05607c08bc for release 1.13.4.
        
        * the bug was introduced in release 1.9.0 so there is no need to
          backport earlier than that.

M	imap/imap.c
M	sort.h

2021-08-21 12:21:25 -0700  Pieter-Tjerk de Boer  <p.t.deboer@utwente.nl> (44f2619c)

        * Reset msn_begin on a QRESYNC failure retry.
        
        Since the msn_index will be regenerated differently, Mutt needs to
        scan for holes again.

M	imap/message.c

2021-08-20 13:28:55 -0700  Kevin McCarthy  <kevin@8t8.us> (a54bb201)

        * Properly free mail_followup_to when resending a message.
        
        This one has been in the code for quite a while!  Use the address free
        function to free all the parts instead of just FREE().

M	postpone.c

2021-08-16 18:31:11 -0700  Kevin McCarthy  <kevin@8t8.us> (eda54c6b)

        * Improve attach files handling of empty value.
        
        Hitting enter at the attach files prompt will still allocate an entry
        in the attachment array.  It might make sense to "abort" inside the
        prompt for that case, but it's a change of behavior to have the prompt
        do so.
        
        Instead, have the compose menu prompt skip NULL values.

M	compose.c

2021-07-13 14:44:29 -0700  Kevin McCarthy  <kevin@8t8.us> (6c0f75cc)

        * Fix strfcpy copy size in mutt_get_default_charset().
        
        If AssumedCharset contained a ':', the value could be larger than
        fcharset.  Ensure it's properly truncated.
        
        This also fixes a compiler warning.

M	charset.c

2021-07-13 14:30:33 -0700  Kevin McCarthy  <kevin@8t8.us> (19bdc79f)

        * Use strfcpy for edit_envelope() user-header subject.
        
        strncpy could leave an untruncated string.

M	send.c

2021-07-13 14:22:38 -0700  Kevin McCarthy  <kevin@8t8.us> (6637beb9)

        * Fix mutt_label_message to use strfcpy().
        
        strncpy could leave an unterminated string.

M	headers.c

2021-07-12 10:56:15 -0700  Kevin McCarthy  <kevin@8t8.us> (e2a89abc)

        * automatic post-release commit for mutt-2.1.1

M	ChangeLog
M	VERSION

2021-07-12 10:47:48 -0700  Kevin McCarthy  <kevin@8t8.us> (878e0388)

        * Update UPDATING file for 2.1.1 release.

M	UPDATING

2021-06-28 15:11:24 -0700  Kevin McCarthy  <kevin@8t8.us> (27f0a450)

        * Add a hard redraw after oauth authentication.
        
        The sample contrib program can use gpg to decrypt a token.  This may
        pop up a curses agent prompt, requiring a hard redraw.
        
        It may be that we should be calling a hard redraw after any fork/exec.
        I don't know if this will cause more problems, so for now I'll just
        patch this one place.  But that is something to consider.

M	account.c

2021-06-28 15:07:15 -0700  Kevin McCarthy  <kevin@8t8.us> (4035e100)

        * Fix classic pgp decrypt_part() hard redraw on error.
        
        Ensure the hard redraw is set even if the decryption fails.  The agent
        prompt still may have appeared.
        
        Since we don't need to set environment variables afterwards, directly
        check the OPTUSEGPGAGENT option for the post-check.

M	pgp.c

2021-07-09 11:49:26 +0200  Alexander Sulfrian  <asulfrian@zedat.fu-berlin.de> (94f5f35a)

        * listmenu: Fix parsing of list headers for mbox
        
        The parsing of the headers needs to skip the "From " lines at the start
        of the messages in mbox format. This now uses the same logic like
        mutt_read_rfc822_header in parse.c.

M	listmenu.c

2021-06-19 14:08:59 -0700  Kevin McCarthy  <kevin@8t8.us> (f5ccd687)

        * Fix menu.c sigwinch handling order.
        
        This fixes problems with a sigwinch that occurs during an external
        process, such as during a query menu lookup, or after exiting the
        background-edit landing page.  Without this change, the user would see
        a misdrawn screen and would need to press a key first.
        
        Change it so that the SigWinch flag is handled before reading input,
        so that the page is automatically redrawn.  This matches the behavior
        in the index, pager, and background-edit process list menu.

M	menu.c

2021-06-13 14:16:06 -0700  Kevin McCarthy  <kevin@8t8.us> (e1dfc2c4)

        * Fix getkeybyaddr() debug output.
        
        Add a NONULL wrapper and a newline at the end.

M	crypt-gpgme.c
M	pgpkey.c

2021-06-12 12:38:19 -0700  Ivan Vilata i Balaguer  <ivan@selidor.net> (9629d5d6)

        * Update Catalan translation.

M	po/ca.po

2021-06-12 10:48:43 -0700  Kevin McCarthy  <kevin@8t8.us> (4b100969)

        * automatic post-release commit for mutt-2.1.0

M	ChangeLog
M	VERSION
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2021-06-12 10:40:18 -0700  Kevin McCarthy  <kevin@8t8.us> (bfccf9c6)

        * Update UPDATING file for 2.1.0 release.

M	UPDATING

2021-06-07 10:15:24 -0700  Vsevolod Volkov  <vvv@mutt.org.ua> (0b2be236)

        * Updated Russian translation.

M	po/ru.po

2021-06-07 10:14:14 -0700  Vsevolod Volkov  <vvv@mutt.org.ua> (6b458ebd)

        * Updated Ukrainian translation.

M	po/uk.po

2021-06-05 13:49:57 -0700  Kevin McCarthy  <kevin@8t8.us> (e8792708)

        * Minor UPDATING file fixes.

M	UPDATING

2021-06-05 13:48:05 -0700  Kevin McCarthy  <kevin@8t8.us> (bab86bf4)

        * Mention <browse-mailboxes> in the new-mail documentation.
        
        Add to the sentence mentioning '-y'.

M	doc/manual.xml.head

2021-06-03 10:40:22 +0200  Grzegorz Szymaszek  <gszymaszek@short.pl> (6a7f32a6)

        * Update the Polish translation for Mutt 2.1

M	po/pl.po

2021-05-31 16:55:39 +0200  Petr Písař  <petr.pisar@atlas.cz> (732efe2e)

        * Update Czech translatation for mutt-2.1.0

M	po/cs.po

2021-05-30 10:20:50 -0700  Helge Kreutzmann  <debian@helgefjell.de> (f0a64564)

        * Update de.po.

M	po/de.po

2021-05-29 12:39:25 -0700  Helge Kreutzmann  <debian@helgefjell.de> (b37d5aa1)

        * Update de.po.

M	po/de.po

2021-05-29 12:38:04 -0700  Kevin McCarthy  <kevin@8t8.us> (c728976c)

        * Revert "Update de.po."
        
        This reverts commit e450615f5b0a77539916d9e8542c9a64bca73c09.
        
        Author was not properly attributed.  Will reapply with author set.

M	po/de.po

2021-05-29 12:14:30 -0700  Kevin McCarthy  <kevin@8t8.us> (e450615f)

        * Update de.po.

M	po/de.po

2021-05-28 21:21:32 +0200  Flammie Pirinen  <flammie@iki.fi> (3d24855d)

        * Update Finnish translation

M	po/fi.po

2021-05-28 20:48:58 +0200  Eike Rathke  <erack@erack.de> (36fb911f)

        * Do not set From reverse name on postponed or to be resend messages
        
        Messages to be resend or resumed from postponed already had
        reverse names and alternates evaluated the first time they entered
        the compose menu and send-hook were already executed then. The
        user may also had edited the From to any other content before
        postponing or sending the message. Upon resuming, do not overwrite
        with a reverse_name lookup and do not remove the real name if
        reverse_realname=no is set.
        
        This restores the old behaviour and fixes the regression
        introduced with
        
            commit 961cf4bed679d9495cc3682d18496a53061d4581
            CommitDate: Mon Feb 1 14:00:56 2021 -0800
        
                Apply $reverse_name when tag-reply/forwarding too.

M	send.c

2021-05-28 20:29:03 +0300  Emir Sarı  <bitigchi@me.com> (ddd292b8)

        * Update Turkish translations

M	po/tr.po

2021-05-28 14:23:37 +0200  Greg Kroah-Hartman  <greg@kroah.com> (88845a41)

        * fix gcc-11 build warnings for H_TO_INTL()
        
        The macro H_TO_INTL() in mutt_idna.c, causes a lot of build warnings
        about the indentation of the if () line to try to warn the developer
        that it looks like this might be a bug:
        
        mutt_idna.c: In function ‘mutt_env_to_intl’:
        mutt_idna.c:327:5: warning: this ‘if’ clause does not guard... [-Wmisleading-indentation]
          327 |     if (tag) *tag = #a; e = 1; err = NULL;              \
              |     ^~
        mutt_idna.c:333:3: note: in expansion of macro ‘H_TO_INTL’
          333 |   H_TO_INTL(return_path);
              |   ^~~~~~~~~
        mutt_idna.c:327:25: note: ...this statement, but the latter is misleadingly indented as if it were guarded by the ‘if’
          327 |     if (tag) *tag = #a; e = 1; err = NULL;              \
              |                         ^
        mutt_idna.c:333:3: note: in expansion of macro ‘H_TO_INTL’
          333 |   H_TO_INTL(return_path);
              |   ^~~~~~~~~
        
        This goes on for many lines.
        
        Fix this up by properly indenting the lines so that gcc "knows" we mean
        well here.

M	mutt_idna.c

2021-05-28 14:38:41 +0300  Maxim Tarasov  <mu@magi.net.ru> (76276257)

        * Trim the ToC for the option list in the manual
        
        Currently, every variable is shown in the table of contents of the
        reference manual. Variable list is over 400 items long. This makes the
        ToC difficult to work with.
        
        Removing is done by adding an overwriting template for the parent of
        variables section (that is sect1 tag with id="variables"). In the
        DocBook source matching template calls another template named subtoc
        with two parameters: context (self element) and nodes (child
        sections). Normally a list of descendant nodes is passed here, but we
        don't want that and instead call subtoc with no parameters.
        
        This approach results in semantically correct code being generated in
        all modes.
        
        Note, that the ID (variables) will have to be kept in sync with XML
        generating code, but that is already hardcoded elsewhere.

M	doc/TODO
M	doc/mutt.xsl

2021-05-26 15:41:40 -0700  Kevin McCarthy  <kevin@8t8.us> (f60882fc)

        * Add debug statements around $hostname setting.
        
        This will make slowdowns due to DNS issues more obvious.

M	init.c

2021-05-26 15:30:20 -0700  Kevin McCarthy  <kevin@8t8.us> (30aea067)

        * Add draft 2.1.0 notes to UPDATING file.

M	UPDATING

2021-05-23 11:20:54 -0700  Kevin McCarthy  <kevin@8t8.us> (ff7c68cc)

        * Merge branch 'stable'

2021-05-23 11:19:02 -0700  Kevin McCarthy  <kevin@8t8.us> (9f40cc39)

        * Update irc channel to libera.chat.

M	doc/manual.xml.head

2021-05-14 18:55:00 -0600  Gregory Anders  <greg@gpanders.com> (4c786d87)

        * Add local_date_header option
        
        Add an option to convert the date used in the Date header into the local
        (sender's) timezone. This is the current behavior and the option
        defaults to true. Unsetting this option causes the date in the Date
        header to be formatted using the GMT timezone.
        
        This option is useful for privacy-sensitive users who may not wish to
        divulge their sending timezone.

M	init.h
M	mutt.h
M	sendlib.c

2021-05-04 11:03:32 -0700  Kevin McCarthy  <kevin@8t8.us> (791fc1c6)

        * Merge branch 'stable'

2021-05-04 10:55:15 -0700  Kevin McCarthy  <kevin@8t8.us> (481f3800)

        * automatic post-release commit for mutt-2.0.7

M	ChangeLog
M	VERSION

2021-05-04 10:38:24 -0700  Kevin McCarthy  <kevin@8t8.us> (bd29a9a0)

        * Merge branch 'stable'

2021-04-28 12:57:53 -0700  Kevin McCarthy  <kevin@8t8.us> (b24a1a25)

        * Add comments to the 2231 decode blocks.

M	rfc2231.c

2021-04-30 18:55:37 -0700  Kevin McCarthy  <kevin@8t8.us> (a10d0bb5)

        * Add sanitize call in print mailcap function.
        
        The mutt_rfc1524_expand_filename() function calls mutt_adv_mktemp(),
        which also calls the sanitizer.
        
        However, if the recv-mode suggested filename has a slash, it's better
        to sanitize before calling expand_filename() too, to preserve the
        entire filename (albeit with the slashes sanitized out).
        
        For example (ignoring name templates) if the file were called
        "either/or.pdf", pre-sanitizing would generate "either_or.pdf", while
        not doing so would generate "or.pdf".

M	attach.c

2021-04-27 13:37:21 -0700  Kevin McCarthy  <kevin@8t8.us> (98f0ca6b)

        * Add allow_8bit flag to sanitize_filename functions.
        
        This will allow "view" mailcap invocations and autoview invocations to
        display something reasonable for international file names.  Also add
        the flag to mutt_adv_mktemp(), which the mailcap viewer calls.
        
        Convert the 'slash parameter' to an ALLOW_SLASH flag.  This makes the
        flags consistent (both "allow" something not permitted by default),
        and invocations more readable.

M	attach.c
M	handler.c
M	lib.c
M	lib.h
M	muttlib.c
M	pop.c
M	protos.h
M	rfc1524.c

2021-04-29 12:54:41 -0700  Kevin McCarthy  <kevin@8t8.us> (fdee288a)

        * Modify makedoc.pl to read sort maps for the default value.
        
        Use the map tables to print out a correct default value for sort
        types.
        
        Remove the unneeded SORT_ALPHA type, for $sort_browser documentation,
        since we can do the lookup now.

M	doc/makedoc.pl
M	init.h
M	sort.h

2021-04-28 13:28:14 -0700  Kevin McCarthy  <kevin@8t8.us> (23b77a20)

        * Arrange sort maps by value instead of name.
        
        The value-to-name mapping uses the first match.  Grouping by value
        makes it more obvious when there are duplicates and which one will be
        printed out, e.g. when querying the value of a variable.

M	init.h

2021-04-28 13:21:17 -0700  Kevin McCarthy  <kevin@8t8.us> (bee3474f)

        * Move sort maps before vars in init.h.
        
        This is so makedoc.pl can read in the maps and use them to properly
        print out default values for the sort options.

M	init.h

2021-04-28 11:16:50 -0700  Kevin McCarthy  <kevin@8t8.us> (acb2bdd4)

        * Merge branch 'stable'

2021-04-25 15:01:07 -0700  Kevin McCarthy  <kevin@8t8.us> (515a315c)

        * Mention ~B in $thorough_search documentation.
        
        It affects ~b, ~B, and ~h.

M	init.h

2021-04-25 10:47:32 -0700  Kevin McCarthy  <kevin@8t8.us> (b2125bcd)

        * Keep file browser '..' entries at the top.
        
        This makes it easier to navigate up a directory when the file browser
        is sorted by a value other than "alpha".

M	browser.c

2021-04-24 15:10:22 -0700  Kevin McCarthy  <kevin@8t8.us> (2333015f)

        * Change browser sort "unsorted" to preserve the original order.
        
        Record entry numbers as they are added to the list, so re-sorting by
        "unsorted" can return to the original order.
        
        This is most useful for the mailboxes case, where "unsorted" should
        mean the order listed in the muttrc.

M	browser.c
M	browser.h
M	imap/browse.c

2021-04-24 14:56:39 -0700  Kevin McCarthy  <kevin@8t8.us> (f8984468)

        * Fix imap_add_folder() reallocation check.
        
        entrymax contains the number of slots allocated.  entrylen contains
        the current number of slots used.
        
        Note: there isn't a memory access bug here - it was merely
        reallocating too early.

M	imap/browse.c

2021-04-24 14:41:20 -0700  Kevin McCarthy  <kevin@8t8.us> (a877a29e)

        * Add $sort_browser_mailboxes configuration variable.
        
        This allows to control file browser sorting and mailbox browser
        sorting separately.

M	browser.c
M	browser.h
M	init.h
M	sort.h

2021-04-24 15:23:49 -0700  Kevin McCarthy  <kevin@8t8.us> (8b7dd25b)

        * Merge branch 'stable'

2021-04-23 18:35:30 -0700  Kevin McCarthy  <kevin@8t8.us> (30e657d3)

        * Improve sidebar drawing in small windows.
        
        Ensure the index window is given at least one column during reflow,
        truncating the sidebar width as necessary.
        
        Change the sidebar to use MuttSidebarWindow->cols instead of directly
        referencing SidebarWidth.

M	curs_lib.c
M	sidebar.c

2021-04-22 15:42:14 -0700  Kevin McCarthy  <kevin@8t8.us> (fe866a19)

        * Disable markers when wrap is at column 1.
        
        This can occur when the user resizes the window to a single column, or
        if they 'set wrap=1'.
        
        In that case, Mutt was outputting the '+' and setting the initial
        output to the second column.  However, if there is only one column,
        nothing would then be printed.  When trying to search or jump to end,
        Mutt would enter an infinite loop because no forward progress would be
        made in the file with each line.
        
        Disable the markers if there is only a single column, so at least one
        character of the message will get printed on each line.

M	pager.c

2021-04-19 18:53:30 -0700  Kevin McCarthy  <kevin@8t8.us> (8162c129)

        * Improve body_pattern and quoting when skipping down.
        
        The previous commit added the MUTT_TYPES flag to the search operation.
        However, adding the flag caused body_pattern and classify_quote
        matching to occur, as part of searching.
        
        Separate those two to only be done when MUTT_SHOWCOLOR is passed.  Keep
        the classify_quote() call in resolve_types(), since otherwise during a
        normal display we would end up matching the regexps twice.
        
        Add a flag so the computation only occurs once, instead of each time
        the line is shown.
        
        For continuation lines, we need to scan from the start of line.
        Otherwise body_patterns and proper quote level coloring won't appear
        if we jump down to the middle of a continuation line.
        
        As part of this commit, I noticed is_cont_hdr was not reset when
        handling a REDRAW_FLOW.  I believe this also fixes the old trac ticket
        issue 3744.

M	pager.c

2021-04-19 14:49:52 -0700  Kevin McCarthy  <kevin@8t8.us> (7bce3182)

        * Add MUTT_TYPES flag for pager search operation.
        
        This allows the display_line() search scanner to also determine the
        type of each line.  Without that, searching down would not be able to
        properly highlight header lines or quote lines.

M	pager.c

2021-04-19 14:48:01 -0700  Kevin McCarthy  <kevin@8t8.us> (f8e405b3)

        * Revert "Add type resolution when searching in the pager."
        
        This reverts commit aa308b67a983918eb59f1d7b5af543817c2cfd04.
        
        This may be what I want to push to master eventually, but this commit
        was accidental.  I need to test it more on a branch and add a better
        commit message before commiting to master.

M	pager.c

2021-04-19 14:45:01 -0700  Kevin McCarthy  <kevin@8t8.us> (aa308b67)

        * Add type resolution when searching in the pager.

M	pager.c

2021-04-19 14:20:47 -0700  Kevin McCarthy  <kevin@8t8.us> (4b6cd846)

        * Add a note about crypto operations being available interactively.
        
        They aren't available in batch mode.  This was mentioned in the "batch
        compose flow" section, but should be mentioned a bit more prominently
        in the manual.

M	doc/manual.xml.head

2021-04-18 14:54:02 -0700  Kevin McCarthy  <kevin@8t8.us> (10c66a53)

        * Mention 8-bit ansi color support in manual.

M	doc/manual.xml.head

2021-04-17 09:34:16 -0700  Kevin McCarthy  <kevin@8t8.us> (36a704cf)

        * Add cc, in-reply-to, and references to default mailto_allow list.
        
        Thanks to Gregory Anders for the ticket and suggested patch, which
        this commit is based upon.

M	doc/manual.xml.head
M	init.c

2021-04-13 18:02:31 -0700  Kevin McCarthy  <kevin@8t8.us> (0684a051)

        * Add a check to make sure pair doesn't overflow.
        
        It's not clear if COLOR_PAIRS can be larger than SHRT_MAX + 1, so make
        sure with a check.

M	color.c

2021-04-11 15:56:42 -0700  Kevin McCarthy  <kevin@8t8.us> (2d683201)

        * Fix ansi colors to use default bg/fg when not set.
        
        Note the ColorList stores COLOR_DEFAULT (-2) not -1, so we need to
        translate those values in mutt_alloc_ansi_color().  If the curses
        backend doesn't support default colors, we abort and just return color
        pair 0.

M	color.c
M	pager.c

2021-04-11 14:19:33 -0700  Kevin McCarthy  <kevin@8t8.us> (c20a5169)

        * Use bkgrndset() as ATTRSET() backend if available.
        
        This function allows more usable color pairs, because it passes the
        pair parameter separately.  The COLOR_PAIR() macro only returns 8-bits
        for a pair, limiting the total pairs used to 256 despite many systems
        having much larger COLOR_PAIRS values.
        
        In order to do this, separate out the pair and attrs values, instead
        of combining attr + COLOR_PAIR(pair) into a single value and storing
        that inside Mutt.  For the older calls, bkgdset() and attrset(), we
        call COLOR_PAIR() at the last minute.
        
        Add COLOR_ATTR to header cache sum calculation, since it is used in
        the HEADER now.

M	Makefile.am
M	color.c
A	color.h
M	commands.c
M	configure.ac
M	curs_main.c
M	hcache.c
M	hcachever.pl
M	menu.c
M	mutt.h
M	mutt_curses.h
M	mutt_menu.h
M	pager.c
M	protos.h
M	score.c
M	sidebar.c
M	thread.c

2021-04-10 11:33:58 +0200  Vincent Lefevre  <vincent@vinc17.net> (869c6cc4)

        * Updated French translation.

M	po/fr.po

2021-04-09 17:51:12 -0700  Kevin McCarthy  <kevin@8t8.us> (6a2e3dea)

        * Clarify -H usage in batch mode is not a "pass through" option.
        
        Mutt runs the file through mutt_prepare_template() in both cases,
        which will decrypt, remove signatures, strip multipart/alternatives.
        
        The documentation wasn't clear about this, and it might be
        misunderstood that -H is a "pass through" option.

M	doc/manual.xml.head
M	doc/mutt.man

2021-04-09 15:12:11 -0700  Kevin McCarthy  <kevin@8t8.us> (6c510773)

        * Add user-friendly error message if append to $trash fails.
        
        For the maildir case, this will then be displayed instead of a raw
        stat error message, in the case the mailbox disappears.

M	mx.c

2021-03-29 04:57:28 -0300  Marco Ippolito  <maroloccio@gmail.com> (9566a95c)

        * Fix documentation typo

M	doc/manual.xml.head

2021-03-27 19:14:10 -0700  Kevin McCarthy  <kevin@8t8.us> (4e01ccdb)

        * Stop batch mode emails with no argument or recipients.
        
        Closes #345.  There are checks in send.c to guard against a
        no-recipient email being sent, but there might be a my_hdr or other
        setting in the muttrc.  In that case, it would be surprising for an
        email to be sent.

M	main.c

2021-03-20 18:33:01 +0100  Vincent Lefevre  <vincent@vinc17.net> (8ac730a1)

        * Updated French translation.

M	po/fr.po

2021-03-19 14:35:53 -0700  Kevin McCarthy  <kevin@8t8.us> (5ee27795)

        * Merge branch 'stable'

2021-03-16 14:13:38 -0700  Kevin McCarthy  <kevin@8t8.us> (9b8cc85e)

        * Add SigInt handler for pattern functions.
        
        Allow, for example, a ~B against a huge mailbox to be interruped via
        ctrl-c.  This commit follows the same behavior as
        mutt_search_command() - not prompting and just interrupting.  We could
        add a prompt if it's really deemed necessary, but I think if they hit
        ctrl-c they want to stop the pattern operation now.
        
        Since it's not practical to roll back, leave the Context in the "in
        the middle" state too.  This may actually be desired.

M	pattern.c

2021-03-15 13:11:07 -0700  Kevin McCarthy  <kevin@8t8.us> (50f22244)

        * Turn off ~h header-only download when $message_cachedir is set.
        
        The initial pattern match will be slow, but then the body will be in
        the message cache.  This is the same as previous behavior, so a
        message cache user should not notice any change.
        
        Those not using a message cache will see improvements from the
        header-only download, but of course they will have to download the
        full headers each time.

M	pattern.c

2021-03-13 18:51:34 +0100  Vincent Lefevre  <vincent@vinc17.net> (5eb9dec8)

        * Updated French translation.

M	po/fr.po

2021-03-12 13:23:42 -0800  Kevin McCarthy  <kevin@8t8.us> (5cf52cd1)

        * Minor fixes to match_body_patterns().
        
        Change the end condition to compare against buflen.  I prefer this
        because we are not directly incrementing offset ourselves, but relying
        on the rational return values from regexec.  If the regex library
        (incorrectly) returned a nul-match at the '\0' terminator for
        instance, the new nul-match logic would assign offset just past the
        terminator.
        
        Remove the i=0 initialization during definition, because it doesn't
        use or need it.

M	pager.c

2021-03-12 13:08:29 -0800  Kevin McCarthy  <kevin@8t8.us> (64dba506)

        * Factor out match_body_patterns to make resolve_types() simpler.
        
        The body pattern matching part has been getting more complex, and is
        now too big to have its details sit amongst the resolve_types()
        logic.  Factor it out into a separate procedure.

M	pager.c

2021-03-10 18:10:39 -0800  Kevin McCarthy  <kevin@8t8.us> (63d29881)

        * Fix body color null_rx handling.
        
        The existing code did not work properly.  If the null_rx occurred
        before another matching entry in the list, it would be ignored.  If it
        occurred afterward, it could cause the entries to be created
        out-of-order which would affect the binary search later on when
        rendering.
        
        Instead, use the normal "match assignment" code, but if the best
        result is a null_rx match, simply discard it and increment the offset
        past the end of the null match.

M	pager.c

2021-03-10 15:09:49 -0800  Kevin McCarthy  <kevin@8t8.us> (53ffdb93)

        * Improve body color matching speed by caching future matches.
        
        On a *very* long body (or header_partial) lines with multiple color
        lines that match, performance can be degraded.  For instance if there
        were moderately expensive regexp matches against "A" "B" and "C".  A
        line with:
        
          A A A A A B A A C A A A B A A A C
        
        The B and C regexps were scanned again after every "A" match, despite
        that the result would be discarded again for the next A match.
        
        Change the color matching to cache the location of each color line
        match.  Discard the cache once the match offset passes that point.

M	mutt_curses.h
M	pager.c

2021-03-11 14:02:03 -0800  Kevin McCarthy  <kevin@8t8.us> (17774247)

        * Merge branch 'stable'

2021-03-09 18:19:21 -0800  Kevin McCarthy  <kevin@8t8.us> (847ce203)

        * Add <view-alt-pager> to compose menu.
        
        This mirrors the <view-pager> in the attachment menu (and just added
        to the compose menu), but adds it to the compose menu for alternative
        generation.

M	OPS
M	compose.c
M	doc/manual.xml.head
M	functions.h

2021-03-09 18:05:17 -0800  Kevin McCarthy  <kevin@8t8.us> (5a325ba4)

        * Add view-mailcap, view-pager, view-text to compose menu.
        
        These are less commonly needed, so don't bind them to a key.  But for
        those who need it, make them be available.

M	OPS
M	compose.c
M	functions.h

2021-03-10 18:58:22 +0100  Vincent Lefevre  <vincent@vinc17.net> (db80f61a)

        * Updated French translation.

M	po/fr.po

2021-03-05 18:52:48 -0800  Kevin McCarthy  <kevin@8t8.us> (191b0513)

        * Fix $ssl_client_cert usage with SMTP.
        
        The ssl and gnutls client-cert setup code was calling
        mutt_account_getuser().  This caused two problems.  First, it's not
        necessarily the case that there will be a username.  Second,
        populating the user would cause smtp_open() to check for AUTH
        capabilities and call smtp_auth - even if the user is already
        authenticated by the cert.  The server won't advertize AUTH if they
        already authenticated, causing a connection abort.
        
        Remove prompt for mutt_account_getuser() in the ssl and gnutls client
        certificate connection code.  The SASL code has callbacks, so I don't
        understand why it would need this.  Let's take it out and see if
        anyone screams 8-P.  If necessary, we can add a mutt_account_getuser()
        call to the very beginning of imap_auth_sasl().
        
        Revamp the openssl ssl_passwd_cb() prompt.  From the man pages, it
        appears to be used for the cert decryption.  There's no need to call
        mutt_account_getuser() and use the generic mutt_account_getpass() just
        to read a password in.  Instead create a callback function version to
        customize the prompt for a client cert with just the host.
        
        Change the SMTP authentication test to check if the AUTH capabilities
        are set, instead of if the user field is set before calling
        smtp_auth().

M	account.c
M	account.h
M	mutt_ssl.c
M	mutt_ssl_gnutls.c
M	smtp.c

2021-03-07 09:02:23 +0100  Olaf Hering  <olaf@aepfle.de> (fcc62991)

        * refresh de.po
        
        align with result of make update-po
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	po/de.po

2021-03-06 13:59:54 -0800  Kevin McCarthy  <kevin@8t8.us> (2054ccf2)

        * Relocate po OPS files to bottom of POTFILES.in.
        
        This matches the pre-0.21 migration order, and will reduce the size of
        updates for the next release.

M	po/POTFILES.in

2021-03-06 22:26:21 +0100  Olaf Hering  <olaf@aepfle.de> (1267c1ca)

        * refresh de.po
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	po/de.po

2021-03-06 11:22:19 -0800  Kevin McCarthy  <kevin@8t8.us> (8940dbe0)

        * Merge branch 'stable'

2021-03-04 12:24:42 -0800  Kevin McCarthy  <kevin@8t8.us> (a796a1bd)

        * Add -nonumbers to lynx options.
        
        This will remove the useless link and field numbers from output in the
        manual.txt.

M	doc/Makefile.am

2021-03-04 12:18:30 -0800  Kevin McCarthy  <kevin@8t8.us> (22bab8ff)

        * Don't install an empty manual.txt file.
        
        Closes #334.
        
        If all the html to txt programs we use (lynx, elinks, w3m) are missing
        from the system, the shell redirection willl create an empty file.
        
        Change the install step to use -s "FILE exists and has a size greater
        than zero".
        
        Thanks to Mitchell Blank Jr for the ticket and suggested fix.

M	doc/Makefile.am

2021-03-03 23:17:55 +0100  Vincent Lefevre  <vincent@vinc17.net> (9e338a19)

        * Updated French translation.

M	po/fr.po

2021-03-03 23:13:09 +0100  Vincent Lefevre  <vincent@vinc17.net> (fb5f052f)

        * Updated French translation.

M	po/fr.po

2021-03-03 12:18:51 -0800  Kevin McCarthy  <kevin@8t8.us> (1d13381f)

        * Don't leak fp when aborting mutt_make_message_attach().
        
        I forgot to close up the fp before returning.

M	sendlib.c

2021-03-01 18:19:08 -0800  Kevin McCarthy  <kevin@8t8.us> (16c381d8)

        * Prompt for retry on decrypt failure for mime message attachments.
        
        Closes #331.
        
        Change $forward_decyrpt to a quadoption, defaulting 'yes' for backward
        compatibility.  This will allow users to choose on a per-message
        attachment basis if desired.
        
        If decoding from $mime_forward_decode fails or decrypting from
        $forward_decrypt, notify the user and prompt to retry attaching
        without the decode/decrypt.
        
        $forward_decrypt directly invokes decryption and returns -1 on error,
        while $mime_forward_decode uses the handler rendering, which returns a
        non-fatal 1 (to allow message display of failing encrypted message).
        So prompt on either case.
        
        If they decline to retry, or the retry fails, return NULL only on a
        hard-fail (-1) return code.  They've been warned and can peek at the
        final result.
        
        The send generate_body() code was not checking for a NULL result.
        This seems like a bad idea, so add a check and error message in that
        case.

M	init.h
M	mutt.h
M	send.c
M	sendlib.c

2021-02-26 14:34:10 -0800  Kevin McCarthy  <kevin@8t8.us> (ad14641e)

        * Merge branch 'stable'

2021-02-24 14:59:19 -0800  Kevin McCarthy  <kevin@8t8.us> (e0d08c59)

        * Add a note about the '^' mailbox shortcut.
        
        Emphasize that it's not always set, for example in command-line mode,
        or when evaluating the muttrc at startup.

M	doc/manual.xml.head

2021-02-23 14:41:47 -0800  Kevin McCarthy  <kevin@8t8.us> (b412d83b)

        * Merge branch 'stable'

2021-02-20 13:08:54 -0800  Kevin McCarthy  <kevin@8t8.us> (7fd331fd)

        * Scan OPS files directly for gettext translation strings.
        
        Previously, gettext's po/Makefile.in.in was modified to separately
        scan and merge a generated file: keymap_alldefs.h.  Gettext doesn't
        recommend nor provide support for scanning generated files.
        
        However, there is no reason we have to scan the generated file.
        Instead move the N_() markers and L10N comments into the OPS files.
        Then simply add the OPS files to po/POTFILES.in.
        
        Add a '--language=C' option to xgettext to avoid a warning about the
        OPS files not have any known language suffix.
        
        Modify gen_defs and doc/gen-map-doc to deal with the new format of the
        OPS files.

M	OPS
M	OPS.CRYPT
M	OPS.MIX
M	OPS.PGP
M	OPS.SIDEBAR
M	OPS.SMIME
M	doc/gen-map-doc
M	gen_defs
M	po/Makevars
M	po/POTFILES.in

2021-02-18 15:40:39 -0800  Kevin McCarthy  <kevin@8t8.us> (d4e13e4b)

        * Fix gettext update problems.
        
        The keymap_alldefs.h file was previously generated and scanned inside
        po/Makefile.in.in as an additional POTFILES files build dependency and
        step.
        
        The file can't be scanned by just adding it to po/POTFILES.in because
        it's a generated file that will be in the build directory.  The next
        commit will instead add the OPS* files directly to POTFILES.in to be
        scanned.
        
        For this commit, remove the generation of keymap_alldefs.h.
        
        Remove the redundant ALL_LINGUAS setting from configure.ac.  Reformat
        the LINGUAS file to be on one line, as the documentation shows.  I
        think it was okay before, but just to be safe.
        
        Fix L10N scanning by adding '--add-comments=L10N' to XGETTEXT_OPTIONS
        in po/Makevars.
        
        Set MSGID_BUGS_ADDRESS to silence a warning.
        
        Add gettext.h to the Makefile.am EXTRA_DIST list.
        
        Remove -Iintl flags from all Makefile.am files, since the intl
        directory is no longer bundled in Mutt.

M	Makefile.am
M	autocrypt/Makefile.am
M	configure.ac
M	imap/Makefile.am
M	po/LINGUAS
M	po/Makevars

2021-02-19 00:20:42 +0100  Vincent Lefevre  <vincent@vinc17.net> (8d94928e)

        * Remove the AM_GNU_GETTEXT_VERSION line as it makes autoreconf fail with gettext < 0.21 because autopoint complains that gettext is too old.
        
        Using this line with a version smaller than 0.21 makes autopoint itself
        fail, thus does not solve the problem.

M	configure.ac

2021-02-19 00:02:15 +0100  Vincent Lefevre  <vincent@vinc17.net> (33fe78af)

        * Add AM_GNU_GETTEXT_VERSION line to avoid a warning from autoreconf.

M	configure.ac

2021-02-07 18:27:47 -0800  Kevin McCarthy  <kevin@8t8.us> (ccc18061)

        * Update gettext to version 0.21.
        
        Run 'gettextize -f --no-changelog' to update to 0.21.
        
        This removes the entire intl directory, and relies on an external
        libintl only.
        
        $(INTLLIBS) should now be referred to as $(LIBINTL), so change all
        references.
        
        Unfortunately, some of the gettext m4 files were modified and "mutt
        customized" in the past.  I'm trying to keep them in a pristine state
        after this upgrade.  glibc21.m4, lcmessage.m4, codeset.m4 have also
        been removed.
        
        Manually call AM_ICONV in configure.ac.  This was previously called
        in the modified "MUTT_AM_GNU_GETTEXT" but the result $am_cv_func_iconv
        is tested just below.
        
        locale.h is a standard library defined by C99.  The gpgme and pgp code
        wrapped those includes in HAVE_LOCALE_H checks, but that check was
        performed inside of gettext.m4.  Remove the check inside those
        files (locale.h is already included unconditionally elsewhere in
        Mutt).
        
        Copy the sample gettext.h file and include that instead, as suggested
        by the gettext documentation.
        
        unistd.h is also a standard posix header, so remove HAVE_UNISTD_H
        checks inside mutt too.
        
        Create po/LINGUAS file listing available languages.
        
        Create po/Makevars from the template and customize for Mutt.
        
        Set PO_DEPENDS_ON_POT to no to prevent po file rebuilds.  According to
        the gettext manual, with this set, "PO files can be accidentally
        updated even if a POT file is not updated" when using git.

M	.gitignore
M	ABOUT-NLS
M	INSTALL
M	Makefile.am
A	config.rpath
M	configure.ac
M	crypt-gpgme.c
M	crypt.c
A	gettext.h
D	intl/COPYING.LIB-2
D	intl/COPYING.LIB-2.1
D	intl/ChangeLog
D	intl/Makefile.in
D	intl/VERSION
D	intl/bindtextdom.c
D	intl/cat-compat.c
D	intl/config.charset
D	intl/dcgettext.c
D	intl/dcigettext.c
D	intl/dcngettext.c
D	intl/dgettext.c
D	intl/dngettext.c
D	intl/explodename.c
D	intl/finddomain.c
D	intl/gettext.c
D	intl/gettext.h
D	intl/gettextP.h
D	intl/hash-string.h
D	intl/intl-compat.c
D	intl/l10nflist.c
D	intl/libgettext.h
D	intl/libgnuintl.h
D	intl/libintl.glibc
D	intl/linux-msg.sed
D	intl/loadinfo.h
D	intl/loadmsgcat.c
D	intl/localcharset.c
D	intl/locale.alias
D	intl/localealias.c
D	intl/ngettext.c
D	intl/plural.c
D	intl/plural.y
D	intl/po2tbl.sed.in
D	intl/ref-add.sin
D	intl/ref-del.sin
D	intl/textdomain.c
D	intl/xopen-msg.sed
M	lib.h
M	m4/Makefile.am
M	m4/README
D	m4/codeset.m4
M	m4/gettext.m4
D	m4/glibc21.m4
A	m4/host-cpu-c-abi.m4
M	m4/iconv.m4
A	m4/intlmacosx.m4
D	m4/lcmessage.m4
A	m4/lib-ld.m4
A	m4/lib-link.m4
A	m4/lib-prefix.m4
A	m4/nls.m4
A	m4/po.m4
M	m4/progtest.m4
M	mutt.h
M	pgp.c
A	po/LINGUAS
M	po/Makefile.in.in
A	po/Makevars
A	po/Rules-quot
A	po/boldquot.sed
A	po/en@boldquot.header
A	po/en@quot.header
A	po/insert-header.sin
A	po/quot.sed
A	po/remove-potcdate.sin
M	smime.c

2021-02-17 15:47:49 -0800  Kevin McCarthy  <kevin@8t8.us> (9635fad4)

        * Add backlinks for $fcc_before_send and self_encrypt options.
        
        Make sure the $fcc_before_send's behavior changes to $fcc_clear and
        $fcc_attach is mentiond in those options too.
        
        Add a "see also" in $fcc_clear to the self_encrypt options.

M	init.h

2021-02-13 12:31:59 -0800  Helge Kreutzmann  <debian@helgefjell.de> (0ced35e0)

        * Update de.po.

M	po/de.po

2021-02-07 19:51:34 -0800  Kevin McCarthy  <kevin@8t8.us> (106ff19a)

        * Merge branch 'stable'

2021-02-05 15:34:37 -0800  Kevin McCarthy  <kevin@8t8.us> (e5c6a054)

        * Save CurrentFolder in background edit scope.
        
        The CurrentFolder can actually be used to resolve an fcc-hook at fcc
        time.  We would want to use the folder they started composing in, to
        be consistent with expectations.

M	doc/manual.xml.head
M	send.c
M	send.h

2021-02-05 14:09:28 -0800  Kevin McCarthy  <kevin@8t8.us> (56f4c0b8)

        * Change attach inline forward messages default CH flag.
        
        Fix it to be CH_DECODE instead of CH_XMIT.
        
        I believe this was a mistake from a long time ago.  The CH_XMIT flag
        is used in mutt for:
        - mutt_save_message() -> set_copy_flags() when decoding
        - pre-send conversion to 7 bit
        - mutt_make_message_attach() (for index mime-forwarding)
        - message bouncing
        
        Using it for *inline* forwarding in the attachment menu doesn't make
        sense.  Both include_forward() in send.c, and include_header() in
        recvcmd.c use CH_DECODE.  It seems reasonable to decode headers when
        inline forwarding from the attachment menu (as is done from the
        index), so I'm guessing that was what was meant here too.

M	recvcmd.c

2021-02-04 18:02:06 -0800  Kevin McCarthy  <kevin@8t8.us> (18c29a84)

        * Filter ANSI sequences when forwarding too.
        
        Add a MUTT_CM_FORWARDING flag to correspond with the MUTT_CM_REPLYING
        flag.  Check those to turn on ANSI filtering.
        
        In order to guard against other accidental prefix setting without one
        of those flags, also check s->prefix to enable ANSI filtering (and
        prefix printing) too.
        
        Add missing MUTT_CM_REPLYING flags to the recvcmd.c reply functions.
        
        While updating the recvcmd.c reply code, I noticed CH_REORDER wasn't
        enabled with OPTWEED, like in the send.c code (and everywhere else),
        so add the missing flag.

M	copy.c
M	copy.h
M	handler.c
M	mutt.h
M	recvcmd.c
M	send.c

2021-02-03 15:50:49 -0800  Kevin McCarthy  <kevin@8t8.us> (1a9fea6f)

        * Add explicit flag to check for postponed message on <mail>.
        
        This used to check for:
          !flags && !msg
        which was still relatively clear that it was a unique situation (just
        for <mail> in the index and pager).
        
        With the addition of background editing, it became:
          (sctx->flags == SENDBACKGROUNDEDIT) && !sctx->msg
        This is less intuitively understood to be just for the <mail> case,
        and thus perhaps easy to create a bug in the future.
        
        Create an explicit flag, SENDCHECKPOSTPONED to perform the check, and
        enable for the <mail> operation in the index and pager.

M	curs_main.c
M	mutt.h
M	pager.c
M	send.c

2021-02-02 12:56:33 -0800  Kevin McCarthy  <kevin@8t8.us> (acf11418)

        * Merge branch 'stable'

2021-02-01 15:15:17 -0800  Kevin McCarthy  <kevin@8t8.us> (09f077c9)

        * Change REPLYTO handling to directly add the my_hdr.
        
        Don't send the header through the muttrc parser, to avoid issues with
        unexpected evaluation of an environment variable.

M	init.c

2021-01-28 18:02:47 -0800  Kevin McCarthy  <kevin@8t8.us> (961cf4be)

        * Apply $reverse_name when tag-reply/forwarding too.
        
        Enable $reverse_name for tag actions in the attach menu too.  Since
        the ATTACH_CONTEXT is a different structure, move both single and
        tagged action handling into recvcmd.c

M	alias.c
M	protos.h
M	recvcmd.c
M	send.c

2021-01-27 15:02:10 -0800  Kevin McCarthy  <kevin@8t8.us> (ab6d0dc5)

        * Merge branch 'stable'

2021-01-27 13:38:53 -0800  Kevin McCarthy  <kevin@8t8.us> (3e35377e)

        * Fix small error in mutt_resize_term().
        
        Commit 547b25a2 accidentally removed the default value setting if
        LINES or COLUMNS are null.  Also, set default values if the atoi
        fails.

M	resize.c

2021-01-26 18:36:20 -0800  Kevin McCarthy  <kevin@8t8.us> (d1729b7c)

        * Create mutt_atolofft() to parse body->length field.
        
        This will allow proper range checking on the number, and set it to -1
        if it's out of range.

M	muttlib.c
M	parse.c
M	protos.h

2021-01-26 12:58:54 -0800  Kevin McCarthy  <kevin@8t8.us> (5d73e4cf)

        * Convert all mutt_atoX functions to behave strictly.
        
        * Remove the automatic conversion of NULL and '\0' to 0.  Add a flag
          for the cases that require lax evaluation.
        
        * Make trailing characters generate an error by default for the
          mutt_atouX functions.  Add a flag for that case.  Most of the IMAP
          code parses numbers out of a stream, so add the flag to those
          calls.
        
        * The mutt_atouX functions were also behaving incorrectly with
          invalid input, e.g. "ABC", returning and setting 0.  Fix them to
          return an error in those cases.
        
        * Add a mutt_atoll() function, to be used in the next commit.
        
        * Change converters to store 0 on error.  atos, atoi, and atoui were
          already doing this, but the others were not.

M	curs_main.c
M	edit.c
M	gnupgparse.c
M	imap/command.c
M	imap/imap.c
M	imap/message.c
M	imap/util.c
M	init.c
M	lib.c
M	lib.h
M	main.c
M	menu.c
M	mh.c
M	parse.c
M	resize.c
M	rfc2231.c
M	score.c
M	smtp.c
M	url.c

2021-01-27 07:27:31 -0800  Kevin McCarthy  <kevin@8t8.us> (7737b353)

        * Merge branch 'stable'

2021-01-24 15:01:33 -0800  Kevin McCarthy  <kevin@8t8.us> (3d6e7df7)

        * Fix hdr_order to use the longest match.
        
        Previously, Mutt would find the first match and use that.
        
        However, the example shown in the manual:
          hdr_order From Date: From: To: Cc: Subject:
        gives the expectation that an mbox From_ line would print first, then
        the Date:, and then the From: header.
        
        Change the matcher to scan all HeaderOrderList entries and use the
        longest match.
        
        Update the documentation to make it clear From_ lines are printed out
        with other "real" headers, and can be manipulated via ignore and
        hdr_order commands.

M	copy.c
M	doc/manual.xml.head

2021-01-23 18:14:02 -0800  Kevin McCarthy  <kevin@8t8.us> (c6700b05)

        * Fix double spacing after group display-name in pager and message.
        
        Edit-headers and message writing uses mutt_write_rfc822_header() ->
        mutt_write_address_list(), which renders each address one by one and
        outputs to a file.  rfc822_write_address_single() already appends a
        space after the group display-name colon delimiter.
        
        Rendering to the pager uses a different code path:
        address_header_decode() -> format_address_header().  The logic is very
        similar to mutt_write_address_list() except it renders to memory.  It
        also needs to avoid re-appending a space after the group display-name.

M	copy.c
M	sendlib.c

2021-01-23 15:00:12 -0800  Kevin McCarthy  <kevin@8t8.us> (075a4c70)

        * Restrict mime header date writing to protected headers.
        
        The previous code would generate and print a date header for
        autocrypt.  This wouldn't really cause a problem, but is incorrect.
        
        Check explicitly for a passed in date parameter in
        MUTT_WRITE_HEADER_MIME mode.

M	sendlib.c

2021-01-23 14:31:19 -0800  Kevin McCarthy  <kevin@8t8.us> (94628052)

        * Mention C99 libc requirement in INSTALL file.

M	INSTALL

2021-01-22 15:15:56 -0800  Kevin McCarthy  <kevin@8t8.us> (e72c8ce1)

        * Tighten up group list parsing a bit more.
        
        The display-name is not optional for a group, so don't start a group
        list if the display-name is empty.
        
        Groups can't be nested, so terminate a previous group list if the
        terminator was left off.

M	rfc822.c

2021-01-16 15:46:54 -0800  Kevin McCarthy  <kevin@8t8.us> (46f86782)

        * Make some small fixes to the -nonotify commit.
        
        Fix logic error in mutt_buffy_check().
        
        Add -nonotify flag to the configuration command list in the manual
        too.
        
        Add line wraps to the muttrc.man mailboxes options, to make the
        synopsis more readable within 80 columns.

M	buffy.c
M	doc/manual.xml.head
M	doc/muttrc.man.head

2021-01-16 20:53:57 +0100  Rene Kita  <git@rkta.de> (26770eac)

        * Add -nonotify argument to mailboxes command
        
        -nonotify allows to disable notifications for mailboxes.
        
        -notify can be used to re-enable notifications for a previously disabled
        mailbox.
        
        A typical use case are mailboxes for mailing lists. The User may want to
        get notified about new mail in their work mailbox, but not get disrupted
        by new mail received from the mailing list.
        
        This patch allows individual configuration for all mailboxes.

M	buffy.c
M	buffy.h
M	doc/manual.xml.head
M	doc/muttrc.man.head
M	imap/command.c
M	imap/imap.c

2021-01-21 12:42:45 -0800  Kevin McCarthy  <kevin@8t8.us> (933f3462)

        * Merge branch 'stable'

2021-01-20 11:51:58 +0100  Vincent Lefevre  <vincent@vinc17.net> (d5a18cca)

        * Updated French translation.

M	po/fr.po

2021-01-18 14:47:32 -0800  Kevin McCarthy  <kevin@8t8.us> (feb30961)

        * Fix warning; minor code cleanup.
        
        random_dev isn't used anymore (after removing the %R expando).
        
        I originally had local variables in some of the case statements, and
        forgot to pull out the curly brackets when I moved those to the top of
        the function.

M	messageid.c

2021-01-18 14:02:37 -0500  Remco Rĳnders  <remco@webconquest.com> (8641fb2a)

        * Remove %R format for $message_id_format

M	init.h
M	messageid.c

2021-01-18 13:54:13 -0500  Remco Rĳnders  <remco@webconquest.com> (dadc0130)

        * Provide %x format for $message_id_format
        
        The expando format %x generates one pseudorandom byte and puts the
        output in a lowercase hex formatted string of length two.
        
        # Conflicts:
        #	init.h
        #	messageid.c

M	init.h
M	messageid.c

2021-01-17 19:39:01 -0800  Kevin McCarthy  <kevin@8t8.us> (5f5d33f8)

        * Change $message_id_format year expando from %y to %Y.
        
        So that it matches the strftime() 4-digit year.
        
        Thanks to Vincent Lefèvre for noting the discrepancy.

M	init.h
M	messageid.c

2021-01-15 15:56:45 -0800  Kevin McCarthy  <kevin@8t8.us> (1f188287)

        * Add $message_id_format for customizing generated Message-IDs.
        
        Provide expandos for the new (2.0+) format and the old format.  Add %r
        and %R to generate fixed size 4-char Base64 blocks from the
        pseudo-random generator, or from /dev/urandom.
        
        The format string allows external filters, for complete control.

M	globals.h
M	init.h
M	messageid.c

2021-01-15 13:21:27 -0800  Kevin McCarthy  <kevin@8t8.us> (b5a807ca)

        * Move mutt_gen_msgid() over to messageid.c.

M	Makefile.am
A	messageid.c
M	po/POTFILES.in
M	sendlib.c

2021-01-17 11:05:36 -0800  Kevin McCarthy  <kevin@8t8.us> (d4305208)

        * Add group terminator if it is left off.
        
        If there is no terminating ";" add one to the list, to make the text
        re-rendering correct.

M	rfc822.c

2021-01-17 10:53:19 -0800  Kevin McCarthy  <kevin@8t8.us> (939b02b3)

        * Don't allocate a group terminator unless we are in a group-list.
        
        This will reduce memory allocation for garbage/spam address lists.
        
        It also makes no sense to store a terminator when there wasn't a
        display-name indicating the start of a group.

M	rfc822.c

2021-01-17 13:05:46 -0800  Kevin McCarthy  <kevin@8t8.us> (59a09320)

        * Merge branch 'stable'

2021-01-10 19:48:17 -0800  Kevin McCarthy  <kevin@8t8.us> (53181e6b)

        * Remove configure test for va_copy.
        
        Its presence is also dictated by the C99 specification.

M	configure.ac
D	m4/funcs.m4

2021-01-10 14:25:23 -0800  Kevin McCarthy  <kevin@8t8.us> (73ee27cb)

        * Remove snprintf and vsnprintf configure checks.
        
        There was a period of time where C99 was standardized but some systems
        still didn't include a correctly working version of those two
        functions.  But I think we are long past that point now.
        
        Remove the checks and replacement code.

M	Makefile.am
M	configure.ac
M	dotlock.c
M	protos.h
D	snprintf.c

2021-01-13 19:15:32 -0800  Kevin McCarthy  <kevin@8t8.us> (d35bee80)

        * Merge branch 'stable'

2021-01-10 10:25:06 -0800  Kevin McCarthy  <kevin@8t8.us> (564af512)

        * Fix check for empty colors left.
        
        Because pair "0" is reserved (and we start searching at index 1), we
        only have access to (COLOR_PAIRS - 1) pairs.
        
        Also, don't increment UserColors during the check, because that would
        incorrectly inflate the number of color pairs allocated if none are
        available.  That would delay or even remove the ability to reallocate
        pairs after future color pair frees.
        
        It actually would make more sense to just check (index > COLOR_PAIRS -
        1).  But since UserColors is incremented here, and is used in dprint
        statements, keep the check consistent.

M	color.c

2021-01-09 09:42:51 -0800  Kevin McCarthy  <kevin@8t8.us> (1ffe93ef)

        * Move empty color slot finding into initial compare loop.
        
        There is no need to scan the list again to find the place for a new
        entry, since we already do to check for duplicates.
        
        Store the last pointer in the initial loop, and calculate the lowest
        available index at the same time.

M	color.c

2021-01-08 18:23:09 -0800  Kevin McCarthy  <kevin@8t8.us> (7731d992)

        * Add code to free ansi colors.
        
        The 256 color ansi-escape sequence commit can create many more
        potential ansi colors than the 8-color version, so they shouldn't be
        allowed to just accumulate.
        
        Free ansi colors when exiting the pager.  The pager can be called
        nested, so this could prematurely free the colors, but they will be
        automatically reallocated.
        
        Ansi and overlay colors shouldn't be refcounted like normal colors, so
        add a bit field for both.
        
        For now, we just let overlay colors accumulate, as before.  If this
        becomes a problem, we could periodically flush them, the same way as
        ansi colors - perhaps when changing mailboxes.
        
        Change ColorList to be sorted by index.  This removes the O(n^2) loop
        just to find the next available index.
        
        Likewise, improve the mutt_free_color() loop to keep track of the last
        pointer instead of relooping.

M	color.c
M	pager.c
M	protos.h

2021-01-08 19:11:34 -0800  Kevin McCarthy  <kevin@8t8.us> (00b70ff0)

        * Merge branch 'stable'

2021-01-07 14:16:28 +0200  Matti Niemenmaa  <matti.niemenmaa+git@iki.fi> (b0bc42ff)

        * pager: Parse 256-color "ANSI" escapes

M	pager.c

2021-01-07 14:20:42 +0200  Matti Niemenmaa  <matti.niemenmaa+git@iki.fi> (1b20dd42)

        * pager: Don't accept color code 8
        
        38 and 48 are not valid color specifications: 30–37 and 40–47 specify
        the eight foreground and background colors while 39 and 49 are used to
        mean "reset to default".
        
        38 and 48 are in use to specify 8-bit or 24-bit colors, but those cases
        require special handling.

M	pager.c

2021-01-03 15:33:46 -0800  Kevin McCarthy  <kevin@8t8.us> (a3db7ccb)

        * Add configure checks for gssapi library and functions.
        
        rkta on irc reported a build failure because the gss headers were not
        present.  Add explicit checks for the required headers.  Also add a
        check for gss_init_sec_context() when using the output of krb-config
        to configure flags.
        
        Abort configure if the library/header checks don't pass.  It would
        previously continue on, setting USE_GSS and need_gss, which would just
        result in a build error.

M	configure.ac
M	m4/gssapi.m4

2021-01-01 18:51:32 -0800  Kevin McCarthy  <kevin@8t8.us> (e4a8abe8)

        * Remove obsolete AC_HEADER_STDC and STDC_HEADERS checks.
        
        The autoconf macro is obsolete in 2.70.  Also, we now assume at least
        C99 so there is no point in checking for ANSI C89 header files.
        
        Fix up code to assume STDC_HEADERS is always true, removing the
        reference to it at the same time.

M	configure.ac
M	m4/gettext.m4
M	mutt_curses.h
M	protos.h
M	regex.c

2021-01-01 18:13:59 -0800  Kevin McCarthy  <kevin@8t8.us> (475e800f)

        * Replace AC_OUTPUT_COMMANDS with AC_CONFIG_COMMANDS.

M	m4/gettext.m4

2021-01-01 18:05:04 -0800  Kevin McCarthy  <kevin@8t8.us> (b04bf448)

        * Convert AC_TRY_LINK to AC_LINK_IFELSE.

M	m4/codeset.m4
M	m4/curslib.m4
M	m4/funcs.m4
M	m4/gettext.m4
M	m4/iconv.m4
M	m4/lcmessage.m4

2021-01-01 15:49:05 -0800  Kevin McCarthy  <kevin@8t8.us> (a01316d9)

        * Convert AC_TRY_COMPILE to AC_COMPILE_IFELSE.

M	m4/funcdecl.m4
M	m4/iconv.m4

2021-01-01 14:04:01 -0800  Kevin McCarthy  <kevin@8t8.us> (9bb70dbc)

        * Remove obsolete AC_ISC_POSIX call.

M	m4/gettext.m4

2021-01-01 12:51:17 -0800  Kevin McCarthy  <kevin@8t8.us> (47dc3b08)

        * Replace AC_HELP_STRING with AS_HELP_STRING.

M	configure.ac
M	m4/gettext.m4
M	m4/gpg-error.m4
M	m4/gpgme.m4
M	m4/iconv.m4

2021-01-01 12:45:18 -0800  Kevin McCarthy  <kevin@8t8.us> (2754a057)

        * Replace AC_ERROR with AC_MSG_ERROR.

M	m4/curslib.m4

2021-01-01 10:08:38 -0800  Kevin McCarthy  <kevin@8t8.us> (cbc0957e)

        * Update deprecated AC_CHECK_TYPE usage.

M	configure.ac

2021-01-01 12:33:22 -0800  Kevin McCarthy  <kevin@8t8.us> (c58d307d)

        * Update config.status invocation.
        
        The files are now specified on the command line, instead of via the
        CONFIG_FILES env var.
        
        This is the first of a series of patches updating obsolete autoconf
        macros and usages.  The 2.70 release sqawks very loudly at those
        constructs, so best to start updating them.

M	intl/Makefile.in
M	po/Makefile.in.in

2020-12-30 14:31:11 -0800  Kevin McCarthy  <kevin@8t8.us> (4c6a0954)

        * Merge branch 'stable'

2020-12-29 14:28:23 -0800  Kevin McCarthy  <kevin@8t8.us> (625666ef)

        * Update header cache checking order and --with options.
        
        Automatically scan in the order: kyotocabinet, tokyocabinet, lmdb,
        qdbm, gdbm, bdb.
        
        Turn all the backend options into '--with' options and add a dir
        parameter.  Specifying a single --with option declares the desired
        backend, turning off scanning.  Specifying --without skips scanning
        for a backend.
        
        Update the INSTALL file to make that clear.  This actually wasn't even
        clear to me until I studied it now, and for years I've been using an
        obfuscated combination of --without and --with to specify the backend,
        when I just needed to use --with.

M	INSTALL
M	configure.ac

2020-12-29 13:28:30 -0800  Kevin McCarthy  <kevin@8t8.us> (d6c7a1a5)

        * Merge branch 'stable'

2020-12-28 18:39:19 -0800  Kevin McCarthy  <kevin@8t8.us> (7932020f)

        * Fix freebsd build on srht.
        
        Looks like the db5 package does install in a wacky place.  For now,
        just use kyotocabinet (which appears to install under /usr/local).

M	.builds/freebsd.yml

2020-12-28 18:24:10 -0800  Kevin McCarthy  <kevin@8t8.us> (a62d11d2)

        * Add non-zero length for gdbm and lmdb configure tests.
        
        In $db_requested=auto mode, the variables may be unset.

M	configure.ac

2020-12-28 15:57:04 -0800  Kevin McCarthy  <kevin@8t8.us> (60bd4a85)

        * Simplify BDB configure.ac check.
        
        Remove the long list of directory and library names to scan, and just
        look for -ldb and db.h.  Use $with_bdb to search an alternative
        directory, just as the other header cache library searches do.
        
        If someone screams, we can enhance a *little* bit, but I think this is
        sufficient, and more important, maintainable.

M	configure.ac

2020-12-25 10:21:13 -0800  Kevin McCarthy  <kevin@8t8.us> (4032fd8a)

        * Merge branch 'stable'

2020-12-23 09:44:14 -0800  Kevin McCarthy  <kevin@8t8.us> (658d28b2)

        * Fix declaration of mutt_decode_base64().
        
        Thanks to Charles for reporting the problem!

M	protos.h

2020-12-23 17:17:26 +0100  Olaf Hering  <olaf@aepfle.de> (3e24f802)

        * refresh de.po
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	po/de.po

2020-12-21 15:34:58 -0800  Kevin McCarthy  <kevin@8t8.us> (03e17ef7)

        * Correct length to use LOFF_T.
        
        This is a part two, made in master, to the stable branch commit
        11b18027.  These are mostly length adjustments to use LOFF_T, matching the
        BODY->length type.
        
        An argument could be made for size_t instead, and a few places in Mutt
        do assign between those types.  I've used LOFF_T because off_t is a
        signed integer.  Some changes in this commit affect loops that
        decrement a length pointer while > 0.  Switching to a size_t could
        create a wraparound infinite loop bug.
        
        This also changes the Content-Length header parser to use atoll()
        intead of atol().  I noticed from the man page that atol() doesn't
        seem to return -1 on error.  But I've kept the check anyway.

M	copy.c
M	crypt-gpgme.c
M	edit.c
M	handler.c
M	imap/message.c
M	mbox.c
M	parse.c
M	pattern.c
M	pop.c

2020-12-22 18:04:32 -0800  Kevin McCarthy  <kevin@8t8.us> (a4a2a1ed)

        * Merge branch 'stable'

2020-12-20 17:48:09 +0000  Christoph Berg  <cb@df7cb.de> (c1ae18c0)

        * Fix a typo in de.po

M	po/de.po

2020-12-20 03:58:21 +0100  Vincent Lefevre  <vincent@vinc17.net> (ef4e63a5)

        * Typo in a L10N text.

M	imap/command.c

2020-12-20 03:43:14 +0100  Vincent Lefevre  <vincent@vinc17.net> (7c6cbecc)

        * Updated French translation.

M	po/fr.po

2020-12-18 10:15:24 -0800  Kevin McCarthy  <kevin@8t8.us> (1598baa2)

        * Add a sanity check for qresync.
        
        If it fails, force a redownload without qresync, to set the uid_seqset
        to a correct state.
        
        Note the headers should almost all be in the header cache, so this
        isn't a huge penalty, but ensures no duplicates occur (the most common
        issue if something goes wrong).

M	imap/message.c

2020-12-16 15:14:29 -0800  Kevin McCarthy  <kevin@8t8.us> (09a1abe3)

        * Add a batch composition flow section to the manual.

M	doc/manual.xml.head

2020-12-15 12:58:24 -0800  Kevin McCarthy  <kevin@8t8.us> (a832cb5a)

        * Create $ssl_verify_host_override.
        
        This allows manually specifying the host name to verify a server
        certificate against.
        
        I'm not sure I like the idea, but since Mutt already allows turning
        hostname verification off, it's not any worse to leave it on but
        manually set the expected hostname in the certificate.
        
        Thanks to eudyptes-pachyrynchus for the merge request, which prompted
        me to take another look at the ticket.

M	globals.h
M	init.h
M	mutt_ssl.c
M	mutt_ssl_gnutls.c

2020-12-10 14:07:19 -0800  Kevin McCarthy  <kevin@8t8.us> (b860ea2f)

        * Add "headers" parameter to mx_open_message().
        
        This will allow some operations to retrieve only headers, such as ~h
        pattern matching or the new list menu.
        
        Modify the IMAP and POP3 implementation to retrieve only headers when
        the parameter is set.
        
        Headers-only will use the message cache if one exists, but will not
        populate the message cache (since the body of the message is not
        downloaded.)

M	commands.c
M	compress.c
M	copy.c
M	imap/imap_private.h
M	imap/message.c
M	listmenu.c
M	mailbox.h
M	mbox.c
M	mh.c
M	mutt.h
M	mx.c
M	parse.c
M	pattern.c
M	pop.c
M	postpone.c
M	recvattach.c
M	send.c
M	sendlib.c

2020-12-10 20:19:08 +0100  Olaf Hering  <olaf@aepfle.de> (c6868e1f)

        * mention system muttrc in man page
        
        mutt uses either the Muttrc owned by the sysadmin, or its own Muttrc.
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	doc/Makefile.am
M	doc/mutt.man

2020-12-09 15:08:31 -0800  Kevin McCarthy  <kevin@8t8.us> (c8663d49)

        * Parse headers on demand for the list menu.
        
        This will be a bit slower over IMAP from the index, but it removes
        storing all the new headers in the header cache.  Since those are not
        used for anything except the list menu, and the list menu is
        infrequently used, it's a bit wasteful to store them in the header
        cache.

M	hcache.c
M	imap/message.c
M	listmenu.c
M	mutt.h
M	muttlib.c
M	parse.c
M	protos.h

2020-12-09 20:00:57 +0100  Grzegorz Szymaszek  <gszymaszek@short.pl> (1f67773f)

        * Improve the Polish translation of OP_TOGGLE_WRITE

M	po/pl.po

2020-12-07 14:59:10 -0800  Kevin McCarthy  <kevin@8t8.us> (f7b469ee)

        * Merge branch 'stable'

2020-12-07 13:18:16 -0800  Kevin McCarthy  <kevin@8t8.us> (8a34338a)

        * Merge branch 'stable'

2020-12-07 17:36:30 +0000  dgc  <dgc.gitlab@bikeshed.us> (59dc711f)

        * Add manual xml for list menu

M	doc/manual.xml.head

2020-12-07 08:53:35 +0100  Olaf Hering  <olaf@aepfle.de> (25d2877f)

        * refresh de.po
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	po/de.po

2020-12-07 02:09:07 +0100  Vincent Lefevre  <vincent@vinc17.net> (b95a1d68)

        * Updated French translation.

M	po/fr.po

2020-11-26 15:21:05 -0800  Kevin McCarthy  <kevin@8t8.us> (42331065)

        * Add <skip-headers> to skip past message headers in pager.
        
        This is based on <skip-quoted>, and is bound to 'H' by default.
        
        I've added an error message in case there is no text past the headers,
        just to cover the logical case.  I don't think Mutt allows that to
        happen for text passed to the pager, but just in case.

M	OPS
M	doc/manual.xml.head
M	functions.h
M	pager.c

2020-12-06 12:56:45 -0800  Kevin McCarthy  <kevin@8t8.us> (c23921bc)

        * Fix list menu label alignment.
        
        Use mutt_strwidth() to find the maximum label length.
        
        Use mutt_FormatString() and mutt_format_s() to align the label.

M	listmenu.c

2020-12-06 21:47:35 +0100  Vincent Lefevre  <vincent@vinc17.net> (067d802c)

        * Updated French translation.

M	po/fr.po

2020-12-06 11:20:06 -0800  Kevin McCarthy  <kevin@8t8.us> (aa85a70f)

        * Add new listmenu.c to POTFILES.in.

M	po/POTFILES.in

2020-12-06 20:03:02 +0100  Vincent Lefevre  <vincent@vinc17.net> (64fce068)

        * Updated French translation for the master branch.

M	po/fr.po

2020-12-06 02:14:27 +0000  dgc  <dgc.gitlab@bikeshed.us> (c92a06c0)

        * abstract some List-* header processing
        
        List-Post parsing is inline in the List-Post header handler. This moves
        it to some separate functions so that we can use it for other purposes.

M	Makefile.am
M	OPS
M	curs_main.c
M	doc/manual.xml.tail
M	functions.h
M	hcache.c
M	imap/message.c
M	keymap.c
M	keymap.h
A	listmenu.c
M	mutt.h
M	muttlib.c
M	pager.c
M	parse.c
M	protos.h

2020-12-04 11:05:35 -0800  Kevin McCarthy  <kevin@8t8.us> (6fe98cf5)

        * Merge branch 'stable'

2020-12-03 13:47:50 -0800  Kevin McCarthy  <kevin@8t8.us> (9518a0ab)

        * Add a mutt_error() when copy/save messages fails.
        
        Avoid using "part" translations for the tag/untagged copy/save
        combinations, even though that makes the code longer.

M	commands.c

2020-12-03 13:40:51 -0800  Kevin McCarthy  <kevin@8t8.us> (8d1f22a1)

        * Refresh index if a tagged save aborts in the middle.
        
        Make the sure the index message flags and status line are properly
        redrawn in that case.

M	curs_main.c

2020-12-02 13:22:52 -0800  Kevin McCarthy  <kevin@8t8.us> (d52b69bb)

        * Merge branch 'stable'

2020-12-01 14:21:31 -0800  Kevin McCarthy  <kevin@8t8.us> (1ec642e2)

        * Fix memory leak in imap_copy_messages().
        
        mx.mbox (allocated by imap_parse_path) was not always freed before
        return.
        
        The sync_cmd and cmd buffers were also not always freed.  One case was
        on retrying after creating the mailbox, which would overwrite the
        allocated pointers.
        
        As long as I'm touching the buffers, convert them to use the buffer
        pool.  I think the mutt_buffer_clear() at the beginning of the retry
        loop isn't necessary, but will keep it to make it clear any existing
        values won't be reused a second time through the loop.

M	imap/message.c

2020-12-01 21:36:06 +0100  Vincent Lefevre  <vincent@vinc17.net> (0a836cee)

        * Fix typos in the manual, found by codespell.

M	doc/manual.xml.head

2020-11-29 19:10:40 -0800  Kevin McCarthy  <kevin@8t8.us> (20334587)

        * Add mutt_buffer_rewind() function.
        
        This makes it a bit clearer what the assignment is doing, and reduces
        direct dptr manipulation a bit.

M	buffer.c
M	buffer.h
M	init.c
M	mutt_lisp.c
M	muttlib.c

2020-11-30 15:48:30 -0800  Kevin McCarthy  <kevin@8t8.us> (e1c962aa)

        * Fix a few mutt_extract_token() callers dest parameters.
        
        Some callers performed a mutt_buffer_init(), called
        mutt_extract_token() and then assumed that the buffer->data would
        never be NULL.  Prior to the "fix" in commit f420be68, this was not
        true, even if MoreArgs() returns true, because the argument could be
        just ''.
        
        The parse_keymap() change fixed a possible segv.  Don't use the buffer
        pool, because it returns buf->data to the caller.
        
        I don't believe the other two would segv, but they did still rely on
        the old behavior where the the buffer would have a '\0' appended
        always.  So, change them to use the buffer pool to be cleaner.

M	init.c
M	keymap.c

2020-11-30 18:22:52 -0800  Kevin McCarthy  <kevin@8t8.us> (93a622ec)

        * Merge branch 'stable'

2020-11-29 15:34:33 -0800  Kevin McCarthy  <kevin@8t8.us> (25106303)

        * Merge branch 'stable'

2020-11-30 00:09:37 +0100  Vincent Lefevre  <vincent@vinc17.net> (0149944d)

        * Updated Project-Id-Version to 2.0.2.

M	po/fr.po

2020-11-30 00:06:56 +0100  Vincent Lefevre  <vincent@vinc17.net> (679c8184)

        * Updated French translation.

M	po/fr.po

2020-11-25 13:59:55 -0800  Kevin McCarthy  <kevin@8t8.us> (21ebc162)

        * Merge branch 'stable'

2020-11-25 10:24:22 -0800  Kevin McCarthy  <kevin@8t8.us> (239261b5)

        * Surround new and old debug functions with #ifdef DEBUG.
        
        The new function directly references debugfile, so needs the ifdef.
        The old function compiles fine, but since it's not used, put it inside
        the ifdef too.
        
        Thanks to Ian Allen for reporting the problem.

M	lib.c

2020-11-20 09:33:41 -0800  David Champion  <dgc@extrahop.com> (a3011236)

        * add dprintf(n, fmt, ...) debugging macro
        
        dprintf(n, fmt, ...) is a more natural form of
        dprint(n, (debugfile, fmt, ...)). It prints code location in the debug
        file where possible.
        
        I believe this approach, while common, was not previously used because
        we were trying to be C90-compatible.  C90 doesn't provide variadic
        macros.  Now we require C99, so it makes sense to add this pattern.

M	lib.c
M	lib.h

2020-11-23 11:04:08 -0800  Kevin McCarthy  <kevin@8t8.us> (49545f61)

        * Add configure error if C compiler doesn't support C99.
        
        We added the test, but did not check to ensure it was found.  Thanks
        to Oswald Buddenhagen for pointing out the missing check.  He
        suggested the AC_PROG_CC might be redundant, but the info page seems
        to indicate AC_PROG_CC_C99 checks the properties of an already located
        compiler, so I'm leaving AC_PROG_CC in.
        
        Also, remove the $U check just below.  Commit 64b1460a removed the
        call to AM_C_PROTOTYPES, but forgot to remove the $U check too.

M	configure.ac

2020-11-18 15:49:44 -0800  Kevin McCarthy  <kevin@8t8.us> (474d368e)

        * Add <view-pager> function to attachment menu.
        
        This uses a copiousoutput mailcap entry, or falls back to raw text.
        
        The existing functions do not provide a way to use copiousoutput
        mailcap entries exclusively.  The default <view-attach> will use one
        for internally supported types if auto_view is configured, but there
        is no way to do so for other mime types (such as application/pdf).

M	OPS
M	attach.c
M	doc/manual.xml.head
M	functions.h
M	mutt.h
M	recvattach.c

2020-11-19 19:04:52 -0800  David Champion  <dgc@extrahop.com> (03803e67)

        * Allow debugging without debug file rotation.
        
        start_debug() takes a boolean indicating whether to rotate debug
        files.
        
        The -d option allows a negative number. If negative, debug files
        are not rotated. The debug level is the absolute value.
        
        This is useful for continuously watching (e.g. tail -f) the
        .muttdebug0 file.

M	doc/manual.xml.head
M	doc/mutt.man
M	init.c
M	main.c

2020-11-22 20:22:23 +1100  Cameron Simpson  <cs@cskk.id.au> (bb0cd944)

        * mutt.man: -H: clarify that a From_ line in the draft file is silently discarded

M	doc/mutt.man

2020-11-21 14:03:08 -0800  Kevin McCarthy  <kevin@8t8.us> (8c967ad5)

        * Clean up labels in imap_open_connection().
        
        Commit 04b06aaa was purposely kept minimal, to aid backporting the
        fix.  It kept the err_close_conn label, but there is no need for the
        label anymore.  Change all goto's to use the bail label.

M	imap/imap.c

2020-11-20 09:32:41 -0800  Kevin McCarthy  <kevin@8t8.us> (3d362fa2)

        * Merge branch 'stable'

2020-11-19 15:10:48 -0800  Kevin McCarthy  <kevin@8t8.us> (452dee69)

        * Merge branch 'stable'

2020-11-18 14:17:00 -0800  Kevin McCarthy  <kevin@8t8.us> (1fccc7d1)

        * Remove buffer_normalize_fullpath().
        
        This was supposed to normalize a path after relative path expansion.
        However, as Oswald Buddenhagen pointed out just before the release,
        its method of '..' expansion was incorrect with symlinks in play.
        Furthermore, it turned out mutt_pretty_mailbox() deals with '.' and
        '..'.
        
        The function was turned into a noop before the release, and I'm now
        pulling it out.

M	muttlib.c

2020-11-14 13:46:57 -0800  Kevin McCarthy  <kevin@8t8.us> (8dbc3b8d)

        * Merge branch 'stable'

2020-11-10 15:56:44 -0800  Kevin McCarthy  <kevin@8t8.us> (e832240e)

        * Fix IMAP UTF-7 for code points >= U+10000.
        
        The 20-year old utf7 conversion functions punted on those values,
        which was understandable for when they were written.  We now have
        emojis and increasing number of characters that might be used in a
        mailbox.
        
        Add encode/decode logic using UTF-16 surrogate pairs.
        
        Thanks to Jeff Sipek for reporting this issue, and for giving pointers
        about how the values should be handled.

M	imap/utf7.c

2021-05-04 10:50:51 -0700  Kevin McCarthy  <kevin@8t8.us> (23ccbe39)

        * Update UPDATING file for 2.0.7.

M	UPDATING

2021-05-03 13:11:30 -0700  Kevin McCarthy  <kevin@8t8.us> (7c4779ac)

        * Fix seqset iterator when it ends in a comma.
        
        If the seqset ended with a comma, the substr_end marker would be just
        before the trailing nul.  In the next call, the loop to skip the
        marker would iterate right past the end of string too.
        
        The fix is simple: place the substr_end marker and skip past it
        immediately.

M	imap/util.c

2021-04-28 10:59:03 -0700  Kevin McCarthy  <kevin@8t8.us> (e0f4d46b)

        * Filter unprintables for 2231 encoded continuations too.
        
        Changeset de8d8e8f a long time ago added the filter for 2047 and 2231
        encoded values, to prevent strange issues.  However, it looks like it
        missed the case where the value is broken into continuations.  Those
        are assembled and charset converted in rfc2231_join_continuations().
        Add a filter there too.

M	rfc2231.c

2021-04-24 15:20:02 -0700  Kevin McCarthy  <kevin@8t8.us> (8801dfe9)

        * Turn off pylint in gitlab-ci.
        
        It dynamically installs the latest pylint via pip, meaning it can
        start failing arbitrarily.
        
        It also appears to halt the build even on warnings.
        
        Since this is just checking a single contrib script, it's not worth my
        trouble.

M	.gitlab-ci.yml

2021-03-16 14:56:13 -0700  Kevin McCarthy  <kevin@8t8.us> (8eb29a4c)

        * Check if mutt_prepare_template() fails for -H command line arg.
        
        If the function fails, it will free the envelope, leading to a segv
        just below.
        
        Thanks to Phil Pennock for reporting the problem.

M	main.c

2021-03-10 18:31:42 -0800  Kevin McCarthy  <kevin@8t8.us> (dcf1d11f)

        * Fix resolve_types() newline removal and restoration.
        
        If the line had a '\n', the previous code would leave it off.  The
        "buf[nl] = '\n'" at the end of the function was overwriting the old
        nul character, but there was a new one where the original newline was.
        
        However, if there was not a '\n', the code was removing the nul string
        terminator, which could cause very bad things for searches, (which are
        the only things that use fmt after resolve_types).  Since this bug has
        been there for 12 years, I'm guessing the lines always contain a
        trailing '\n'.
        
        Now, there is a potential problem with behavior changes here...  This
        could have an effect on the QuoteRegexp or SearchRE matches.  It turns
        out SearchRE is compiled with REG_NEWLINE, but the other isn't.  Since
        QuoteRegexp is (typically) only looking at the start of a line, I'm
        going to take the risk of restoring the '\n'.

M	pager.c

2021-03-06 11:15:07 -0800  Kevin McCarthy  <kevin@8t8.us> (98f8cb83)

        * automatic post-release commit for mutt-2.0.6

M	ChangeLog
M	VERSION

2021-03-06 11:12:08 -0800  Kevin McCarthy  <kevin@8t8.us> (814f6d20)

        * Update UPDATING file for 2.0.6 release.

M	UPDATING

2021-02-25 14:19:19 -0800  Kevin McCarthy  <kevin@8t8.us> (de51ab4a)

        * Fix (un)setenv to not return an error with unset env vars.
        
        The code was returning -1 in those cases.  This can cause hook
        processors, such as send2-hook, to sleep 1 second without an error
        message being set and displayed.  It also causes the hook processor to
        abort executing subsequent matching commands.
        
        -1 should be reserved for syntax errors.  For setenv querying, change
        the return value to 0.  For unsetenv, generate a message and also
        change the return value to 0.
        
        <enter-command> checks if err->data is set to determine whether to
        print anything, and the behavior is used in the 'set' commands, so
        this is established correct behavior.

M	init.c

2021-02-05 15:34:37 -0800  Kevin McCarthy  <kevin@8t8.us> (0f8a2a13)

        * Save CurrentFolder in background edit scope.
        
        The CurrentFolder can actually be used to resolve an fcc-hook at fcc
        time.  We would want to use the folder they started composing in, to
        be consistent with expectations.

M	doc/manual.xml.head
M	send.c
M	send.h

2021-02-07 19:41:21 -0800  Kevin McCarthy  <kevin@8t8.us> (564b515c)

        * Fix pattern compilation error for ~( !~>(~P) )
        
        The problem is a nested recursive call followed by trailing
        whitespace.  Other codepaths ensure trailng whitespaces are processed
        when processing the argument, but the parenthesis calls did not.
        
        This meant the outer loop while check:
          while (*ps.dptr)
          {
            SKIPWS (ps.dptr);
            switch (*ps.dptr)
            {
              /* process (~P), for instance */
            }
          }
        would return true for the trailing space(s), the SKIPWS would skip
        over them, and then switch would try to evaluate '\0'.
        
        I think a better solution would be to rearrange the calls like:
          SKIPWS (ps.dptr);
          while (*ps.dptr)
          {
            switch (*ps.dptr)
            {
            }
            SKIPWS(ps.dptr);
          }
        to ensure any trailing whitespace is removed.
        
        However, that's a bit risky for a stable branch commit.  So instead,
        just explicitly add the SKIPWS for the ~() thread ops and for the ()
        groupings after processing the inside expression.

M	pattern.c

2021-02-02 12:47:24 -0800  Kevin McCarthy  <kevin@8t8.us> (ca272c39)

        * Fix contrib/markdown2html crash.
        
        The script crashes if the last line in the message ends with a colon.
        
        Thanks to Aitor Soroa (@asoroa) for the bug report and patch!

M	contrib/markdown2html

2021-01-27 14:55:35 -0800  Kevin McCarthy  <kevin@8t8.us> (6df1891b)

        * Fix another yesorno prompt, for autocrypt account creation.
        
        I seem to have trouble remembering that ctrl-g is one of the
        choices. :-(
        
        There is yet another autocrypt prompt for "enabling prefer-encryption"
        that *could* abort on ctrl-g.  But, since it's not really an "action"
        prompt, I'm keeping that one as a "no on ctrl-g".

M	autocrypt/autocrypt_gpgme.c

2021-01-27 09:31:58 +0100  Christopher Zimmermann  <madroach@gmerlin.de> (2342b4d1)

        * Correctly handle CTRL-G on remaining background_edit sessions prompt

M	curs_lib.c
M	curs_main.c

2021-01-21 12:31:43 -0800  Kevin McCarthy  <kevin@8t8.us> (da5e3282)

        * automatic post-release commit for mutt-2.0.5

M	ChangeLog
M	VERSION

2021-01-21 12:27:50 -0800  Kevin McCarthy  <kevin@8t8.us> (dd66f4ae)

        * Update UPDATING file for 2.0.5.

M	UPDATING

2021-01-17 10:40:37 -0800  Kevin McCarthy  <kevin@8t8.us> (4a2becbd)

        * Fix memory leak parsing group addresses without a display name.
        
        When there was a group address terminator with no previous
        addresses (including the group display-name), an address would be
        allocated but not attached to the address list.
        
        Change this to only allocate when last exists.
        
        It would be more correct to not allocate at all unless we are inside a
        group list, but I will address that in a separate commit to master.

M	rfc822.c

2020-12-01 14:21:31 -0800  Kevin McCarthy  <kevin@8t8.us> (464a9bc6)

        * Fix memory leak in imap_copy_messages().
        
        mx.mbox (allocated by imap_parse_path) was not always freed before
        return.
        
        The sync_cmd and cmd buffers were also not always freed.  One case was
        on retrying after creating the mailbox, which would overwrite the
        allocated pointers.
        
        As long as I'm touching the buffers, convert them to use the buffer
        pool.  I think the mutt_buffer_clear() at the beginning of the retry
        loop isn't necessary, but will keep it to make it clear any existing
        values won't be reused a second time through the loop.

M	imap/message.c

2021-01-13 19:06:49 -0800  Kevin McCarthy  <kevin@8t8.us> (b40c7f6c)

        * Fix imap memory leaks.
        
        The mx.mbox allocated by imap_parse_path() was not freed on error in a
        couple places.
        
        There is also a leak in imap_copy_message(), but this was fixed in
        master in commit 1ec642e2.  I'll cherry pick that into stable.

M	imap/imap.c

2021-01-08 19:04:18 -0800  Kevin McCarthy  <kevin@8t8.us> (b67ae9ce)

        * Fix color overlay when HAVE_COLOR is unset.
        
        mutt_merge_colors() and mutt_attrset_cursor() were not defined in that
        case, but are called in the menu and sidebar.
        
        Change mutt_merge_colors() to just combine attributes in that case.

M	color.c

2020-12-30 14:23:18 -0800  Kevin McCarthy  <kevin@8t8.us> (26f41dd1)

        * automatic post-release commit for mutt-2.0.4

M	ChangeLog
M	UPDATING
M	VERSION

2020-12-30 14:15:08 -0800  Kevin McCarthy  <kevin@8t8.us> (5cc62090)

        * Bump copyright notices.
        
        I'll run the update tool on source files in master a bit later.

M	COPYRIGHT
M	doc/manual.xml.head
M	doc/mutt.man
M	main.c

2020-12-29 13:13:09 -0800  Kevin McCarthy  <kevin@8t8.us> (b23f900b)

        * Fix smtp debug segfault on invalid SmtpAuthenticators list.
        
        sasl_client_start() sets the mech parameter only on success.  dprint()
        the whole mechlist on failure.

M	smtp.c

2020-12-24 15:33:57 -0800  Kevin McCarthy  <kevin@8t8.us> (48d08860)

        * Fix header cache BDB version checking.
        
        Update BDB versions up to 6.2.
        
        The scheme used here is, as Oswald nicely puts it, "totally insane",
        and seems to come straight from the initial header cache commit in
        c11667eaa3.
        
        For a stable release, I'm just going to add a few more Jenga pieces to
        the top.
        
        However, going forward this is unmaintainable.  Oswald reports using a
        simple check for "db.h" and "-ldb" for about two decades with no
        issues.  I will make that change in master later this week.

M	configure.ac

2020-12-21 15:30:01 -0800  Kevin McCarthy  <kevin@8t8.us> (11b18027)

        * Fix offset to use LOFF_T in a couple places.
        
        The BODY->hdr_offset was incorrectly of type long, which could result
        in corrupted >2gb mbox files in some circumstances.
        
        The uses in mh_rewrite_message() are not as serious, but they should
        still be of type LOFF_T.
        
        I found both of these fixes in a patch file,
        bug-676388-largefile.patch, in the openSUSE mutt src rpm.  It looks
        like Harald Koenig was the original author of a larger patch in that
        openSUSE ticket, which was reduced over time as fixes were made to
        Mutt.
        
        Note that patch file also incorrectly adjusted old_hdr_lines in mh.c.
        I've removed that part, as HEADER->lines is type int.
        
        Unfortunately, the BODY->hdr_offset type change will result in a
        header cache change (i.e. invalidation).  I'm not enthused about doing
        that during a stable release, but the change is important enough to
        merit it.

M	mh.c
M	mutt.h

2020-12-07 14:47:22 -0800  Kevin McCarthy  <kevin@8t8.us> (a7b839e5)

        * Ensure idata->check_status is cleared on mailbox close.
        
        I don't think this would cause any issues, but it should be cleared
        here in any case.

M	imap/imap.c

2020-12-07 13:03:41 -0800  Kevin McCarthy  <kevin@8t8.us> (b5ef1155)

        * Abort IMAP open if condstore/qresync updates fetch fails.
        
        An error in imap_cmd_step() was not being properly returned to the
        caller.

M	imap/message.c

2020-12-04 10:54:21 -0800  Kevin McCarthy  <kevin@8t8.us> (a51f058f)

        * automatic post-release commit for mutt-2.0.3

M	ChangeLog
M	VERSION

2020-12-04 10:48:04 -0800  Kevin McCarthy  <kevin@8t8.us> (c6f114f8)

        * Update UPDATING file for 2.0.3 release.

M	UPDATING

2020-12-02 13:03:06 -0800  Kevin McCarthy  <kevin@8t8.us> (3ba8dac0)

        * Fix pager dropped input on SigWinch flag handling.
        
        The code to process the SigWinch flag ocurred after, and would drop an
        input character when the flag was set outside of, km_dokey().  This
        could happen, for instance, when a pipe operation was invoked.
        
        Thanks to Vincent Lefèvre for uncovering the problem.

M	pager.c

2020-11-30 15:53:49 -0800  Kevin McCarthy  <kevin@8t8.us> (f420be68)

        * Ensure mutt_extract_token() never returns a NULL dest->data.
        
        Commit e5a32a61 removed a 'mutt_buffer_addch (dest, 0)' at the end of
        the function.  Most callers had been converted to use the buffer pool,
        and the call was strange since buffers self-terminate.
        
        However, this line covered up logic errors in some of the callers,
        which assumed the buffer->data could not be NULL afterwards.
        
        I will try to fix up callers with the logic errors in master.  This is
        to fix the problem in stable, and also ensure future callers don't
        make the same mistake.

M	init.c

2020-11-29 13:44:30 -0800  Kevin McCarthy  <kevin@8t8.us> (cfdcfa7f)

        * Fix REPLY_TO environment variable handling.
        
        Commit 4e153adf changed this code to reuse the function buffer
        variable, but forgot to rewind the buffer for parsing in
        parse_my_hdr().
        
        Additionally commit e5a32a61 removed an extra "null termination"
        mutt_buffer_addch() at the end of mutt_extract_token().  This caused a
        NULL value to be passed to the strpbrk() in parse_my_hdr(), causing a
        segv.  Change to use a buffer pool token parameter instead.
        
        I actually think, like with the previous IMAP mailbox handling, this
        method of adding a my_hdr is dangerous.  I'll look into refactoring it
        in master instead.
        
        Thanks to Paul Nevai for reporting the problem and tracking down the
        backtrace.

M	init.c

2020-11-29 10:48:22 -0800  Kevin McCarthy  <kevin@8t8.us> (dbdf481c)

        * Fix undefined NULL pointer arithmetic.
        
        clang 10 is giving a warning about arithmetic with a NULL pointer.  To
        prevent any problems, add checks in the BUFFER increase-size handling
        functions.

M	buffer.c

2020-11-25 13:46:47 -0800  Kevin McCarthy  <kevin@8t8.us> (9109eff8)

        * Fix exact-address recording of last value.
        
        If the last address was also terminated by a comma (e.g: foo@local,
        bar@local,) the exact-address was incorrectly overwriting the recorded
        value.

M	rfc822.c

2020-11-24 12:54:00 -0800  Kevin McCarthy  <kevin@8t8.us> (d73a83f7)

        * Fix exact-address handling when addr->personal is set.
        
        The exact-address compile-time option takes an exact copy of an
        address when it is parsed, and prints that out when outputting the
        address.  The idea is to preserve older "user@host (Name)" syntax.
        
        Unfortunately, when code tries to "update" the personal/name field, it
        needs to clear the exact-address copy for it to have any effect.
        
        An object-oriented design encapsulating the setting would help prevent
        this problem.  It might be desirable to create a C function instead,
        but callers would have to remember it, and such a thing isn't common
        in the Mutt codebase.
        
        Another patch (I'm still debating applying) changes the address parser
        to discard the exact-address copy when it exactly matches the
        mailbox.  However, that still won't fix every case (and it makes the
        parser even more difficult to follow.)
        
        So this commit (to stable) takes the straightforward approach.
        
        It fixes bugs in:
        
        * Alias creation.  The "personal name" prompt was ignored.
        
        * Autocrypt initialization from address setting with $realname.
        
        * $pgp_getkeys_command handling.
        
        * Query menu results.
        
        * "unset $reverse_realname" handling.
        
        * $from handling of $realname.
        
        * Bounce Resent-From handling of $realname.

M	alias.c
M	autocrypt/autocrypt.c
M	pgpinvoke.c
M	query.c
M	send.c
M	sendlib.c

2020-11-20 09:23:29 -0800  Kevin McCarthy  <kevin@8t8.us> (d9268908)

        * automatic post-release commit for mutt-2.0.2

M	ChangeLog
M	VERSION

2020-11-20 09:20:01 -0800  Kevin McCarthy  <kevin@8t8.us> (e4fd9247)

        * Update UPDATING file for 2.0.2.

M	UPDATING

2020-11-16 10:20:21 -0800  Kevin McCarthy  <kevin@8t8.us> (04b06aaa)

        * Ensure IMAP connection is closed after a connection error.
        
        During connection, if the server provided an illegal initial response,
        Mutt "bailed", but did not actually close the connection.  The calling
        code unfortunately relied on the connection status to decide to
        continue with authentication, instead of checking the "bail" return
        value.
        
        This could result in authentication credentials being sent over an
        unencrypted connection, without $ssl_force_tls being consulted.
        
        Fix this by strictly closing the connection on any invalid response
        during connection.  The fix is intentionally small, to ease
        backporting.  A better fix would include removing the 'err_close_conn'
        label, and perhaps adding return value checking in the caller (though
        this change obviates the need for that).
        
        This addresses CVE-2020-28896.  Thanks to Gabriel Salles-Loustau for
        reporting the problem, and providing test cases to reproduce.

M	imap/imap.c

2020-11-19 15:06:51 -0800  Keld Simonsen  <keld@keldix.com> (d4c97068)

        * Updated Danish translation.

M	po/da.po

2020-11-14 13:16:03 -0800  Kevin McCarthy  <kevin@8t8.us> (42e08237)

        * automatic post-release commit for mutt-2.0.1

M	ChangeLog
M	VERSION

2020-11-14 13:10:45 -0800  Kevin McCarthy  <kevin@8t8.us> (78fe7d4e)

        * Update UPDATING file for 2.0.1.

M	UPDATING

2020-11-12 09:42:28 -0800  Kevin McCarthy  <kevin@8t8.us> (894a49f6)

        * Clarify pattern completion uses <complete>.
        
        Some users may have bound tab to another function, so be specific.

M	UPDATING

2020-11-09 10:59:44 +0100  Remco Rĳnders  <remco@webconquest.com> (86d64caa)

        * Consistently use uint32_t (closes #294)

M	hcache.c
M	mutt_random.c

2020-11-07 12:18:03 -0800  Kevin McCarthy  <kevin@8t8.us> (3d08634b)

        * automatic post-release commit for mutt-2.0.0

M	ChangeLog
M	VERSION
M	po/bg.po
M	po/ca.po
M	po/cs.po
M	po/da.po
M	po/de.po
M	po/el.po
M	po/eo.po
M	po/es.po
M	po/et.po
M	po/eu.po
M	po/fi.po
M	po/fr.po
M	po/ga.po
M	po/gl.po
M	po/hu.po
M	po/id.po
M	po/it.po
M	po/ja.po
M	po/ko.po
M	po/lt.po
M	po/nl.po
M	po/pl.po
M	po/pt_BR.po
M	po/ru.po
M	po/sk.po
M	po/sv.po
M	po/tr.po
M	po/uk.po
M	po/zh_CN.po
M	po/zh_TW.po

2020-11-07 11:30:13 -0800  Kevin McCarthy  <kevin@8t8.us> (0c8f4357)

        * Add missing new header files to EXTRA_mutt_SOURCES.
        
        I forgot to add the mutt_lisp.h and mutt_random.h files there.

M	Makefile.am

2020-11-07 11:01:47 -0800  Kevin McCarthy  <kevin@8t8.us> (a374cea8)

        * Update UPDATING file for 2.0.

M	UPDATING

2020-11-06 14:31:57 -0800  Vsevolod Volkov  <vvv@mutt.org.ua> (3e9c605d)

        * Updated Russian translation.

M	po/ru.po

2020-11-06 14:29:11 -0800  Vsevolod Volkov  <vvv@mutt.org.ua> (3317883a)

        * Updated Ukrainian translation.

M	po/uk.po

2020-11-06 14:26:09 -0800  Ivan Vilata i Balaguer  <ivan@selidor.net> (32fcad9f)

        * Updated Catalan translation.

M	po/ca.po

2020-11-06 14:02:49 -0800  Kevin McCarthy  <kevin@8t8.us> (f5aa9382)

        * Disable normalization after expand_path().
        
        The algorithm used was incorrect, for '..' expansion with symlinks
        involved.  Furthermore, mutt_pretty_mailbox() takes care of this for
        us.
        
        To be conservative, just before the release, I'm leaving the function
        but converting it to a noop.  I'll pull the function out after the
        release.
        
        Thanks to Oswald Buddenhagen for pointing out the bug!

M	muttlib.c

2020-11-06 13:18:27 -0800  Kevin McCarthy  <kevin@8t8.us> (6704caf4)

        * Don't relative-path expand for fcc-hook and save-hook.
        
        "fcc-hook ~x. \\^" used to work, because mutt_addr_hook() calls
        mutt_make_string(), which performs backslash expansion.
        
        The same would happen for save-hook.
        
        Many thanks to Oswald Buddenhagen for reporting the issue.

M	hook.c
M	muttlib.c
M	protos.h

2020-11-04 23:01:55 +0100  Grzegorz Szymaszek  <gszymaszek@short.pl> (533c38f4)

        * Fix the Polish translation of “Attachments”
        
        I have misunderstood the “Atts” abbreviation for “Attributes”, while it
        actually means “Attachments”.

M	po/pl.po

2020-11-04 20:15:52 +0100  Grzegorz Szymaszek  <gszymaszek@short.pl> (cdc99643)

        * Update the Polish translation for Mutt 2.0

M	po/pl.po

2020-11-03 16:50:23 +0100  Flammie Pirinen  <tommi.pirinen@uit.no> (f26731fa)

        * updated finnish translation

M	po/fi.po

2020-11-03 07:11:00 -0800  Kevin McCarthy  <kevin@8t8.us> (e677c196)

        * Minor fix to UPDATING file.

M	UPDATING

2020-10-31 15:35:53 +0100  Petr Písař  <petr.pisar@atlas.cz> (d752a64c)

        * Czech translation updated for 2.0

M	po/cs.po

2020-10-29 14:46:30 -0400  Remco Rĳnders  <remco@webconquest.com> (f6fb0ca9)

        * Adjust Makefile.am to exclude BEWARE file

M	Makefile.am

2020-10-29 14:24:08 -0400  Remco Rĳnders  <remco@webconquest.com> (37a1950a)

        * Move contents from BEWARE to devel-notes.txt

D	BEWARE
M	doc/devel-notes.txt

2020-10-29 13:59:13 -0400  Remco Rĳnders  <remco@webconquest.com> (4fa19ba4)

        * Change instructions to subscribe to dev mail list

M	doc/devel-notes.txt

2020-10-25 15:07:55 -0700  Kevin McCarthy  <kevin@8t8.us> (9258922a)

        * Add a more explicit mention of ^G in the manual.
        
        It's a FAQ, so I think is worth emphasizing in the "getting started"
        section.

M	doc/manual.xml.head

2020-10-25 20:49:22 +0100  Christopher Zimmermann  <madroach@gmerlin.de> (cafe0fb5)

        * Allow to abort on question about multipart/alternative

M	send.c

2020-10-24 09:13:19 -0400  Remco Rĳnders  <remco@webconquest.com> (63e8ba68)

        * Updated Dutch translation.

M	po/nl.po

2020-10-23 15:50:06 -0700  Emir Sarı  <bitigchi@me.com> (d8bbd22c)

        * Update Turkish translations.

M	po/tr.po

2020-10-23 19:10:58 +0200  Olaf Hering  <olaf@aepfle.de> (18a07d14)

        * refresh de.po
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	po/de.po

2020-10-22 19:41:14 -0700  Kevin McCarthy  <kevin@8t8.us> (e1089b5e)

        * Remove obsolete stamp-h.in.
        
        This file was used a long time ago (pre-1.0) when Makefile.in was
        checked in.
        
        We now generate Makefile.in from Makefile.am, and automake appears to
        use a different mechanism of time-stamping, using stamp-h + $counter.

D	stamp-h.in

2020-10-17 18:55:27 -0700  Kevin McCarthy  <kevin@8t8.us> (1036f0ed)

        * Add an initial change list for 2.0.0 to the UPDATING file.

M	UPDATING

2020-10-17 18:54:52 -0700  Kevin McCarthy  <kevin@8t8.us> (47fa1503)

        * Add the mailboxes history category to the manual.

M	doc/manual.xml.head

2020-10-14 14:29:27 +0200  Philipp Klaus Krause  <pkk@spth.de> (36640a88)

        * Since the string from strerror should never be modified, use const.

M	curs_lib.c

2020-10-12 15:34:44 -0700  Kevin McCarthy  <kevin@8t8.us> (1061dcbc)

        * Create $attach_save_dir.
        
        This will be used when saving attachments via
        mutt_save_attachment_list().
        
        Try to create the directory if it doesn't exist.  If we're unable to
        chdir or create the directory just continue on, using cwd.

M	globals.h
M	init.h
M	recvattach.c

2020-10-09 09:20:11 -0700  Kevin McCarthy  <kevin@8t8.us> (f8263764)

        * Fix mutt_oauth.py.README example.
        
        $imap_authenticators should be colon delimited.

M	contrib/mutt_oauth2.py.README

2020-10-06 13:39:55 +1100  Cameron Simpson  <cs@cskk.id.au> (0241b030)

        * doc/manual.xml.head: Most common mail sending keys: replace "compose" with "mail", incorrect function name

M	doc/manual.xml.head

2020-10-03 15:43:06 -0700  Kevin McCarthy  <kevin@8t8.us> (489ade5c)

        * Move MuttLisp example descriptions before the code.

M	doc/manual.xml.head

2020-10-01 13:33:55 -0700  Kevin McCarthy  <kevin@8t8.us> (ed9303a8)

        * More ansi/special cleanup.
        
        Relocate the checks for a->attr and special around the blocks that use
        them.

M	pager.c

2020-09-30 09:49:17 -0700  Kevin McCarthy  <kevin@8t8.us> (65b1ceab)

        * Don't do ansi coloring on a search result.

M	pager.c

2020-09-29 18:46:27 -0700  Kevin McCarthy  <kevin@8t8.us> (73a7bf2c)

        * Don't free and reuse ansi colors.
        
        You can't reallocate a color-pair to another color while the previous
        one is still on the screen.
        
        Since there are at most 64 ansi-color combinations, just let them
        accumulate.

M	pager.c

2020-09-29 14:20:24 -0700  Kevin McCarthy  <kevin@8t8.us> (a3a4d12f)

        * Fix $allow_ansi end-of-line handling for attachments.
        
        Attachment viewing doesn't set MUTT_SHOWCOLOR, but for proper display
        we need to call resolve_color() before clearing to end-of-line.

M	pager.c

2020-09-29 14:17:27 -0700  Kevin McCarthy  <kevin@8t8.us> (15372907)

        * Separate special color setting from $allow_ansi colors.
        
        The ColorDefs for MT_COLOR_BOLD and MT_COLOR_UNDERLINE should only be
        applied for the special formatting.  They shouldn't apply when
        $allow_ansi has a bold/underline sequence.
        
        Change the exclusive or operator to a regular or.  Exclusive or
        implies we are doing some kind of toggling, which we are not in this
        case.  It just confuses things.
        
        Don't make the ansi underline, reverse, and blink mutually exclusive.

M	pager.c

2020-09-23 11:08:03 -0700  Kevin McCarthy  <kevin@8t8.us> (b0ccf259)

        * Delay $hostname setting until after the muttrc is evaluated.
        
        Commit 5c5c34f2 made back in 1.6 changed Fqdn setting to use
        gethostname() and getaddrinfo() to get the canonical domain.  This is
        more accurate but can cause startup delays for systems where the DNS
        resolution is not set up properly.
        
        Because this occurred before muttrc reading, there was no workaround
        except to "fix DNS".
        
        Change Fqdn ($hostname) setting to occur after the muttrc and '-e'
        argument processing occur.
        
        This is a possible breaking change if users rely on $hostname inside
        their muttrc, for example 'source "muttrc.$hostname"'.  The workaround
        would be to put something like (depending on the system type): 'set
        hostname = `hostname --fqdn`' in the muttrc above that invocation.
        
        Also note that we still set Hostname (the internal variable) early,
        because it is used in more places than Fqdn, such as tempfiles.

M	init.c
M	init.h

2020-09-22 11:17:07 -0700  Kevin McCarthy  <kevin@8t8.us> (8a2fc801)

        * Note that $cursor_overlay affects tree colors too.
        
        Change the font on "default" to indicate that actual value allows for
        color overlays between the layers.

M	init.h

2020-09-20 18:46:48 -0700  Kevin McCarthy  <kevin@8t8.us> (9204b24e)

        * Reenable $ssl_force_tls.
        
        The next release will be 2.0, providing more justification for
        (reasonable) breaking changes.  In 2020, this should be the default.
        
        The documentation seems to already make appropriate warnings about
        $tunnel_is_secure.  Since that option is introduced this release,
        there is no need to worry about existing users with it unset.
        
        However, there were a couple stray double-quotes in the documentation
        for that, so clean those up in this commit.

M	doc/manual.xml.head
M	init.h

2020-09-19 15:31:36 -0700  Kevin McCarthy  <kevin@8t8.us> (2ce2fb7b)

        * Add refresh option to smime_keys man page.

M	doc/smime_keys.man

2020-09-18 09:39:18 -0700  Kevin McCarthy  <kevin@8t8.us> (34ba89ec)

        * Add missing full stops in smime_keys.man page.
        
        Thanks to hmartink and the manpage-l10n project for pointing out the
        issues.

M	doc/smime_keys.man

2020-09-16 09:44:07 -0700  Kevin McCarthy  <kevin@8t8.us> (e91313b8)

        * Remove casts for mutt_random_bytes() argument.
        
        Unneeded casts can hide issues later on, so take them out.

M	mutt_random.c
M	muttlib.c
M	sendlib.c

2020-09-15 14:32:19 -0700  Kevin McCarthy  <kevin@8t8.us> (ee2b9d1d)

        * Remove message-id security leaks section of manual.
        
        The message-id generator has been changed to use a combination of time
        and random components for the left side.

M	doc/manual.xml.head

2020-09-08 14:05:49 -0400  Remco Rĳnders  <remco@webconquest.com> (9da4e6e1)

        * Change Message-ID to be more unique and leak less information
        
        A Message-ID should be globally unique. Currently mutt generates this ID
        based on the current date and time, followed by ".G", followed by a letter
        A to Z (A for the 1st and 27th email sent, Z for the 26th, etc.), followed
        by the pid of the active mutt process, followed by "@" and the configured
        fqdn.
        
        This can lead to information being leaked as to an users email habits and
        activities, which might be undesirable.
        
        By replacing everything left of the "@" in the Message-ID with a Base64
        encoded timestamp and 64 bits of randomness, we no longer include this
        information.

M	sendlib.c

2020-08-31 13:48:51 -0400  Remco Rĳnders  <remco@webconquest.com> (b48233f7)

        * Use PRIu64 macro as format when printing uint64_t values

M	muttlib.c

2020-08-31 13:10:25 -0400  Remco Rĳnders  <remco@webconquest.com> (8ccd96db)

        * Implement LFRS113 PRNG functions
        
        - Instead of relying on random() implementations which can be of
        questionable quality or relying on the presence of /dev/urandom, we
        implement our own PRNG implementation that uses the LFRS113 PRNG algorithm
        by Pierre L'Ecuyer.
        
        We seed this PRNG with values based on time, pid and ppid. It is OK if not
        all seeds are of the highest quality as all four seeds would have to be
        known to predict the numbers generated. In addition to this, we also use
        /dev/urandom values (if available) that we mix into our four seeds.
        
        In case we are reseeding we will also reuse our existing state information
        for setting the new seed values.
        
        - Add a function to Base64 encode 96 random bits

M	Makefile.am
M	init.c
A	mutt_random.c
A	mutt_random.h
M	muttlib.c
M	sendlib.c

2020-09-13 00:05:22 +0100  isdtor  <isdtor@gmail.com> (56de020a)

        * Add note about $smime_default_key to use with GPGME.
        
        When using GPGME for S/MIME, the key id used should be the id
        displayed by "gpgsm --list-keys".

M	init.h

2020-09-06 15:39:07 -0700  Kevin McCarthy  <kevin@8t8.us> (4219d5f9)

        * Block signals during mbox-append operation.
        
        I first noticed this back in 2017, but no one replied to my query to
        mutt-dev and I forgot about it too.
        
        Thanks to Oswald Buddenhagen for the followup when he was going
        through the mailing list archives, confirming the mistake.
        
        I've also reviewed MUTT_APPEND and MUTT_NEWFOLDER uses to make sure
        the context is properly closed (and the signals restored).

M	mbox.c

2020-09-05 15:15:40 -0700  Kevin McCarthy  <kevin@8t8.us> (7157d009)

        * Removed unused mutt_expand_path()
        
        All usages now call mutt_buffer_expand_path().

M	muttlib.c
M	protos.h

2020-09-05 15:11:59 -0700  Kevin McCarthy  <kevin@8t8.us> (d76aebd2)

        * Convert _mutt_enter_string() to use buffer expand_path function.
        
        This is the last usage of mutt_expand_path().  Converting all of
        _mutt_enter_string() is a large project, so instead just localize to
        use a BUFFER for the mutt_expand_path() call.

M	enter.c

2020-09-05 14:10:18 -0700  Kevin McCarthy  <kevin@8t8.us> (4a2f1067)

        * Remove unused mutt_quote_filename().
        
        All callers now call the buffer function instead.

M	lib.c
M	lib.h

2020-09-04 19:46:02 -0700  Kevin McCarthy  <kevin@8t8.us> (bf68f089)

        * Convert mutt_create_alias and helpers to use buffer pool.
        
        This is working towards removing a few of the partially converted path
        functions, such as mutt_expand_path().

M	alias.c
M	protos.h

2020-09-06 23:21:15 +0200  Olaf Hering  <olaf@aepfle.de> (2d9c05c9)

        * Fix typos in de.po
        
        Signed-off-by: Olaf Hering <olaf@aepfle.de>

M	po/de.po

2020-09-04 14:16:21 -0700  Kevin McCarthy  <kevin@8t8.us> (c4fe5624)

        * Use muttmua ubuntu image for shellcheck.

M	.gitlab-ci.yml

2020-09-04 14:11:55 -0700  Kevin McCarthy  <kevin@8t8.us> (0f97dd3a)

        * Turn off shellcheck unused var warning for doc/instdoc.sh.

M	doc/instdoc.sh.in

2020-08-30 13:26:29 -0700  Kevin McCarthy  <kevin@8t8.us> (7ae6d9aa)

        * Disable relative expansion for signature and source pipes.
        
        Relative expansion shouldn't be performed when those values are to be
        executed as a pipe for the output.
        
        I believe this issue only affects $signature and the source command,
        so for now I'm disabling relative expansion for those two cases.  If
        there is too much more breakage, I will consider backing out the
        relative expansion and disabling the :cd command.
        
        Thanks to Aaron Schrab for reporting this issue.

M	init.c

2020-08-28 15:51:55 -0700  Kevin McCarthy  <kevin@8t8.us> (2ba1d11f)

        * Normalize expanded paths with '.' or '..' in them.
        
        This usage is not too likely, but to prevent strange looking mailbox
        paths, make sure the path is normalized after being expanded.

M	muttlib.c

2020-07-29 13:44:17 -0700  Kevin McCarthy  <kevin@8t8.us> (6fc79323)

        * Remove relative path expansion for some cases.
        
        Some paths, such as the folder browser, or certain hook values,
        should be expanded for shortcuts, but not for relative paths.
        
        Configuration variables that hold commands that search by PATH should
        also not be expanded.
        
        Create a separate call, and a separate data type for config vars.

M	browser.c
M	commands.c
M	doc/makedoc.pl
M	hook.c
M	init.c
M	init.h
M	muttlib.c
M	protos.h
M	recvattach.c

2020-07-26 19:10:57 -0700  Kevin McCarthy  <kevin@8t8.us> (0f455d51)

        * Change expand_path() to expand relative paths.
        
        The introduction of the "cd" command can make relative paths
        unreliable.  Change expand_path() to expand relative paths.
        
        Change pretty_mailbox() to contract relative paths, but only when the
        folder is outside of homedir, or when cwd is underneath the homedir.
        
        To try and keep the sidebar from changing, use the pretty_mailbox code
        to contract relative paths only.

M	muttlib.c
M	sidebar.c

2020-08-29 12:30:18 -0700  Kevin McCarthy  <kevin@8t8.us> (092bc204)

        * Merge branch 'stable' into master

2020-08-29 12:29:50 -0700  Kevin McCarthy  <kevin@8t8.us> (f34d0909)

        * automatic post-release commit for mutt-1.14.7

M	ChangeLog
M	VERSION

2020-08-27 15:11:25 -0700  Kevin McCarthy  <kevin@8t8.us> (55c09cfb)

        * Merge branch 'stable' into master

2020-08-25 12:29:14 -0400  Remco Rĳnders  <remco@webconquest.com> (20165b4e)

        * Remove always true conditional (#if 1)

M	main.c

2020-08-25 12:23:37 -0400  Remco Rĳnders  <remco@webconquest.com> (9ef96f1f)

        * Remove always true conditional (#if 1)

M	strcasestr.c

2020-08-25 12:16:52 -0400  Remco Rĳnders  <remco@webconquest.com> (ae3014e9)

        * Make returns after mx_fastclose_mailbox calls more consistent and cleaner

M	mx.c

2020-08-25 12:14:33 -0400  Remco Rĳnders  <remco@webconquest.com> (97398c4f)

        * Remove always true conditional (#if 1)

M	imap/imap.c

2020-08-22 07:43:15 -0700  William Yardley  <wyardley@users.noreply.github.com> (3f856d11)

        * refactor: update shell scripts for shellcheck warnings
        
        This updates shell scripts in the project to resolve shellcheck lint
        warnings.
        
        A couple of warnings are ignored instead, at least for now.

M	check_sec.sh
M	contrib/bgedit-detectgui.sh
M	contrib/iconv/make.sh
M	gen_defs
M	txt2c.sh

2020-08-24 12:12:39 -0700  William Yardley  <wyardley@users.noreply.github.com> (6f4c0f7a)

        * gen_defs: switch from $(()) to expr
        
        For greater compatibility with Solaris's Bourne shell, switch to "expr" for
        numeric evaluation

M	gen_defs

